
_USB_CDC_Bytes_Received:

;USB_CDC_Library.mpas,423 :: 		begin
;USB_CDC_Library.mpas,424 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library.mpas,425 :: 		Result := 0;
	CLRF        R1 
;USB_CDC_Library.mpas,426 :: 		if (BDEP3OUTStat.UOWN = 0)
	BTFSC       1048, 7 
	GOTO        L__USB_CDC_Bytes_Received2
;USB_CDC_Library.mpas,427 :: 		then Result := BDEP3OUTCnt;
	MOVF        1049, 0 
	MOVWF       R1 
L__USB_CDC_Bytes_Received2:
;USB_CDC_Library.mpas,428 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library.mpas,429 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_USB_CDC_Bytes_Received:
	RETURN      0
; end of _USB_CDC_Bytes_Received

_USB_CDC_Read:

;USB_CDC_Library.mpas,434 :: 		begin
;USB_CDC_Library.mpas,435 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library.mpas,436 :: 		Result := 0; // no bytes read
	CLRF        USB_CDC_Read_local_result+0 
;USB_CDC_Library.mpas,438 :: 		if (BDEP3OUTStat.UOWN = 0) then  // PIC owns the buffer
	BTFSC       1048, 7 
	GOTO        L__USB_CDC_Read6
;USB_CDC_Library.mpas,440 :: 		ByteCount := BDEP3OUTCnt;      // get bytecount of EP3 out buffer
	MOVF        1049, 0 
	MOVWF       USB_CDC_Read_ByteCount+0 
;USB_CDC_Library.mpas,441 :: 		SrcPtr := ^byte(BDEP3OUTAdr);  // Source data pointer
	MOVF        1050, 0 
	MOVWF       USB_CDC_Read_SrcPtr+0 
	MOVF        1051, 0 
	MOVWF       USB_CDC_Read_SrcPtr+1 
;USB_CDC_Library.mpas,443 :: 		if ByteCount > MaxLen then ByteCount := MaxLen;
	MOVF        USB_CDC_Read_ByteCount+0, 0 
	SUBWF       FARG_USB_CDC_Read_MaxLen+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_CDC_Read9
	MOVF        FARG_USB_CDC_Read_MaxLen+0, 0 
	MOVWF       USB_CDC_Read_ByteCount+0 
L__USB_CDC_Read9:
;USB_CDC_Library.mpas,444 :: 		Result := ByteCount;
	MOVF        USB_CDC_Read_ByteCount+0, 0 
	MOVWF       USB_CDC_Read_local_result+0 
;USB_CDC_Library.mpas,446 :: 		if ByteCount > 0 then       // non empty
	MOVF        USB_CDC_Read_ByteCount+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_CDC_Read12
;USB_CDC_Library.mpas,448 :: 		memcpy(DstPtr, SrcPtr, ByteCount);
	MOVF        FARG_USB_CDC_Read_DstPtr+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        FARG_USB_CDC_Read_DstPtr+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        USB_CDC_Read_SrcPtr+0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        USB_CDC_Read_SrcPtr+1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVF        USB_CDC_Read_ByteCount+0, 0 
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;USB_CDC_Library.mpas,449 :: 		end;
L__USB_CDC_Read12:
;USB_CDC_Library.mpas,452 :: 		BDEP3OUTCnt  := USB_CDC_BULK_OUT_EP_SIZE;     // bytecount
	MOVLW       64
	MOVWF       1049 
;USB_CDC_Library.mpas,453 :: 		BDEP3OUTAdr  := word(@BuffEP3OUT);            // buffer address
	MOVLW       USB_CDC_Library_BuffEP3OUT+0
	MOVWF       1050 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP3OUT+0)
	MOVWF       1051 
;USB_CDC_Library.mpas,454 :: 		BDEP3OUTStat := BDEP3OUTStat and USB_DTSMASK; // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1048, 1 
;USB_CDC_Library.mpas,455 :: 		BDEP3OUTStat := BDEP3OUTStat xor USB_DTSMASK; // toggle data 0/1
	BTG         1048, 6 
;USB_CDC_Library.mpas,456 :: 		BDEP3OUTStat := BDEP3OUTStat OR  USB_DTSEN or USB_USIE;   // set the DTSEN bit and UOWN bit (enable next reception)
	MOVLW       8
	IORWF       1048, 0 
	MOVWF       R0 
	MOVLW       128
	IORWF       R0, 0 
	MOVWF       1048 
;USB_CDC_Library.mpas,457 :: 		end;
L__USB_CDC_Read6:
;USB_CDC_Library.mpas,459 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library.mpas,460 :: 		end;
	MOVF        USB_CDC_Read_local_result+0, 0 
	MOVWF       R0 
L_end_USB_CDC_Read:
	RETURN      0
; end of _USB_CDC_Read

USB_CDC_Library_SendBulkZeroLenPacket:

;USB_CDC_Library.mpas,463 :: 		begin
;USB_CDC_Library.mpas,465 :: 		BDEP3INCnt  := 0;                                       // set bytecount
	CLRF        1053 
;USB_CDC_Library.mpas,466 :: 		BDEP3INAdr  := word(@BuffEP3IN);                        // buffer address
	MOVLW       USB_CDC_Library_BuffEP3IN+0
	MOVWF       1054 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP3IN+0)
	MOVWF       1055 
;USB_CDC_Library.mpas,467 :: 		BDEP3INStat := BDEP3INStat and USB_DTSMASK;             // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1052, 1 
;USB_CDC_Library.mpas,468 :: 		BDEP3INStat := BDEP3INStat xor USB_DTSMASK;             // toggle the data 0/1 bit
	BTG         1052, 6 
;USB_CDC_Library.mpas,469 :: 		BDEP3INStat := BDEP3INStat OR  USB_DTSEN or USB_USIE;   // set the DTSEN bit and UOWN bit (enable sending)
	MOVLW       8
	IORWF       1052, 0 
	MOVWF       R0 
	MOVLW       128
	IORWF       R0, 0 
	MOVWF       1052 
;USB_CDC_Library.mpas,470 :: 		end;
L_end_SendBulkZeroLenPacket:
	RETURN      0
; end of USB_CDC_Library_SendBulkZeroLenPacket

_USB_CDC_Write_Ready:

;USB_CDC_Library.mpas,473 :: 		begin
;USB_CDC_Library.mpas,474 :: 		PIE2.USBIE  := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library.mpas,475 :: 		if (BDEP3INStat.UOWN = 0)
	BTFSC       1052, 7 
	GOTO        L__USB_CDC_Write_Ready17
;USB_CDC_Library.mpas,476 :: 		then Result := true
	MOVLW       255
	MOVWF       R1 
	GOTO        L__USB_CDC_Write_Ready18
;USB_CDC_Library.mpas,477 :: 		else Result := false;
L__USB_CDC_Write_Ready17:
	CLRF        R1 
L__USB_CDC_Write_Ready18:
;USB_CDC_Library.mpas,478 :: 		PIE2.USBIE  := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library.mpas,479 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_USB_CDC_Write_Ready:
	RETURN      0
; end of _USB_CDC_Write_Ready

_USB_CDC_Write:

;USB_CDC_Library.mpas,483 :: 		begin
;USB_CDC_Library.mpas,484 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library.mpas,486 :: 		if (BDEP3INStat.UOWN = 0)
	BTFSC       1052, 7 
	GOTO        L__USB_CDC_Write21
;USB_CDC_Library.mpas,487 :: 		then Result := true
	MOVLW       255
	MOVWF       USB_CDC_Write_local_result+0 
	GOTO        L__USB_CDC_Write22
;USB_CDC_Library.mpas,488 :: 		else Result := false;
L__USB_CDC_Write21:
	CLRF        USB_CDC_Write_local_result+0 
L__USB_CDC_Write22:
;USB_CDC_Library.mpas,490 :: 		if Result then
	MOVF        USB_CDC_Write_local_result+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__USB_CDC_Write24
;USB_CDC_Library.mpas,493 :: 		DstPtr := ^byte(@BuffEP3IN);    // get destination address
	MOVLW       USB_CDC_Library_BuffEP3IN+0
	MOVWF       USB_CDC_Write_DstPtr+0 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP3IN+0)
	MOVWF       USB_CDC_Write_DstPtr+1 
;USB_CDC_Library.mpas,496 :: 		if ByteCount > USB_CDC_BULK_IN_EP_SIZE
	MOVLW       0
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_CDC_Write432
	MOVF        FARG_USB_CDC_Write_ByteCount+0, 0 
	SUBLW       64
L__USB_CDC_Write432:
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_CDC_Write27
;USB_CDC_Library.mpas,497 :: 		then ByteCount := USB_CDC_BULK_IN_EP_SIZE;
	MOVLW       64
	MOVWF       FARG_USB_CDC_Write_ByteCount+0 
L__USB_CDC_Write27:
;USB_CDC_Library.mpas,499 :: 		if ByteCount > 0 then    // fill the transmit buffer
	MOVF        FARG_USB_CDC_Write_ByteCount+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_CDC_Write30
;USB_CDC_Library.mpas,501 :: 		memcpy(DstPtr, SrcPtr, ByteCount);
	MOVF        USB_CDC_Write_DstPtr+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        USB_CDC_Write_DstPtr+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        FARG_USB_CDC_Write_SrcPtr+0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        FARG_USB_CDC_Write_SrcPtr+1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVF        FARG_USB_CDC_Write_ByteCount+0, 0 
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;USB_CDC_Library.mpas,502 :: 		end;
L__USB_CDC_Write30:
;USB_CDC_Library.mpas,505 :: 		BDEP3INCnt  := ByteCount;                               // set bytecount
	MOVF        FARG_USB_CDC_Write_ByteCount+0, 0 
	MOVWF       1053 
;USB_CDC_Library.mpas,506 :: 		BDEP3INAdr  := word(@BuffEP3IN);                        // buffer address
	MOVLW       USB_CDC_Library_BuffEP3IN+0
	MOVWF       1054 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP3IN+0)
	MOVWF       1055 
;USB_CDC_Library.mpas,507 :: 		BDEP3INStat := BDEP3INStat and USB_DTSMASK;             // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1052, 1 
;USB_CDC_Library.mpas,508 :: 		BDEP3INStat := BDEP3INStat xor USB_DTSMASK;             // toggle the data 0/1 bit
	BTG         1052, 6 
;USB_CDC_Library.mpas,509 :: 		BDEP3INStat := BDEP3INStat OR  USB_DTSEN or USB_USIE;   // set the DTSEN bit and UOWN bit (enable sending)
	MOVLW       8
	IORWF       1052, 0 
	MOVWF       R0 
	MOVLW       128
	IORWF       R0, 0 
	MOVWF       1052 
;USB_CDC_Library.mpas,510 :: 		end;
L__USB_CDC_Write24:
;USB_CDC_Library.mpas,512 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library.mpas,513 :: 		end;
	MOVF        USB_CDC_Write_local_result+0, 0 
	MOVWF       R0 
L_end_USB_CDC_Write:
	RETURN      0
; end of _USB_CDC_Write

_ConfiguredUsb:

;USB_CDC_Library.mpas,516 :: 		begin
;USB_CDC_Library.mpas,517 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE
	MOVF        USB_CDC_Library_UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ConfiguredUsb34
;USB_CDC_Library.mpas,518 :: 		then Result := true
	MOVLW       255
	MOVWF       R1 
	GOTO        L__ConfiguredUsb35
;USB_CDC_Library.mpas,519 :: 		else Result := false;
L__ConfiguredUsb34:
	CLRF        R1 
L__ConfiguredUsb35:
;USB_CDC_Library.mpas,520 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_ConfiguredUsb:
	RETURN      0
; end of _ConfiguredUsb

_ActiveUsb:

;USB_CDC_Library.mpas,523 :: 		begin
;USB_CDC_Library.mpas,524 :: 		if (IsIdle = false) and (UsbDeviceEnumState = USB_CONFIG_STATE)
	MOVF        USB_CDC_Library_IsIdle+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        USB_CDC_Library_UsbDeviceEnumState+0, 0 
	XORLW       3
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__ActiveUsb38
;USB_CDC_Library.mpas,525 :: 		then Result := true
	MOVLW       255
	MOVWF       R2 
	GOTO        L__ActiveUsb39
;USB_CDC_Library.mpas,526 :: 		else Result := false;
L__ActiveUsb38:
	CLRF        R2 
L__ActiveUsb39:
;USB_CDC_Library.mpas,527 :: 		end;
	MOVF        R2, 0 
	MOVWF       R0 
L_end_ActiveUsb:
	RETURN      0
; end of _ActiveUsb

_InitUsb:

;USB_CDC_Library.mpas,530 :: 		begin
;USB_CDC_Library.mpas,544 :: 		UsbDeviceRequest  := $FF; // no device requests in progress
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,546 :: 		UsbDeviceEnumState := USB_POWERED_STATE;
	CLRF        USB_CDC_Library_UsbDeviceEnumState+0 
;USB_CDC_Library.mpas,551 :: 		UsbCurrentConfig  := 0; // no configuration selected
	CLRF        USB_CDC_Library_UsbCurrentConfig+0 
;USB_CDC_Library.mpas,552 :: 		Usb_Status_Device := 1; //
	MOVLW       1
	MOVWF       USB_CDC_Library_Usb_Status_Device+0 
;USB_CDC_Library.mpas,553 :: 		UsbInterface      := 0;
	CLRF        USB_CDC_Library_UsbInterface+0 
;USB_CDC_Library.mpas,555 :: 		UADDR := 0;
	CLRF        UADDR+0 
;USB_CDC_Library.mpas,557 :: 		UCFG.7      := 0; // eye pattern disabled
	BCF         UCFG+0, 7 
;USB_CDC_Library.mpas,558 :: 		UCFG.UOEMON := 0; // OE monitor disabled
	BCF         UCFG+0, 6 
;USB_CDC_Library.mpas,559 :: 		UCFG.UPUEN  := 1; // on chip pull up enabled
	BSF         UCFG+0, 4 
;USB_CDC_Library.mpas,560 :: 		UCFG.UTRDIS := 0; // on chip tranceiver active
	BCF         UCFG+0, 3 
;USB_CDC_Library.mpas,561 :: 		UCFG.FSEN   := 1; // Full speed enable (48 MHz USB clock required)
	BSF         UCFG+0, 2 
;USB_CDC_Library.mpas,562 :: 		UCFG.PPB1   := 0; // ping pong buffers disabled
	BCF         UCFG+0, 1 
;USB_CDC_Library.mpas,563 :: 		UCFG.PPB0   := 0; //
	BCF         UCFG+0, 0 
;USB_CDC_Library.mpas,565 :: 		UIR   := 0; // clear all Usb interrupt flags
	CLRF        UIR+0 
;USB_CDC_Library.mpas,566 :: 		UIE   := 1; // the only interrupt enabled is "USB reset"
	MOVLW       1
	MOVWF       UIE+0 
;USB_CDC_Library.mpas,568 :: 		PIR2.USBIF := 0; // clear usb interrupt flag
	BCF         PIR2+0, 5 
;USB_CDC_Library.mpas,569 :: 		PIE2.USBIE := 1; // enable Usb interrupts
	BSF         PIE2+0, 5 
;USB_CDC_Library.mpas,571 :: 		INTCON.PEIE := 1; // peripheral interrupt enable
	BSF         INTCON+0, 6 
;USB_CDC_Library.mpas,572 :: 		INTCON.GIE  := 1; // global enable
	BSF         INTCON+0, 7 
;USB_CDC_Library.mpas,574 :: 		UCON  := 8; // attach device (USBEN = 1)
	MOVLW       8
	MOVWF       UCON+0 
;USB_CDC_Library.mpas,576 :: 		repeat
L__InitUsb41:
;USB_CDC_Library.mpas,577 :: 		until UCON.SE0 = 0;
	BTFSC       UCON+0, 5 
	GOTO        L__InitUsb41
;USB_CDC_Library.mpas,578 :: 		end;
L_end_InitUsb:
	RETURN      0
; end of _InitUsb

_DeInitUsb:

;USB_CDC_Library.mpas,581 :: 		begin
;USB_CDC_Library.mpas,582 :: 		UCON.USBEN  := 0; // detach
	BCF         UCON+0, 3 
;USB_CDC_Library.mpas,583 :: 		UCON.SUSPND := 1; // suspend mode
	BSF         UCON+0, 1 
;USB_CDC_Library.mpas,585 :: 		UsbDeviceEnumState := USB_POWERED_STATE;
	CLRF        USB_CDC_Library_UsbDeviceEnumState+0 
;USB_CDC_Library.mpas,590 :: 		PIE2.USBIE := 0;  // disable the USB interrupts
	BCF         PIE2+0, 5 
;USB_CDC_Library.mpas,591 :: 		end;
L_end_DeInitUsb:
	RETURN      0
; end of _DeInitUsb

_SoftDetachUsb:

;USB_CDC_Library.mpas,594 :: 		begin
;USB_CDC_Library.mpas,595 :: 		UCON.USBEN := 0;
	BCF         UCON+0, 3 
;USB_CDC_Library.mpas,596 :: 		Delay_ms(100);
	MOVLW       7
	MOVWF       R11, 0
	MOVLW       23
	MOVWF       R12, 0
	MOVLW       106
	MOVWF       R13, 0
L__SoftDetachUsb48:
	DECFSZ      R13, 1, 1
	BRA         L__SoftDetachUsb48
	DECFSZ      R12, 1, 1
	BRA         L__SoftDetachUsb48
	DECFSZ      R11, 1, 1
	BRA         L__SoftDetachUsb48
	NOP
;USB_CDC_Library.mpas,597 :: 		InitUsb;
	CALL        _InitUsb+0, 0
;USB_CDC_Library.mpas,598 :: 		end;
L_end_SoftDetachUsb:
	RETURN      0
; end of _SoftDetachUsb

USB_CDC_Library_EP0InReset:

;USB_CDC_Library.mpas,601 :: 		begin
;USB_CDC_Library.mpas,602 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_CDC_Library.mpas,603 :: 		BDEP0INStat := (USB_UCPU or USB_DAT0 or USB_DTSEN); // UOWN = 0, DTSEN = 1;
	MOVLW       8
	MOVWF       1028 
;USB_CDC_Library.mpas,604 :: 		end;
L_end_EP0InReset:
	RETURN      0
; end of USB_CDC_Library_EP0InReset

USB_CDC_Library_EP0OutReset:

;USB_CDC_Library.mpas,607 :: 		begin
;USB_CDC_Library.mpas,608 :: 		BDEP0OUTCnt  := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_CDC_Library.mpas,609 :: 		BDEP0OUTStat := (USB_USIE or USBDat or USB_DTSEN); // UOWN = 1 and DTSEN = 1; // ready to receive data
	MOVLW       128
	IORWF       FARG_EP0OutReset_USBDat+0, 0 
	MOVWF       R0 
	MOVLW       8
	IORWF       R0, 0 
	MOVWF       1024 
;USB_CDC_Library.mpas,610 :: 		end;
L_end_EP0OutReset:
	RETURN      0
; end of USB_CDC_Library_EP0OutReset

USB_CDC_Library_GiveEP0INtoSIE__:

;USB_CDC_Library.mpas,613 :: 		begin
;USB_CDC_Library.mpas,614 :: 		BDEP0INStat := BDEP0INStat xor USB_DTSMASK;             // toggle the DTS bit
	BTG         1028, 6 
;USB_CDC_Library.mpas,615 :: 		BDEP0INStat := BDEP0INStat and USB_DTSMASK;             // clear the PID bits except DTS
	MOVLW       64
	ANDWF       1028, 1 
;USB_CDC_Library.mpas,616 :: 		BDEP0INStat := BDEP0INStat or (USB_DTSEN or USB_USIE);  // go: set DTSEN
	MOVLW       136
	IORWF       1028, 1 
;USB_CDC_Library.mpas,617 :: 		end;
L_end_GiveEP0INtoSIE__:
	RETURN      0
; end of USB_CDC_Library_GiveEP0INtoSIE__

USB_CDC_Library_GiveEP0OUTtoSIE__:

;USB_CDC_Library.mpas,620 :: 		begin
;USB_CDC_Library.mpas,621 :: 		BDEP0OUTStat := BDEP0OUTStat and USB_DTSMask;            // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1024, 1 
;USB_CDC_Library.mpas,622 :: 		BDEP0OUTStat := BDEP0OUTStat xor USB_DTSMask;            // toggle data 0/1
	BTG         1024, 6 
;USB_CDC_Library.mpas,623 :: 		BDEP0OUTStat := BDEP0OUTStat or (USB_DTSEN or USB_USIE); // set the DTS bit and the UOWN bit
	MOVLW       136
	IORWF       1024, 1 
;USB_CDC_Library.mpas,624 :: 		end;
L_end_GiveEP0OUTtoSIE__:
	RETURN      0
; end of USB_CDC_Library_GiveEP0OUTtoSIE__

USB_CDC_Library_StallEP0:

;USB_CDC_Library.mpas,627 :: 		begin
;USB_CDC_Library.mpas,631 :: 		UsbDeviceRequest := $FF; // disregard any pending device request
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,633 :: 		BDEP0OUTCnt      := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_CDC_Library.mpas,634 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_CDC_Library.mpas,635 :: 		BDEP0OUTStat     := (USB_USIE or USB_BSTALL);
	MOVLW       132
	MOVWF       1024 
;USB_CDC_Library.mpas,636 :: 		BDEP0INStat      := (USB_USIE or USB_BSTALL);
	MOVLW       132
	MOVWF       1028 
;USB_CDC_Library.mpas,637 :: 		end;
L_end_StallEP0:
	RETURN      0
; end of USB_CDC_Library_StallEP0

USB_CDC_Library_EP0Stalled:

;USB_CDC_Library.mpas,640 :: 		begin
;USB_CDC_Library.mpas,641 :: 		Result := (BDEP0INStat and USB_BSTALL) > 0;
	MOVLW       4
	ANDWF       1028, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	SUBLW       0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R1 
;USB_CDC_Library.mpas,642 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_EP0Stalled:
	RETURN      0
; end of USB_CDC_Library_EP0Stalled

USB_CDC_Library_UsbReset:

;USB_CDC_Library.mpas,646 :: 		begin
;USB_CDC_Library.mpas,647 :: 		UEP0 := 0;  // disable UEP0
	CLRF        UEP0+0 
;USB_CDC_Library.mpas,648 :: 		UEP3 := 0;  // disable UEP3
	CLRF        UEP3+0 
;USB_CDC_Library.mpas,655 :: 		UCON.PKTDIS := 1;    // disable packet reception
	BSF         UCON+0, 4 
;USB_CDC_Library.mpas,657 :: 		UsbCurrentConfig := 0;
	CLRF        USB_CDC_Library_UsbCurrentConfig+0 
;USB_CDC_Library.mpas,658 :: 		IsIdle := false;
	CLRF        USB_CDC_Library_IsIdle+0 
;USB_CDC_Library.mpas,660 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_CDC_Library.mpas,661 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_CDC_Library.mpas,662 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_CDC_Library.mpas,663 :: 		UIR.TRNIF := 0;  // clear 4 times to make the status fifo empty
	BCF         UIR+0, 3 
;USB_CDC_Library.mpas,666 :: 		BDEP0OUTAdr  := word(@BuffEP0OUT);
	MOVLW       USB_CDC_Library_BuffEP0OUT+0
	MOVWF       1026 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP0OUT+0)
	MOVWF       1027 
;USB_CDC_Library.mpas,667 :: 		EP0OutReset(USB_DAT0);  // Initial EP0OUT Status: start with DATA0 toggle bit
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,670 :: 		BDEP0INAdr  := word(@BuffEP0IN);
	MOVLW       USB_CDC_Library_BuffEP0IN+0
	MOVWF       1030 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP0IN+0)
	MOVWF       1031 
;USB_CDC_Library.mpas,671 :: 		EP0InReset;
	CALL        USB_CDC_Library_EP0InReset+0, 0
;USB_CDC_Library.mpas,673 :: 		UADDR      := 0; // no usb address assigned (yet)
	CLRF        UADDR+0 
;USB_CDC_Library.mpas,674 :: 		UIR        := 0; // clear the usb interrupt flags
	CLRF        UIR+0 
;USB_CDC_Library.mpas,675 :: 		PIR2.USBIF := 0; // enable the USB interrupts
	BCF         PIR2+0, 5 
;USB_CDC_Library.mpas,677 :: 		UsbDeviceEnumState := USB_DEFAULT_STATE;
	MOVLW       1
	MOVWF       USB_CDC_Library_UsbDeviceEnumState+0 
;USB_CDC_Library.mpas,682 :: 		Usb_Status_Device := 0; // selfpowered, remote wakeup disabled
	CLRF        USB_CDC_Library_Usb_Status_Device+0 
;USB_CDC_Library.mpas,684 :: 		UIE  := $39; // enable all interrupts except "ACTIVE", "SOFIE" and "UEREIE"
	MOVLW       57
	MOVWF       UIE+0 
;USB_CDC_Library.mpas,685 :: 		UEIE := 0;   // disable all error interrupts
	CLRF        UEIE+0 
;USB_CDC_Library.mpas,688 :: 		UEP0 := USB_EP_CTRL or USB_HSHK_EN;
	MOVLW       22
	MOVWF       UEP0+0 
;USB_CDC_Library.mpas,689 :: 		UCON.PKTDIS := 0;                     // enable packet reception
	BCF         UCON+0, 4 
;USB_CDC_Library.mpas,690 :: 		end;
L_end_UsbReset:
	RETURN      0
; end of USB_CDC_Library_UsbReset

USB_CDC_Library_USBError:

;USB_CDC_Library.mpas,693 :: 		begin
;USB_CDC_Library.mpas,698 :: 		UEIR := 0;
	CLRF        UEIR+0 
;USB_CDC_Library.mpas,699 :: 		UIR.UERRIF := 0; // clear error interrupt bit
	BCF         UIR+0, 1 
;USB_CDC_Library.mpas,701 :: 		end;
L_end_USBError:
	RETURN      0
; end of USB_CDC_Library_USBError

USB_CDC_Library_SendZeroLenPacket:

;USB_CDC_Library.mpas,704 :: 		begin
;USB_CDC_Library.mpas,708 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,709 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_CDC_Library.mpas,710 :: 		BDEP0INStat      := (USB_USIE or USB_DAT1 or USB_DTSEN); // UOWN, DTS (data1) and DTSEN are set
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,711 :: 		end;
L_end_SendZeroLenPacket:
	RETURN      0
; end of USB_CDC_Library_SendZeroLenPacket

USB_CDC_Library_SendAckToHost:

;USB_CDC_Library.mpas,714 :: 		begin
;USB_CDC_Library.mpas,718 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,719 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_CDC_Library.mpas,720 :: 		BDEP0INStat      := (USB_USIE or USB_DAT1 or USB_DTSEN); // UOWN, DTS (data1) and DTSEN are set
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,721 :: 		end;
L_end_SendAckToHost:
	RETURN      0
; end of USB_CDC_Library_SendAckToHost

USB_CDC_Library_CopyDescriptorToEP0:

;USB_CDC_Library.mpas,726 :: 		begin
;USB_CDC_Library.mpas,727 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       CopyDescriptorToEP0_Dst+0 
	MOVF        1031, 0 
	MOVWF       CopyDescriptorToEP0_Dst+1 
;USB_CDC_Library.mpas,728 :: 		Len := DescriptorBytesToSend;
	MOVF        USB_CDC_Library_DescriptorBytesToSend+0, 0 
	MOVWF       CopyDescriptorToEP0_Len+0 
;USB_CDC_Library.mpas,739 :: 		if (Len = 0)
	MOVF        USB_CDC_Library_DescriptorBytesToSend+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_CopyDescriptorToEP061
;USB_CDC_Library.mpas,740 :: 		then UsbDeviceRequest := $FF // all bytes have been sent previous time
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
	GOTO        L_USB_CDC_Library_CopyDescriptorToEP062
;USB_CDC_Library.mpas,743 :: 		else  // some left over of the descriptor is to be sent
L_USB_CDC_Library_CopyDescriptorToEP061:
;USB_CDC_Library.mpas,745 :: 		if (Len > EP0_PACKET_SIZE) then Len := EP0_PACKET_SIZE;
	MOVF        CopyDescriptorToEP0_Len+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_CopyDescriptorToEP064
	MOVLW       64
	MOVWF       CopyDescriptorToEP0_Len+0 
L_USB_CDC_Library_CopyDescriptorToEP064:
;USB_CDC_Library.mpas,746 :: 		for I := 0 to (Len - 1) do
	CLRF        CopyDescriptorToEP0_I+0 
L_USB_CDC_Library_CopyDescriptorToEP066:
	DECF        CopyDescriptorToEP0_Len+0, 0 
	MOVWF       R1 
	MOVF        CopyDescriptorToEP0_I+0, 0 
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_CopyDescriptorToEP070
;USB_CDC_Library.mpas,748 :: 		Dst^:= DescriptorPointer^;
	MOVF        USB_CDC_Library_DescriptorPointer+0, 0 
	MOVWF       TBLPTRL 
	MOVF        USB_CDC_Library_DescriptorPointer+1, 0 
	MOVWF       TBLPTRH 
	MOVF        USB_CDC_Library_DescriptorPointer+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       CopyDescriptorToEP0_Dst+0, FSR1L
	MOVFF       CopyDescriptorToEP0_Dst+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_CDC_Library.mpas,749 :: 		Inc(Dst);
	INFSNZ      CopyDescriptorToEP0_Dst+0, 1 
	INCF        CopyDescriptorToEP0_Dst+1, 1 
;USB_CDC_Library.mpas,750 :: 		Inc(DescriptorPointer);
	MOVLW       1
	ADDWF       USB_CDC_Library_DescriptorPointer+0, 1 
	MOVLW       0
	ADDWFC      USB_CDC_Library_DescriptorPointer+1, 1 
	ADDWFC      USB_CDC_Library_DescriptorPointer+2, 1 
;USB_CDC_Library.mpas,751 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_CDC_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_CDC_Library_DescriptorBytesToSend+1, 1 
;USB_CDC_Library.mpas,752 :: 		Dec(DescriptorBytesRequested);
	MOVLW       1
	SUBWF       USB_CDC_Library_DescriptorBytesRequested+0, 1 
	MOVLW       0
	SUBWFB      USB_CDC_Library_DescriptorBytesRequested+1, 1 
;USB_CDC_Library.mpas,753 :: 		end;
	MOVF        CopyDescriptorToEP0_I+0, 0 
	XORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_CopyDescriptorToEP070
	INCF        CopyDescriptorToEP0_I+0, 1 
	GOTO        L_USB_CDC_Library_CopyDescriptorToEP066
L_USB_CDC_Library_CopyDescriptorToEP070:
;USB_CDC_Library.mpas,754 :: 		end;
L_USB_CDC_Library_CopyDescriptorToEP062:
;USB_CDC_Library.mpas,756 :: 		if (DescriptorBytesRequested = 0)
	MOVLW       0
	XORWF       USB_CDC_Library_DescriptorBytesRequested+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_CopyDescriptorToEP0449
	MOVLW       0
	XORWF       USB_CDC_Library_DescriptorBytesRequested+0, 0 
L_USB_CDC_Library_CopyDescriptorToEP0449:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_CopyDescriptorToEP072
;USB_CDC_Library.mpas,757 :: 		then UsbDeviceRequest := $FF; // all bytes have been sent after this
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
L_USB_CDC_Library_CopyDescriptorToEP072:
;USB_CDC_Library.mpas,759 :: 		BDEP0INCnt  := Len;
	MOVF        CopyDescriptorToEP0_Len+0, 0 
	MOVWF       1029 
;USB_CDC_Library.mpas,760 :: 		BDEP0INAdr  := word(@BuffEP0IN);
	MOVLW       USB_CDC_Library_BuffEP0IN+0
	MOVWF       1030 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP0IN+0)
	MOVWF       1031 
;USB_CDC_Library.mpas,761 :: 		GiveEP0INtoSIE__; // send
	CALL        USB_CDC_Library_GiveEP0INtoSIE__+0, 0
;USB_CDC_Library.mpas,762 :: 		end;
L_end_CopyDescriptorToEP0:
	RETURN      0
; end of USB_CDC_Library_CopyDescriptorToEP0

USB_CDC_Library_SendStringDescriptorToEP0:

;USB_CDC_Library.mpas,767 :: 		begin
;USB_CDC_Library.mpas,769 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       SendStringDescriptorToEP0_Dst+0 
	MOVF        1031, 0 
	MOVWF       SendStringDescriptorToEP0_Dst+1 
;USB_CDC_Library.mpas,770 :: 		Len := DescriptorBytesToSend;
	MOVF        USB_CDC_Library_DescriptorBytesToSend+0, 0 
	MOVWF       SendStringDescriptorToEP0_Len+0 
;USB_CDC_Library.mpas,772 :: 		if (Len = 0)
	MOVF        USB_CDC_Library_DescriptorBytesToSend+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_SendStringDescriptorToEP076
;USB_CDC_Library.mpas,773 :: 		then UsbDeviceRequest := $FF // all bytes have been sent previous time
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
	GOTO        L_USB_CDC_Library_SendStringDescriptorToEP077
;USB_CDC_Library.mpas,776 :: 		else  // some left over of the descriptor is to be sent
L_USB_CDC_Library_SendStringDescriptorToEP076:
;USB_CDC_Library.mpas,778 :: 		if (Len > EP0_PACKET_SIZE) then Len := EP0_PACKET_SIZE;
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_SendStringDescriptorToEP079
	MOVLW       64
	MOVWF       SendStringDescriptorToEP0_Len+0 
L_USB_CDC_Library_SendStringDescriptorToEP079:
;USB_CDC_Library.mpas,785 :: 		I := 0;
	CLRF        SendStringDescriptorToEP0_I+0 
;USB_CDC_Library.mpas,786 :: 		if StartStringDescriptor then     // first send length byte and string descriptor identifier
	MOVF        USB_CDC_Library_StartStringDescriptor+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_SendStringDescriptorToEP082
;USB_CDC_Library.mpas,788 :: 		Dst^ := Len;                    // length byte
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       POSTINC1+0 
;USB_CDC_Library.mpas,789 :: 		inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_CDC_Library.mpas,790 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_CDC_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_CDC_Library_DescriptorBytesToSend+1, 1 
;USB_CDC_Library.mpas,792 :: 		Dst^ := USB_STRING_DESCRIPTOR;  // descriptor identifcation
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVLW       3
	MOVWF       POSTINC1+0 
;USB_CDC_Library.mpas,793 :: 		inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_CDC_Library.mpas,794 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_CDC_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_CDC_Library_DescriptorBytesToSend+1, 1 
;USB_CDC_Library.mpas,796 :: 		I := 2;
	MOVLW       2
	MOVWF       SendStringDescriptorToEP0_I+0 
;USB_CDC_Library.mpas,797 :: 		StartStringDescriptor := false;
	CLRF        USB_CDC_Library_StartStringDescriptor+0 
;USB_CDC_Library.mpas,798 :: 		end;
L_USB_CDC_Library_SendStringDescriptorToEP082:
;USB_CDC_Library.mpas,800 :: 		while I < Len do
L_USB_CDC_Library_SendStringDescriptorToEP085:
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	SUBWF       SendStringDescriptorToEP0_I+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_SendStringDescriptorToEP086
;USB_CDC_Library.mpas,802 :: 		Dst^:= DescriptorPointer^;     // copy byte
	MOVF        USB_CDC_Library_DescriptorPointer+0, 0 
	MOVWF       TBLPTRL 
	MOVF        USB_CDC_Library_DescriptorPointer+1, 0 
	MOVWF       TBLPTRH 
	MOVF        USB_CDC_Library_DescriptorPointer+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_CDC_Library.mpas,803 :: 		Inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_CDC_Library.mpas,804 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_CDC_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_CDC_Library_DescriptorBytesToSend+1, 1 
;USB_CDC_Library.mpas,805 :: 		Inc(DescriptorPointer);
	MOVLW       1
	ADDWF       USB_CDC_Library_DescriptorPointer+0, 1 
	MOVLW       0
	ADDWFC      USB_CDC_Library_DescriptorPointer+1, 1 
	ADDWFC      USB_CDC_Library_DescriptorPointer+2, 1 
;USB_CDC_Library.mpas,806 :: 		inc(I);
	INCF        SendStringDescriptorToEP0_I+0, 1 
;USB_CDC_Library.mpas,808 :: 		Dst^:= 0;                     // and add zero
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	CLRF        POSTINC1+0 
;USB_CDC_Library.mpas,809 :: 		Inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_CDC_Library.mpas,810 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_CDC_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_CDC_Library_DescriptorBytesToSend+1, 1 
;USB_CDC_Library.mpas,811 :: 		inc(I);
	INCF        SendStringDescriptorToEP0_I+0, 1 
;USB_CDC_Library.mpas,812 :: 		end;
	GOTO        L_USB_CDC_Library_SendStringDescriptorToEP085
L_USB_CDC_Library_SendStringDescriptorToEP086:
;USB_CDC_Library.mpas,813 :: 		end;
L_USB_CDC_Library_SendStringDescriptorToEP077:
;USB_CDC_Library.mpas,815 :: 		if (DescriptorBytesToSend = 0)
	MOVLW       0
	XORWF       USB_CDC_Library_DescriptorBytesToSend+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_SendStringDescriptorToEP0451
	MOVLW       0
	XORWF       USB_CDC_Library_DescriptorBytesToSend+0, 0 
L_USB_CDC_Library_SendStringDescriptorToEP0451:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_SendStringDescriptorToEP090
;USB_CDC_Library.mpas,816 :: 		then UsbDeviceRequest := $FF; // all bytes have been sent after this
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
L_USB_CDC_Library_SendStringDescriptorToEP090:
;USB_CDC_Library.mpas,823 :: 		BDEP0INCnt  := Len;
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       1029 
;USB_CDC_Library.mpas,824 :: 		BDEP0INAdr  := word(@BuffEP0IN);
	MOVLW       USB_CDC_Library_BuffEP0IN+0
	MOVWF       1030 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP0IN+0)
	MOVWF       1031 
;USB_CDC_Library.mpas,825 :: 		GiveEP0INtoSIE__; // send
	CALL        USB_CDC_Library_GiveEP0INtoSIE__+0, 0
;USB_CDC_Library.mpas,826 :: 		end;
L_end_SendStringDescriptorToEP0:
	RETURN      0
; end of USB_CDC_Library_SendStringDescriptorToEP0

USB_CDC_Library_PrepareStringDescriptor:

;USB_CDC_Library.mpas,831 :: 		begin
;USB_CDC_Library.mpas,833 :: 		Len := 0;
	CLRF        R5 
;USB_CDC_Library.mpas,834 :: 		Tmp := Src;
	MOVF        FARG_PrepareStringDescriptor_Src+0, 0 
	MOVWF       R2 
	MOVF        FARG_PrepareStringDescriptor_Src+1, 0 
	MOVWF       R3 
	MOVF        FARG_PrepareStringDescriptor_Src+2, 0 
	MOVWF       R4 
;USB_CDC_Library.mpas,835 :: 		while Tmp^ > 0 do
L_USB_CDC_Library_PrepareStringDescriptor94:
	MOVF        R2, 0 
	MOVWF       TBLPTRL 
	MOVF        R3, 0 
	MOVWF       TBLPTRH 
	MOVF        R4, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R1
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_PrepareStringDescriptor95
;USB_CDC_Library.mpas,837 :: 		inc(Len);
	INCF        R5, 1 
;USB_CDC_Library.mpas,838 :: 		inc(Tmp);
	MOVLW       1
	ADDWF       R2, 1 
	MOVLW       0
	ADDWFC      R3, 1 
	ADDWFC      R4, 1 
;USB_CDC_Library.mpas,839 :: 		end;
	GOTO        L_USB_CDC_Library_PrepareStringDescriptor94
L_USB_CDC_Library_PrepareStringDescriptor95:
;USB_CDC_Library.mpas,840 :: 		Len := (2 * Len) + 2;
	MOVF        R5, 0 
	MOVWF       R0 
	RLCF        R0, 1 
	BCF         R0, 0 
	MOVLW       2
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       R5 
;USB_CDC_Library.mpas,842 :: 		DescriptorPointer     := Src;
	MOVF        FARG_PrepareStringDescriptor_Src+0, 0 
	MOVWF       USB_CDC_Library_DescriptorPointer+0 
	MOVF        FARG_PrepareStringDescriptor_Src+1, 0 
	MOVWF       USB_CDC_Library_DescriptorPointer+1 
	MOVF        FARG_PrepareStringDescriptor_Src+2, 0 
	MOVWF       USB_CDC_Library_DescriptorPointer+2 
;USB_CDC_Library.mpas,843 :: 		DescriptorBytesToSend := Len;
	MOVF        R0, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+1 
;USB_CDC_Library.mpas,844 :: 		UsbDeviceRequest      := USB_GET_STRING_DESCRIPTOR_ONGOING;
	MOVLW       2
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,845 :: 		StartStringDescriptor := true;
	MOVLW       255
	MOVWF       USB_CDC_Library_StartStringDescriptor+0 
;USB_CDC_Library.mpas,846 :: 		end;
L_end_PrepareStringDescriptor:
	RETURN      0
; end of USB_CDC_Library_PrepareStringDescriptor

USB_CDC_Library_GetDescriptor:

;USB_CDC_Library.mpas,850 :: 		begin
;USB_CDC_Library.mpas,851 :: 		Index := Lo(SetUpPacket.wValue);
	MOVF        USB_CDC_Library_SetUpPacket+2, 0 
	MOVWF       GetDescriptor_Index+0 
;USB_CDC_Library.mpas,869 :: 		USB_DEVICE_DESCRIPTOR         : // GetDeviceDescriptor
	MOVF        USB_CDC_Library_SetUpPacket+3, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor102
;USB_CDC_Library.mpas,871 :: 		UsbDeviceRequest           := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,872 :: 		DescriptorPointer          := @DeviceDescriptor;
	MOVLW       _DeviceDescriptor+0
	MOVWF       USB_CDC_Library_DescriptorPointer+0 
	MOVLW       hi_addr(_DeviceDescriptor+0)
	MOVWF       USB_CDC_Library_DescriptorPointer+1 
	MOVLW       higher_addr(_DeviceDescriptor+0)
	MOVWF       USB_CDC_Library_DescriptorPointer+2 
;USB_CDC_Library.mpas,873 :: 		DescriptorBytesToSend      := SizeOf(DeviceDescriptor);
	MOVLW       18
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+1 
;USB_CDC_Library.mpas,874 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        USB_CDC_Library_SetUpPacket+6, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesRequested+0 
	MOVF        USB_CDC_Library_SetUpPacket+7, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesRequested+1 
;USB_CDC_Library.mpas,875 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVLW       0
	SUBWF       USB_CDC_Library_SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor454
	MOVLW       18
	SUBWF       USB_CDC_Library_SetUpPacket+6, 0 
L_USB_CDC_Library_GetDescriptor454:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_GetDescriptor104
;USB_CDC_Library.mpas,876 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        USB_CDC_Library_DescriptorBytesRequested+0, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+0 
	MOVF        USB_CDC_Library_DescriptorBytesRequested+1, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+1 
L_USB_CDC_Library_GetDescriptor104:
;USB_CDC_Library.mpas,877 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,878 :: 		CopyDescriptorToEP0;
	CALL        USB_CDC_Library_CopyDescriptorToEP0+0, 0
;USB_CDC_Library.mpas,879 :: 		end;
	GOTO        L_USB_CDC_Library_GetDescriptor99
L_USB_CDC_Library_GetDescriptor102:
;USB_CDC_Library.mpas,881 :: 		USB_CONFIGURATION_DESCRIPTOR  : // GetConfigDescriptor;
	MOVF        USB_CDC_Library_SetUpPacket+3, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor108
;USB_CDC_Library.mpas,883 :: 		UsbDeviceRequest           := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,884 :: 		DescriptorPointer          := @Config1;
	MOVLW       _Config1+0
	MOVWF       USB_CDC_Library_DescriptorPointer+0 
	MOVLW       hi_addr(_Config1+0)
	MOVWF       USB_CDC_Library_DescriptorPointer+1 
	MOVLW       higher_addr(_Config1+0)
	MOVWF       USB_CDC_Library_DescriptorPointer+2 
;USB_CDC_Library.mpas,885 :: 		DescriptorBytesToSend      := SizeOf(Config1);
	MOVLW       67
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+1 
;USB_CDC_Library.mpas,886 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        USB_CDC_Library_SetUpPacket+6, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesRequested+0 
	MOVF        USB_CDC_Library_SetUpPacket+7, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesRequested+1 
;USB_CDC_Library.mpas,887 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVLW       0
	SUBWF       USB_CDC_Library_SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor455
	MOVLW       67
	SUBWF       USB_CDC_Library_SetUpPacket+6, 0 
L_USB_CDC_Library_GetDescriptor455:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_GetDescriptor110
;USB_CDC_Library.mpas,888 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        USB_CDC_Library_DescriptorBytesRequested+0, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+0 
	MOVF        USB_CDC_Library_DescriptorBytesRequested+1, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+1 
L_USB_CDC_Library_GetDescriptor110:
;USB_CDC_Library.mpas,889 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,890 :: 		CopyDescriptorToEP0;
	CALL        USB_CDC_Library_CopyDescriptorToEP0+0, 0
;USB_CDC_Library.mpas,891 :: 		end;
	GOTO        L_USB_CDC_Library_GetDescriptor99
L_USB_CDC_Library_GetDescriptor108:
;USB_CDC_Library.mpas,893 :: 		USB_STRING_DESCRIPTOR         : // GetStringDescriptor(Index);
	MOVF        USB_CDC_Library_SetUpPacket+3, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor114
;USB_CDC_Library.mpas,895 :: 		if Index <= 3 then
	MOVF        GetDescriptor_Index+0, 0 
	SUBLW       3
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_GetDescriptor116
;USB_CDC_Library.mpas,899 :: 		0: //
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor121
;USB_CDC_Library.mpas,901 :: 		DescriptorPointer     := @LanguageString;
	MOVLW       _LanguageString+0
	MOVWF       USB_CDC_Library_DescriptorPointer+0 
	MOVLW       hi_addr(_LanguageString+0)
	MOVWF       USB_CDC_Library_DescriptorPointer+1 
	MOVLW       higher_addr(_LanguageString+0)
	MOVWF       USB_CDC_Library_DescriptorPointer+2 
;USB_CDC_Library.mpas,902 :: 		DescriptorBytesToSend := SizeOf(LanguageString);
	MOVLW       4
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+1 
;USB_CDC_Library.mpas,903 :: 		UsbDeviceRequest      := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,904 :: 		end;
	GOTO        L_USB_CDC_Library_GetDescriptor118
L_USB_CDC_Library_GetDescriptor121:
;USB_CDC_Library.mpas,905 :: 		1: PrepareStringDescriptor(@UsbManufacturer);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor124
	MOVLW       _UsbManufacturer+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbManufacturer+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbManufacturer+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_CDC_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_CDC_Library_GetDescriptor118
L_USB_CDC_Library_GetDescriptor124:
;USB_CDC_Library.mpas,906 :: 		2: PrepareStringDescriptor(@UsbProduct);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor127
	MOVLW       _UsbProduct+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbProduct+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbProduct+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_CDC_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_CDC_Library_GetDescriptor118
L_USB_CDC_Library_GetDescriptor127:
;USB_CDC_Library.mpas,907 :: 		3: PrepareStringDescriptor(@UsbSerialNo);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor130
	MOVLW       _UsbSerialNo+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbSerialNo+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbSerialNo+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_CDC_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_CDC_Library_GetDescriptor118
L_USB_CDC_Library_GetDescriptor130:
L_USB_CDC_Library_GetDescriptor118:
;USB_CDC_Library.mpas,909 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        USB_CDC_Library_SetUpPacket+6, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesRequested+0 
	MOVF        USB_CDC_Library_SetUpPacket+7, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesRequested+1 
;USB_CDC_Library.mpas,910 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVF        USB_CDC_Library_DescriptorBytesToSend+1, 0 
	SUBWF       USB_CDC_Library_SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor456
	MOVF        USB_CDC_Library_DescriptorBytesToSend+0, 0 
	SUBWF       USB_CDC_Library_SetUpPacket+6, 0 
L_USB_CDC_Library_GetDescriptor456:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_GetDescriptor132
;USB_CDC_Library.mpas,911 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        USB_CDC_Library_DescriptorBytesRequested+0, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+0 
	MOVF        USB_CDC_Library_DescriptorBytesRequested+1, 0 
	MOVWF       USB_CDC_Library_DescriptorBytesToSend+1 
L_USB_CDC_Library_GetDescriptor132:
;USB_CDC_Library.mpas,913 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,914 :: 		if Index = 0
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_GetDescriptor135
;USB_CDC_Library.mpas,915 :: 		then CopyDescriptorToEP0        // string is in constant memory
	CALL        USB_CDC_Library_CopyDescriptorToEP0+0, 0
	GOTO        L_USB_CDC_Library_GetDescriptor136
;USB_CDC_Library.mpas,916 :: 		else SendStringDescriptorToEP0; // special case
L_USB_CDC_Library_GetDescriptor135:
	CALL        USB_CDC_Library_SendStringDescriptorToEP0+0, 0
L_USB_CDC_Library_GetDescriptor136:
;USB_CDC_Library.mpas,917 :: 		end
	GOTO        L_USB_CDC_Library_GetDescriptor117
;USB_CDC_Library.mpas,918 :: 		else StallEP0;
L_USB_CDC_Library_GetDescriptor116:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_GetDescriptor117:
;USB_CDC_Library.mpas,920 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_GetDescriptor99
L_USB_CDC_Library_GetDescriptor114:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_GetDescriptor99:
;USB_CDC_Library.mpas,922 :: 		end;
L_end_GetDescriptor:
	RETURN      0
; end of USB_CDC_Library_GetDescriptor

USB_CDC_Library_TokenOutPID:

;USB_CDC_Library.mpas,926 :: 		begin
;USB_CDC_Library.mpas,927 :: 		Ep := (USTATCopy shr 3) and $0F; // get endpoint
	MOVF        USB_CDC_Library_USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       TokenOutPID_Ep+0 
;USB_CDC_Library.mpas,935 :: 		if (Ep = 0) and (BDEP0OUTCnt = 0) then  // ZLP received , reset EP0 out, ready for reception
	MOVF        R0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        1025, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenOutPID139
;USB_CDC_Library.mpas,937 :: 		EP0OutReset(USB_DAT0);  // reset EP0 to its initial state
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,941 :: 		exit;
	GOTO        L_end_USB_CDC_Library_TokenOutPID
;USB_CDC_Library.mpas,942 :: 		end;
L_USB_CDC_Library_TokenOutPID139:
;USB_CDC_Library.mpas,945 :: 		0: // Endpoint 0 out
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenOutPID144
;USB_CDC_Library.mpas,957 :: 		USB_SEND_ENCAPSULATED_COMMAND + $80:
	MOVF        USB_CDC_Library_UsbDeviceRequest+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenOutPID148
;USB_CDC_Library.mpas,962 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,963 :: 		for I := 0 to 7 do DummyEncapsulatedCommand[I] := BuffEP0OUT[I];
	CLRF        TokenOutPID_I+0 
L_USB_CDC_Library_TokenOutPID150:
	MOVLW       USB_CDC_Library_DummyEncapsulatedCommand+0
	MOVWF       FSR1L 
	MOVLW       hi_addr(USB_CDC_Library_DummyEncapsulatedCommand+0)
	MOVWF       FSR1H 
	MOVF        TokenOutPID_I+0, 0 
	ADDWF       FSR1L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVLW       USB_CDC_Library_BuffEP0OUT+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP0OUT+0)
	MOVWF       FSR0H 
	MOVF        TokenOutPID_I+0, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        TokenOutPID_I+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenOutPID153
	INCF        TokenOutPID_I+0, 1 
	GOTO        L_USB_CDC_Library_TokenOutPID150
L_USB_CDC_Library_TokenOutPID153:
;USB_CDC_Library.mpas,965 :: 		end;
	GOTO        L_USB_CDC_Library_TokenOutPID145
L_USB_CDC_Library_TokenOutPID148:
;USB_CDC_Library.mpas,967 :: 		USB_SET_LINE_CODING + $80:
	MOVF        USB_CDC_Library_UsbDeviceRequest+0, 0 
	XORLW       160
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenOutPID156
;USB_CDC_Library.mpas,973 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,975 :: 		(BuffEP0OUT[1] shl  8) +
	MOVF        1281, 0 
	MOVWF       R1 
	CLRF        R0 
	CLRF        R2 
	CLRF        R3 
	MOVF        1280, 0 
	ADDWF       R0, 0 
	MOVWF       R5 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       R6 
	MOVLW       0
	ADDWFC      R2, 0 
	MOVWF       R7 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       R8 
;USB_CDC_Library.mpas,976 :: 		(BuffEP0OUT[2] shl 16) +
	MOVF        1282, 0 
	MOVWF       R2 
	CLRF        R0 
	CLRF        R1 
	CLRF        R3 
	MOVF        R0, 0 
	ADDWF       R5, 1 
	MOVF        R1, 0 
	ADDWFC      R6, 1 
	MOVF        R2, 0 
	ADDWFC      R7, 1 
	MOVF        R3, 0 
	ADDWFC      R8, 1 
;USB_CDC_Library.mpas,977 :: 		(BuffEP0OUT[3] shl 24);
	MOVF        1283, 0 
	MOVWF       R3 
	CLRF        R0 
	CLRF        R1 
	CLRF        R2 
	MOVF        R5, 0 
	ADDWF       R0, 1 
	MOVF        R6, 0 
	ADDWFC      R1, 1 
	MOVF        R7, 0 
	ADDWFC      R2, 1 
	MOVF        R8, 0 
	ADDWFC      R3, 1 
	MOVF        R0, 0 
	MOVWF       USB_CDC_Library_LineCoding+0 
	MOVF        R1, 0 
	MOVWF       USB_CDC_Library_LineCoding+1 
	MOVF        R2, 0 
	MOVWF       USB_CDC_Library_LineCoding+2 
	MOVF        R3, 0 
	MOVWF       USB_CDC_Library_LineCoding+3 
;USB_CDC_Library.mpas,978 :: 		LineCoding.CharFormat := BuffEP0OUT[4];
	MOVF        1284, 0 
	MOVWF       USB_CDC_Library_LineCoding+4 
;USB_CDC_Library.mpas,979 :: 		LineCoding.ParityType := BuffEP0OUT[5];
	MOVF        1285, 0 
	MOVWF       USB_CDC_Library_LineCoding+5 
;USB_CDC_Library.mpas,980 :: 		LineCoding.DataBits   := BuffEP0OUT[6];
	MOVF        1286, 0 
	MOVWF       USB_CDC_Library_LineCoding+6 
;USB_CDC_Library.mpas,981 :: 		end;
	GOTO        L_USB_CDC_Library_TokenOutPID145
L_USB_CDC_Library_TokenOutPID156:
L_USB_CDC_Library_TokenOutPID145:
;USB_CDC_Library.mpas,984 :: 		if (BDEP0OutCnt < EP0_PACKET_SIZE) then    // this was the last packet
	MOVLW       64
	SUBWF       1025, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_TokenOutPID158
;USB_CDC_Library.mpas,986 :: 		BDEP0OUTCnt  := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_CDC_Library.mpas,987 :: 		BDEP0OUTStat := USB_USIE or USB_DAT0 or USB_DTSEN; // set UOWN and DTS: give buffer back to SIE
	MOVLW       136
	MOVWF       1024 
;USB_CDC_Library.mpas,988 :: 		EP0OutReset(USB_DAT0); // reset EP0 to its initial state
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,989 :: 		SendZeroLenPacket;
	CALL        USB_CDC_Library_SendZeroLenPacket+0, 0
;USB_CDC_Library.mpas,990 :: 		end
	GOTO        L_USB_CDC_Library_TokenOutPID159
;USB_CDC_Library.mpas,992 :: 		else
L_USB_CDC_Library_TokenOutPID158:
;USB_CDC_Library.mpas,994 :: 		GiveEP0OUTtoSIE__; // toggle the DTS bit and set DTSEN and USB_USIE (give to SIE = prepare to receive data)
	CALL        USB_CDC_Library_GiveEP0OUTtoSIE__+0, 0
;USB_CDC_Library.mpas,995 :: 		end;
L_USB_CDC_Library_TokenOutPID159:
;USB_CDC_Library.mpas,996 :: 		end;
	GOTO        L_USB_CDC_Library_TokenOutPID141
L_USB_CDC_Library_TokenOutPID144:
;USB_CDC_Library.mpas,998 :: 		2: //
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenOutPID162
;USB_CDC_Library.mpas,1003 :: 		end;
	GOTO        L_USB_CDC_Library_TokenOutPID141
L_USB_CDC_Library_TokenOutPID162:
;USB_CDC_Library.mpas,1005 :: 		3: //
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenOutPID165
;USB_CDC_Library.mpas,1010 :: 		end;
	GOTO        L_USB_CDC_Library_TokenOutPID141
L_USB_CDC_Library_TokenOutPID165:
L_USB_CDC_Library_TokenOutPID141:
;USB_CDC_Library.mpas,1012 :: 		end;
L_end_USB_CDC_Library_TokenOutPID:
L_end_TokenOutPID:
	RETURN      0
; end of USB_CDC_Library_TokenOutPID

USB_CDC_Library_TokenInPID:

;USB_CDC_Library.mpas,1016 :: 		begin
;USB_CDC_Library.mpas,1017 :: 		Ep := (USTATCopy shr 3) and $0F; // get endpoint
	MOVF        USB_CDC_Library_USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       TokenInPID_Ep+0 
;USB_CDC_Library.mpas,1026 :: 		0: // endpoint 0
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID170
;USB_CDC_Library.mpas,1034 :: 		USB_GET_DESCRIPTOR_ONGOING:         CopyDescriptorToEP0;
	MOVF        USB_CDC_Library_UsbDeviceRequest+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID174
	CALL        USB_CDC_Library_CopyDescriptorToEP0+0, 0
	GOTO        L_USB_CDC_Library_TokenInPID171
L_USB_CDC_Library_TokenInPID174:
;USB_CDC_Library.mpas,1036 :: 		USB_GET_STRING_DESCRIPTOR_ONGOING:  SendStringDescriptorToEP0;
	MOVF        USB_CDC_Library_UsbDeviceRequest+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID177
	CALL        USB_CDC_Library_SendStringDescriptorToEP0+0, 0
	GOTO        L_USB_CDC_Library_TokenInPID171
L_USB_CDC_Library_TokenInPID177:
;USB_CDC_Library.mpas,1038 :: 		USB_SET_ADDRESS_ONGOING:      //  FinishSetAddress;
	MOVF        USB_CDC_Library_UsbDeviceRequest+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID180
;USB_CDC_Library.mpas,1040 :: 		UsbDeviceRequest := $FF;    // clear current device request
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,1041 :: 		UsbCurrentConfig := 0;      // clear configuration
	CLRF        USB_CDC_Library_UsbCurrentConfig+0 
;USB_CDC_Library.mpas,1042 :: 		UADDR := UsbAddressPending; // set USB Address
	MOVF        USB_CDC_Library_UsbAddressPending+0, 0 
	MOVWF       UADDR+0 
;USB_CDC_Library.mpas,1043 :: 		if UsbAddressPending > 0
	MOVF        USB_CDC_Library_UsbAddressPending+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_TokenInPID182
;USB_CDC_Library.mpas,1046 :: 		UsbDeviceEnumState := USB_ADDRESS_STATE; // change status
	MOVLW       2
	MOVWF       USB_CDC_Library_UsbDeviceEnumState+0 
;USB_CDC_Library.mpas,1050 :: 		end;
L_USB_CDC_Library_TokenInPID182:
;USB_CDC_Library.mpas,1057 :: 		end;
	GOTO        L_USB_CDC_Library_TokenInPID171
L_USB_CDC_Library_TokenInPID180:
L_USB_CDC_Library_TokenInPID171:
;USB_CDC_Library.mpas,1059 :: 		end;
	GOTO        L_USB_CDC_Library_TokenInPID167
L_USB_CDC_Library_TokenInPID170:
;USB_CDC_Library.mpas,1061 :: 		1: // endpoint 1 IN
	MOVF        TokenInPID_Ep+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID186
;USB_CDC_Library.mpas,1066 :: 		end;
	GOTO        L_USB_CDC_Library_TokenInPID167
L_USB_CDC_Library_TokenInPID186:
;USB_CDC_Library.mpas,1068 :: 		2: //
	MOVF        TokenInPID_Ep+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID189
;USB_CDC_Library.mpas,1073 :: 		end;
	GOTO        L_USB_CDC_Library_TokenInPID167
L_USB_CDC_Library_TokenInPID189:
;USB_CDC_Library.mpas,1075 :: 		3: //
	MOVF        TokenInPID_Ep+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID192
;USB_CDC_Library.mpas,1077 :: 		if BDEP3INCnt = USB_CDC_BULK_OUT_EP_SIZE
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID459
	MOVLW       64
	XORWF       1053, 0 
L_USB_CDC_Library_TokenInPID459:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenInPID194
;USB_CDC_Library.mpas,1078 :: 		then SendBulkZeroLenPacket;
	CALL        USB_CDC_Library_SendBulkZeroLenPacket+0, 0
L_USB_CDC_Library_TokenInPID194:
;USB_CDC_Library.mpas,1082 :: 		end;
	GOTO        L_USB_CDC_Library_TokenInPID167
L_USB_CDC_Library_TokenInPID192:
L_USB_CDC_Library_TokenInPID167:
;USB_CDC_Library.mpas,1085 :: 		end;
L_end_TokenInPID:
	RETURN      0
; end of USB_CDC_Library_TokenInPID

USB_CDC_Library_ClassSpecificRequest:

;USB_CDC_Library.mpas,1088 :: 		begin
;USB_CDC_Library.mpas,1095 :: 		if (SetUpPacket.wIndex = USB_CDC_COMM_INTF_ID) or
	MOVLW       0
	XORWF       USB_CDC_Library_SetUpPacket+5, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest461
	MOVLW       0
	XORWF       USB_CDC_Library_SetUpPacket+4, 0 
L_USB_CDC_Library_ClassSpecificRequest461:
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
;USB_CDC_Library.mpas,1096 :: 		(SetUpPacket.wIndex = USB_CDC_DATA_INTF_ID) then
	MOVLW       0
	XORWF       USB_CDC_Library_SetUpPacket+5, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest462
	MOVLW       1
	XORWF       USB_CDC_Library_SetUpPacket+4, 0 
L_USB_CDC_Library_ClassSpecificRequest462:
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	IORWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest198
;USB_CDC_Library.mpas,1101 :: 		USB_SEND_ENCAPSULATED_COMMAND: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest203
;USB_CDC_Library.mpas,1106 :: 		UsbDeviceRequest := USB_SEND_ENCAPSULATED_COMMAND + $80;
	MOVLW       128
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,1107 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1108 :: 		end;
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest203:
;USB_CDC_Library.mpas,1110 :: 		USB_GET_ENCAPSULATED_RESPONSE: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest206
;USB_CDC_Library.mpas,1115 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1116 :: 		BuffEP0IN[0] := 'O';
	MOVLW       79
	MOVWF       1344 
;USB_CDC_Library.mpas,1117 :: 		BuffEP0IN[1] := 'K';
	MOVLW       75
	MOVWF       1345 
;USB_CDC_Library.mpas,1118 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_CDC_Library.mpas,1119 :: 		BDEP0INStat  := USB_USIE or USB_DAT1 or USB_DTSEN; // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,1120 :: 		end;
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest206:
;USB_CDC_Library.mpas,1122 :: 		USB_SET_COMM_FEATURE: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest209
;USB_CDC_Library.mpas,1128 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1129 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1130 :: 		end;
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest209:
;USB_CDC_Library.mpas,1132 :: 		USB_CLEAR_COMM_FEATURE: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest212
;USB_CDC_Library.mpas,1138 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1139 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1140 :: 		end;
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest212:
;USB_CDC_Library.mpas,1142 :: 		USB_GET_COMM_FEATURE: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest215
;USB_CDC_Library.mpas,1148 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1149 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1150 :: 		end;
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest215:
;USB_CDC_Library.mpas,1152 :: 		USB_SET_LINE_CODING: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       32
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest218
;USB_CDC_Library.mpas,1158 :: 		UsbDeviceRequest := USB_SET_LINE_CODING + $80;
	MOVLW       160
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,1159 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1160 :: 		end;
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest218:
;USB_CDC_Library.mpas,1162 :: 		USB_GET_LINE_CODING: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       33
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest221
;USB_CDC_Library.mpas,1164 :: 		BuffEP0IN[0] := lo(LineCoding.Baudrate);
	MOVF        USB_CDC_Library_LineCoding+0, 0 
	MOVWF       1344 
;USB_CDC_Library.mpas,1165 :: 		BuffEP0IN[1] := hi(LineCoding.Baudrate);
	MOVF        USB_CDC_Library_LineCoding+1, 0 
	MOVWF       1345 
;USB_CDC_Library.mpas,1166 :: 		BuffEP0IN[2] := higher(LineCoding.Baudrate);
	MOVF        USB_CDC_Library_LineCoding+2, 0 
	MOVWF       1346 
;USB_CDC_Library.mpas,1167 :: 		BuffEP0IN[3] := highest(LineCoding.Baudrate);
	MOVF        USB_CDC_Library_LineCoding+3, 0 
	MOVWF       1347 
;USB_CDC_Library.mpas,1168 :: 		BuffEP0IN[4] := LineCoding.CharFormat;
	MOVF        USB_CDC_Library_LineCoding+4, 0 
	MOVWF       1348 
;USB_CDC_Library.mpas,1169 :: 		BuffEP0IN[5] := LineCoding.ParityType;
	MOVF        USB_CDC_Library_LineCoding+5, 0 
	MOVWF       1349 
;USB_CDC_Library.mpas,1170 :: 		BuffEP0IN[6] := LineCoding.DataBits;
	MOVF        USB_CDC_Library_LineCoding+6, 0 
	MOVWF       1350 
;USB_CDC_Library.mpas,1175 :: 		EP0OutReset(USB_DAT1);                             // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1176 :: 		BDEP0INCnt   := SetUpPacket.wLength;
	MOVF        USB_CDC_Library_SetUpPacket+6, 0 
	MOVWF       1029 
;USB_CDC_Library.mpas,1177 :: 		BDEP0INStat  := USB_USIE or USB_DAT1 or USB_DTSEN; // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,1178 :: 		end;
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest221:
;USB_CDC_Library.mpas,1180 :: 		USB_SET_CONTROL_LINE_STATE: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       34
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest224
;USB_CDC_Library.mpas,1182 :: 		DummyControlLineState := SetUpPacket.wValue;
	MOVF        USB_CDC_Library_SetUpPacket+2, 0 
	MOVWF       USB_CDC_Library_DummyControlLineState+0 
	MOVF        USB_CDC_Library_SetUpPacket+3, 0 
	MOVWF       USB_CDC_Library_DummyControlLineState+1 
;USB_CDC_Library.mpas,1188 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1189 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1190 :: 		end;
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest224:
;USB_CDC_Library.mpas,1192 :: 		USB_SEND_BREAK: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       35
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_ClassSpecificRequest227
;USB_CDC_Library.mpas,1198 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1199 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1201 :: 		else
	GOTO        L_USB_CDC_Library_ClassSpecificRequest200
L_USB_CDC_Library_ClassSpecificRequest227:
;USB_CDC_Library.mpas,1208 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1209 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1210 :: 		end;
L_USB_CDC_Library_ClassSpecificRequest200:
;USB_CDC_Library.mpas,1214 :: 		end;
L_USB_CDC_Library_ClassSpecificRequest198:
;USB_CDC_Library.mpas,1215 :: 		end;
L_end_ClassSpecificRequest:
	RETURN      0
; end of USB_CDC_Library_ClassSpecificRequest

USB_CDC_Library_CheckForVendorRequest:

;USB_CDC_Library.mpas,1218 :: 		begin
;USB_CDC_Library.mpas,1222 :: 		end;
L_end_CheckForVendorRequest:
	RETURN      0
; end of USB_CDC_Library_CheckForVendorRequest

USB_CDC_Library_SetUpCDCEndpoints:

;USB_CDC_Library.mpas,1225 :: 		begin
;USB_CDC_Library.mpas,1227 :: 		LineCoding.BaudRate   := 115200;
	MOVLW       0
	MOVWF       USB_CDC_Library_LineCoding+0 
	MOVLW       194
	MOVWF       USB_CDC_Library_LineCoding+1 
	MOVLW       1
	MOVWF       USB_CDC_Library_LineCoding+2 
	MOVLW       0
	MOVWF       USB_CDC_Library_LineCoding+3 
;USB_CDC_Library.mpas,1228 :: 		LineCoding.CharFormat := 0;
	CLRF        USB_CDC_Library_LineCoding+4 
;USB_CDC_Library.mpas,1229 :: 		LineCoding.ParityType := 0;
	CLRF        USB_CDC_Library_LineCoding+5 
;USB_CDC_Library.mpas,1230 :: 		LineCoding.Databits   := 8;
	MOVLW       8
	MOVWF       USB_CDC_Library_LineCoding+6 
;USB_CDC_Library.mpas,1232 :: 		BDEP2INAdr   := word(@BuffEP2IN);
	MOVLW       USB_CDC_Library_BuffEP2IN+0
	MOVWF       1046 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP2IN+0)
	MOVWF       1047 
;USB_CDC_Library.mpas,1233 :: 		BDEP2INStat  := USB_UCPU or USB_DAT1;
	MOVLW       64
	MOVWF       1044 
;USB_CDC_Library.mpas,1235 :: 		BDEP3OUTAdr  := word(@BuffEP3OUT);
	MOVLW       USB_CDC_Library_BuffEP3OUT+0
	MOVWF       1050 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP3OUT+0)
	MOVWF       1051 
;USB_CDC_Library.mpas,1236 :: 		BDEP3OUTCnt  := USB_CDC_BULK_OUT_EP_SIZE;
	MOVLW       64
	MOVWF       1049 
;USB_CDC_Library.mpas,1237 :: 		BDEP3OUTStat := USB_USIE or USB_DAT0 or USB_DTSEN;
	MOVLW       136
	MOVWF       1048 
;USB_CDC_Library.mpas,1239 :: 		BDEP3INAdr   := word(@BuffEP3IN);
	MOVLW       USB_CDC_Library_BuffEP3IN+0
	MOVWF       1054 
	MOVLW       hi_addr(USB_CDC_Library_BuffEP3IN+0)
	MOVWF       1055 
;USB_CDC_Library.mpas,1240 :: 		BDEP3INStat  := USB_UCPU or USB_DAT1;
	MOVLW       64
	MOVWF       1052 
;USB_CDC_Library.mpas,1242 :: 		UEP2         := (USB_EP_IN or USB_HSHK_EN);      // enable com pipe
	MOVLW       26
	MOVWF       UEP2+0 
;USB_CDC_Library.mpas,1243 :: 		UEP3         := (USB_EP_OUT_IN or USB_HSHK_EN);  // enable data pipes
	MOVLW       30
	MOVWF       UEP3+0 
;USB_CDC_Library.mpas,1244 :: 		end;
L_end_SetUpCDCEndpoints:
	RETURN      0
; end of USB_CDC_Library_SetUpCDCEndpoints

USB_CDC_Library_TokenSetupPID:

;USB_CDC_Library.mpas,1250 :: 		begin
;USB_CDC_Library.mpas,1251 :: 		UsbDeviceRequest := $FF; // clear the device request
	MOVLW       255
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,1254 :: 		Dst := ^byte(@SetupPacket);
	MOVLW       USB_CDC_Library_SetUpPacket+0
	MOVWF       TokenSetupPID_Dst+0 
	MOVLW       hi_addr(USB_CDC_Library_SetUpPacket+0)
	MOVWF       TokenSetupPID_Dst+1 
;USB_CDC_Library.mpas,1255 :: 		Src := ^byte(BufferDescriptor^.Address);
	MOVLW       2
	ADDWF       USB_CDC_Library_BufferDescriptor+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      USB_CDC_Library_BufferDescriptor+1, 0 
	MOVWF       R1 
	MOVFF       R0, FSR0L
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       TokenSetupPID_Src+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       TokenSetupPID_Src+1 
;USB_CDC_Library.mpas,1256 :: 		for I := 0 to (SizeOf(SetupPacket) - 1) do
	CLRF        TokenSetupPID_I+0 
L_USB_CDC_Library_TokenSetupPID232:
;USB_CDC_Library.mpas,1258 :: 		Dst^ := Src^;
	MOVFF       TokenSetupPID_Src+0, FSR0L
	MOVFF       TokenSetupPID_Src+1, FSR0H
	MOVFF       TokenSetupPID_Dst+0, FSR1L
	MOVFF       TokenSetupPID_Dst+1, FSR1H
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;USB_CDC_Library.mpas,1259 :: 		Inc(Src);
	INFSNZ      TokenSetupPID_Src+0, 1 
	INCF        TokenSetupPID_Src+1, 1 
;USB_CDC_Library.mpas,1260 :: 		Inc(Dst);
	INFSNZ      TokenSetupPID_Dst+0, 1 
	INCF        TokenSetupPID_Dst+1, 1 
;USB_CDC_Library.mpas,1261 :: 		end;
	MOVF        TokenSetupPID_I+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID235
	INCF        TokenSetupPID_I+0, 1 
	GOTO        L_USB_CDC_Library_TokenSetupPID232
L_USB_CDC_Library_TokenSetupPID235:
;USB_CDC_Library.mpas,1263 :: 		BDEP0OUTStat := 0;     //
	CLRF        1024 
;USB_CDC_Library.mpas,1264 :: 		BDEP0INStat  := (USB_UCPU or USB_DAT0 or USB_DTSEN); // return the IN buffer to us (dequeue any pending requests)
	MOVLW       8
	MOVWF       1028 
;USB_CDC_Library.mpas,1265 :: 		UCON.PKTDIS := 0; // enable setup packets
	BCF         UCON+0, 4 
;USB_CDC_Library.mpas,1282 :: 		USB_STD_HOST_TO_DEVICE: //
	MOVF        USB_CDC_Library_SetUpPacket+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID239
;USB_CDC_Library.mpas,1286 :: 		USB_CLEAR_FEATURE:               // ClearDeviceFeature;
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID243
;USB_CDC_Library.mpas,1288 :: 		if SetUpPacket.wValue = 1 then // device remote wakeup
	MOVLW       0
	XORWF       USB_CDC_Library_SetUpPacket+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID466
	MOVLW       1
	XORWF       USB_CDC_Library_SetUpPacket+2, 0 
L_USB_CDC_Library_TokenSetupPID466:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID245
;USB_CDC_Library.mpas,1290 :: 		Usb_Status_Device.1 := 0;
	BCF         USB_CDC_Library_Usb_Status_Device+0, 1 
;USB_CDC_Library.mpas,1291 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1292 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1293 :: 		end else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID246
L_USB_CDC_Library_TokenSetupPID245:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID246:
;USB_CDC_Library.mpas,1294 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID240
L_USB_CDC_Library_TokenSetupPID243:
;USB_CDC_Library.mpas,1296 :: 		USB_SET_FEATURE:                 // SetDeviceFeature
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID249
;USB_CDC_Library.mpas,1298 :: 		if SetUpPacket.wValue = 1 then // device remote wakeup
	MOVLW       0
	XORWF       USB_CDC_Library_SetUpPacket+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID467
	MOVLW       1
	XORWF       USB_CDC_Library_SetUpPacket+2, 0 
L_USB_CDC_Library_TokenSetupPID467:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID251
;USB_CDC_Library.mpas,1300 :: 		Usb_Status_Device.1 := 1;
	BSF         USB_CDC_Library_Usb_Status_Device+0, 1 
;USB_CDC_Library.mpas,1301 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1302 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1303 :: 		end else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID252
L_USB_CDC_Library_TokenSetupPID251:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID252:
;USB_CDC_Library.mpas,1304 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID240
L_USB_CDC_Library_TokenSetupPID249:
;USB_CDC_Library.mpas,1306 :: 		USB_SET_ADDRESS:                           //SetAddress;
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID255
;USB_CDC_Library.mpas,1308 :: 		UsbDeviceRequest := USB_SET_ADDRESS_ONGOING;
	MOVLW       3
	MOVWF       USB_CDC_Library_UsbDeviceRequest+0 
;USB_CDC_Library.mpas,1309 :: 		UsbAddressPending := SetUpPacket.wValue; // USB address
	MOVF        USB_CDC_Library_SetUpPacket+2, 0 
	MOVWF       USB_CDC_Library_UsbAddressPending+0 
;USB_CDC_Library.mpas,1310 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1311 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_CDC_Library.mpas,1312 :: 		BDEP0INStat := (USB_USIE or USB_DAT1 or USB_DTSEN); // echo the buffer
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,1313 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID240
L_USB_CDC_Library_TokenSetupPID255:
;USB_CDC_Library.mpas,1315 :: 		USB_SET_CONFIGURATION:                     // SetConfiguration;
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID258
;USB_CDC_Library.mpas,1317 :: 		Config := Lo(SetUpPacket.wValue);
	MOVF        USB_CDC_Library_SetUpPacket+2, 0 
	MOVWF       TokenSetupPID_Config+0 
;USB_CDC_Library.mpas,1318 :: 		if Config <= USB_NUM_CONFIGURATIONS then
	MOVF        USB_CDC_Library_SetUpPacket+2, 0 
	SUBLW       1
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_TokenSetupPID260
;USB_CDC_Library.mpas,1320 :: 		UsbCurrentConfig := Config;            // set configuration
	MOVF        TokenSetupPID_Config+0, 0 
	MOVWF       USB_CDC_Library_UsbCurrentConfig+0 
;USB_CDC_Library.mpas,1321 :: 		if Config > 0 then
	MOVF        TokenSetupPID_Config+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_CDC_Library_TokenSetupPID263
;USB_CDC_Library.mpas,1323 :: 		UsbDeviceEnumState := USB_CONFIG_STATE;
	MOVLW       3
	MOVWF       USB_CDC_Library_UsbDeviceEnumState+0 
;USB_CDC_Library.mpas,1327 :: 		SetUpCDCEndpoints;
	CALL        USB_CDC_Library_SetUpCDCEndpoints+0, 0
;USB_CDC_Library.mpas,1328 :: 		end
	GOTO        L_USB_CDC_Library_TokenSetupPID264
;USB_CDC_Library.mpas,1329 :: 		else
L_USB_CDC_Library_TokenSetupPID263:
;USB_CDC_Library.mpas,1331 :: 		UsbDeviceEnumState := USB_ADDRESS_STATE; // no configuration selected
	MOVLW       2
	MOVWF       USB_CDC_Library_UsbDeviceEnumState+0 
;USB_CDC_Library.mpas,1335 :: 		end;
L_USB_CDC_Library_TokenSetupPID264:
;USB_CDC_Library.mpas,1336 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1337 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1344 :: 		end else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID261
L_USB_CDC_Library_TokenSetupPID260:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID261:
;USB_CDC_Library.mpas,1347 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID240
L_USB_CDC_Library_TokenSetupPID258:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID240:
;USB_CDC_Library.mpas,1350 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID236
L_USB_CDC_Library_TokenSetupPID239:
;USB_CDC_Library.mpas,1352 :: 		USB_STD_HOST_TO_INTERFACE: //
	MOVF        USB_CDC_Library_SetUpPacket+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID267
;USB_CDC_Library.mpas,1355 :: 		USB_CLEAR_FEATURE:      // ClearInterfaceFeature;
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID271
;USB_CDC_Library.mpas,1360 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1361 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1362 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID268
L_USB_CDC_Library_TokenSetupPID271:
;USB_CDC_Library.mpas,1364 :: 		USB_SET_FEATURE:        // SetInterfaceFeature
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID274
;USB_CDC_Library.mpas,1369 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1370 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1371 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID268
L_USB_CDC_Library_TokenSetupPID274:
;USB_CDC_Library.mpas,1373 :: 		USB_SET_INTERFACE:      // SetInterface;
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       11
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID277
;USB_CDC_Library.mpas,1375 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE then
	MOVF        USB_CDC_Library_UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID279
;USB_CDC_Library.mpas,1377 :: 		UsbInterface := SetupPacket.wIndex;
	MOVF        USB_CDC_Library_SetUpPacket+4, 0 
	MOVWF       USB_CDC_Library_UsbInterface+0 
;USB_CDC_Library.mpas,1378 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1379 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1380 :: 		end else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID280
L_USB_CDC_Library_TokenSetupPID279:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID280:
;USB_CDC_Library.mpas,1383 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID268
L_USB_CDC_Library_TokenSetupPID277:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID268:
;USB_CDC_Library.mpas,1386 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID236
L_USB_CDC_Library_TokenSetupPID267:
;USB_CDC_Library.mpas,1388 :: 		USB_STD_HOST_TO_ENDPOINT: //
	MOVF        USB_CDC_Library_SetUpPacket+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID283
;USB_CDC_Library.mpas,1390 :: 		Ep := SetUpPacket.wIndex and $8F;  // endpoint number
	MOVLW       143
	ANDWF       USB_CDC_Library_SetUpPacket+4, 0 
	MOVWF       TokenSetupPID_Ep+0 
;USB_CDC_Library.mpas,1394 :: 		USB_CLEAR_FEATURE:      // ClearEndpointFeature;
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID287
;USB_CDC_Library.mpas,1397 :: 		USB_EP02_IN  : BDEP2INStat  := (USB_UCPU or USB_DAT1);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       130
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID291
	MOVLW       64
	MOVWF       1044 
	GOTO        L_USB_CDC_Library_TokenSetupPID288
L_USB_CDC_Library_TokenSetupPID291:
;USB_CDC_Library.mpas,1398 :: 		USB_EP03_OUT : BDEP3OUTStat := (USB_USIE or USB_DAT0 or USB_DTSEN);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID294
	MOVLW       136
	MOVWF       1048 
	GOTO        L_USB_CDC_Library_TokenSetupPID288
L_USB_CDC_Library_TokenSetupPID294:
;USB_CDC_Library.mpas,1399 :: 		USB_EP03_IN  : BDEP3INStat  := (USB_UCPU or USB_DAT1)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       131
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID297
	MOVLW       64
	MOVWF       1052 
;USB_CDC_Library.mpas,1400 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID288
L_USB_CDC_Library_TokenSetupPID297:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID288:
;USB_CDC_Library.mpas,1402 :: 		if not EP0Stalled then
	CALL        USB_CDC_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID299
;USB_CDC_Library.mpas,1404 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1405 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1406 :: 		end;
L_USB_CDC_Library_TokenSetupPID299:
;USB_CDC_Library.mpas,1410 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID284
L_USB_CDC_Library_TokenSetupPID287:
;USB_CDC_Library.mpas,1412 :: 		USB_SET_FEATURE:        // SetEndpointFeature
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID303
;USB_CDC_Library.mpas,1415 :: 		USB_EP02_IN  : BDEP2INStat  := (USB_USIE or USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       130
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID307
	MOVLW       132
	MOVWF       1044 
	GOTO        L_USB_CDC_Library_TokenSetupPID304
L_USB_CDC_Library_TokenSetupPID307:
;USB_CDC_Library.mpas,1416 :: 		USB_EP03_OUT : BDEP3OUTStat := (USB_USIE or USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID310
	MOVLW       132
	MOVWF       1048 
	GOTO        L_USB_CDC_Library_TokenSetupPID304
L_USB_CDC_Library_TokenSetupPID310:
;USB_CDC_Library.mpas,1417 :: 		USB_EP03_IN  : BDEP3INStat  := (USB_USIE or USB_BSTALL)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       131
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID313
	MOVLW       132
	MOVWF       1052 
;USB_CDC_Library.mpas,1418 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID304
L_USB_CDC_Library_TokenSetupPID313:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID304:
;USB_CDC_Library.mpas,1420 :: 		if not EP0Stalled then
	CALL        USB_CDC_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID315
;USB_CDC_Library.mpas,1422 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1423 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1424 :: 		end;
L_USB_CDC_Library_TokenSetupPID315:
;USB_CDC_Library.mpas,1430 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID284
L_USB_CDC_Library_TokenSetupPID303:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID284:
;USB_CDC_Library.mpas,1433 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID236
L_USB_CDC_Library_TokenSetupPID283:
;USB_CDC_Library.mpas,1435 :: 		USB_STD_DEVICE_TO_HOST: //
	MOVF        USB_CDC_Library_SetUpPacket+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID319
;USB_CDC_Library.mpas,1438 :: 		USB_GET_CONFIGURATION:  //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID323
;USB_CDC_Library.mpas,1440 :: 		BuffEP0IN[0] := 0;
	CLRF        1344 
;USB_CDC_Library.mpas,1441 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE
	MOVF        USB_CDC_Library_UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID325
;USB_CDC_Library.mpas,1442 :: 		then BuffEP0IN[0] := UsbCurrentConfig;
	MOVF        USB_CDC_Library_UsbCurrentConfig+0, 0 
	MOVWF       1344 
L_USB_CDC_Library_TokenSetupPID325:
;USB_CDC_Library.mpas,1443 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1444 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_CDC_Library.mpas,1445 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,1446 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID320
L_USB_CDC_Library_TokenSetupPID323:
;USB_CDC_Library.mpas,1448 :: 		USB_GET_DESCRIPTOR:     GetDescriptor;
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID329
	CALL        USB_CDC_Library_GetDescriptor+0, 0
	GOTO        L_USB_CDC_Library_TokenSetupPID320
L_USB_CDC_Library_TokenSetupPID329:
;USB_CDC_Library.mpas,1450 :: 		USB_GET_STATUS:         //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID332
;USB_CDC_Library.mpas,1452 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1453 :: 		BuffEP0IN[0] := Usb_Status_Device;
	MOVF        USB_CDC_Library_Usb_Status_Device+0, 0 
	MOVWF       1344 
;USB_CDC_Library.mpas,1454 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_CDC_Library.mpas,1455 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_CDC_Library.mpas,1456 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,1459 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID320
L_USB_CDC_Library_TokenSetupPID332:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID320:
;USB_CDC_Library.mpas,1462 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID236
L_USB_CDC_Library_TokenSetupPID319:
;USB_CDC_Library.mpas,1464 :: 		USB_STD_INTERFACE_TO_HOST: //
	MOVF        USB_CDC_Library_SetUpPacket+0, 0 
	XORLW       129
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID335
;USB_CDC_Library.mpas,1467 :: 		USB_GET_INTERFACE:      //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID339
;USB_CDC_Library.mpas,1470 :: 		if UsbDeviceEnumState <> USB_ADDRESS_STATE then
	MOVF        USB_CDC_Library_UsbDeviceEnumState+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID341
;USB_CDC_Library.mpas,1472 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1473 :: 		BuffEP0IN[0] := UsbInterface;
	MOVF        USB_CDC_Library_UsbInterface+0, 0 
	MOVWF       1344 
;USB_CDC_Library.mpas,1474 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_CDC_Library.mpas,1475 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,1476 :: 		end else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID342
L_USB_CDC_Library_TokenSetupPID341:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID342:
;USB_CDC_Library.mpas,1477 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID336
L_USB_CDC_Library_TokenSetupPID339:
;USB_CDC_Library.mpas,1479 :: 		USB_GET_STATUS:         //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID345
;USB_CDC_Library.mpas,1481 :: 		if UsbDeviceEnumState <> USB_ADDRESS_STATE then
	MOVF        USB_CDC_Library_UsbDeviceEnumState+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID347
;USB_CDC_Library.mpas,1483 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1484 :: 		BuffEP0IN[0] := 0;
	CLRF        1344 
;USB_CDC_Library.mpas,1485 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_CDC_Library.mpas,1486 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_CDC_Library.mpas,1487 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: go
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,1488 :: 		end else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID348
L_USB_CDC_Library_TokenSetupPID347:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID348:
;USB_CDC_Library.mpas,1489 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID336
L_USB_CDC_Library_TokenSetupPID345:
;USB_CDC_Library.mpas,1491 :: 		USB_GET_DESCRIPTOR:     GetDescriptor
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID351
	CALL        USB_CDC_Library_GetDescriptor+0, 0
;USB_CDC_Library.mpas,1493 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID336
L_USB_CDC_Library_TokenSetupPID351:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID336:
;USB_CDC_Library.mpas,1496 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID236
L_USB_CDC_Library_TokenSetupPID335:
;USB_CDC_Library.mpas,1498 :: 		USB_STD_ENDPOINT_TO_HOST: //
	MOVF        USB_CDC_Library_SetUpPacket+0, 0 
	XORLW       130
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID354
;USB_CDC_Library.mpas,1500 :: 		Ep := SetUpPacket.wIndex and $8F;  // endpoint number
	MOVLW       143
	ANDWF       USB_CDC_Library_SetUpPacket+4, 0 
	MOVWF       TokenSetupPID_Ep+0 
;USB_CDC_Library.mpas,1504 :: 		USB_GET_STATUS:         //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID358
;USB_CDC_Library.mpas,1508 :: 		USB_EP00_OUT : BuffEP0IN[0] := bit_(BDEP0OUTStat and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID362
	MOVLW       4
	ANDWF       1024, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
	GOTO        L_USB_CDC_Library_TokenSetupPID359
L_USB_CDC_Library_TokenSetupPID362:
;USB_CDC_Library.mpas,1509 :: 		USB_EP00_IN  : BuffEP0IN[0] := bit_(BDEP0INStat  and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID365
	MOVLW       4
	ANDWF       1028, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
	GOTO        L_USB_CDC_Library_TokenSetupPID359
L_USB_CDC_Library_TokenSetupPID365:
;USB_CDC_Library.mpas,1510 :: 		USB_EP02_IN  : BuffEP0IN[0] := bit_(BDEP2INStat  and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       130
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID368
	MOVLW       4
	ANDWF       1044, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
	GOTO        L_USB_CDC_Library_TokenSetupPID359
L_USB_CDC_Library_TokenSetupPID368:
;USB_CDC_Library.mpas,1511 :: 		USB_EP03_OUT : BuffEP0IN[0] := bit_(BDEP3OUTStat and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID371
	MOVLW       4
	ANDWF       1048, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
	GOTO        L_USB_CDC_Library_TokenSetupPID359
L_USB_CDC_Library_TokenSetupPID371:
;USB_CDC_Library.mpas,1512 :: 		USB_EP03_IN  : BuffEP0IN[0] := bit_(BDEP3INStat  and USB_BSTALL)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       131
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID374
	MOVLW       4
	ANDWF       1052, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
;USB_CDC_Library.mpas,1513 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID359
L_USB_CDC_Library_TokenSetupPID374:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID359:
;USB_CDC_Library.mpas,1515 :: 		if not Ep0Stalled then
	CALL        USB_CDC_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID376
;USB_CDC_Library.mpas,1517 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1518 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_CDC_Library.mpas,1519 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_CDC_Library.mpas,1520 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: go
	MOVLW       200
	MOVWF       1028 
;USB_CDC_Library.mpas,1521 :: 		end;
L_USB_CDC_Library_TokenSetupPID376:
;USB_CDC_Library.mpas,1522 :: 		end;
	GOTO        L_USB_CDC_Library_TokenSetupPID355
L_USB_CDC_Library_TokenSetupPID358:
;USB_CDC_Library.mpas,1524 :: 		USB_SYNCH_FRAME: //
	MOVF        USB_CDC_Library_SetUpPacket+1, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID380
;USB_CDC_Library.mpas,1529 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_CDC_Library_EP0OutReset+0, 0
;USB_CDC_Library.mpas,1530 :: 		SendAckToHost; // send acknowledge
	CALL        USB_CDC_Library_SendAckToHost+0, 0
;USB_CDC_Library.mpas,1533 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID355
L_USB_CDC_Library_TokenSetupPID380:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID355:
;USB_CDC_Library.mpas,1538 :: 		else
	GOTO        L_USB_CDC_Library_TokenSetupPID236
L_USB_CDC_Library_TokenSetupPID354:
;USB_CDC_Library.mpas,1540 :: 		case (SetUpPacket.bmRequestType shr 5)and 3 of
	MOVLW       5
	MOVWF       R1 
	MOVF        USB_CDC_Library_SetUpPacket+0, 0 
	MOVWF       R0 
	MOVF        R1, 0 
L_USB_CDC_Library_TokenSetupPID468:
	BZ          L_USB_CDC_Library_TokenSetupPID469
	RRCF        R0, 1 
	BCF         R0, 7 
	ADDLW       255
	GOTO        L_USB_CDC_Library_TokenSetupPID468
L_USB_CDC_Library_TokenSetupPID469:
	MOVLW       3
	ANDWF       R0, 0 
	MOVWF       FLOC_USB_CDC_Library_TokenSetupPID+0 
;USB_CDC_Library.mpas,1546 :: 		USB_CLASS :  ClassSpecificRequest;      // Class specific request (interface)
	MOVF        FLOC_USB_CDC_Library_TokenSetupPID+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID384
	CALL        USB_CDC_Library_ClassSpecificRequest+0, 0
	GOTO        L_USB_CDC_Library_TokenSetupPID381
L_USB_CDC_Library_TokenSetupPID384:
;USB_CDC_Library.mpas,1547 :: 		USB_VENDOR:  CheckforVendorRequest
	MOVF        FLOC_USB_CDC_Library_TokenSetupPID+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_CDC_Library_TokenSetupPID387
	CALL        USB_CDC_Library_CheckForVendorRequest+0, 0
;USB_CDC_Library.mpas,1548 :: 		else StallEP0;
	GOTO        L_USB_CDC_Library_TokenSetupPID381
L_USB_CDC_Library_TokenSetupPID387:
	CALL        USB_CDC_Library_StallEP0+0, 0
L_USB_CDC_Library_TokenSetupPID381:
;USB_CDC_Library.mpas,1550 :: 		end;
L_USB_CDC_Library_TokenSetupPID236:
;USB_CDC_Library.mpas,1552 :: 		end;
L_end_TokenSetupPID:
	RETURN      0
; end of USB_CDC_Library_TokenSetupPID

_USB_Interrupt:

;USB_CDC_Library.mpas,1556 :: 		begin
;USB_CDC_Library.mpas,1558 :: 		if PIR2.USBIF = 1 then // usb interrupt occurred
	BTFSS       PIR2+0, 5 
	GOTO        L__USB_Interrupt390
;USB_CDC_Library.mpas,1560 :: 		PIR2.USBIF := 0;
	BCF         PIR2+0, 5 
;USB_CDC_Library.mpas,1562 :: 		Tmp := UIR and UIE; // get the enabled interrupts
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_CDC_Library.mpas,1564 :: 		while Tmp > 0 do    // some interrupts have occured
L__USB_Interrupt393:
	MOVF        USB_Interrupt_Tmp+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_Interrupt394
;USB_CDC_Library.mpas,1566 :: 		while Tmp.TRNIF = 1 do
L__USB_Interrupt398:
	BTFSS       USB_Interrupt_Tmp+0, 3 
	GOTO        L__USB_Interrupt399
;USB_CDC_Library.mpas,1569 :: 		USTATCopy := USTAT; // get copy of the status register
	MOVF        USTAT+0, 0 
	MOVWF       USB_CDC_Library_USTATCopy+0 
;USB_CDC_Library.mpas,1570 :: 		BufferDescriptor := ^TBufferDescriptor(@BDEP0OUTStat) + ((USTATCopy shr 2) and $1F); // create pointer to BufferDescriptor of EPx
	MOVF        USB_CDC_Library_USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       31
	ANDWF       R0, 0 
	MOVWF       R3 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       USB_CDC_Library_BDEP0OUTStat+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(USB_CDC_Library_BDEP0OUTStat+0)
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       USB_CDC_Library_BufferDescriptor+0 
	MOVF        R1, 0 
	MOVWF       USB_CDC_Library_BufferDescriptor+1 
;USB_CDC_Library.mpas,1572 :: 		UIR.TRNIF := 0;     // clear the interrupt flag (advances fifo: enable further activity)
	BCF         UIR+0, 3 
;USB_CDC_Library.mpas,1574 :: 		if BufferDescriptor^.Status.UOWN = 0 then
	MOVF        R0, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0L
	MOVFF       R3, FSR0H
	BTFSC       POSTINC0+0, 7 
	GOTO        L__USB_Interrupt403
;USB_CDC_Library.mpas,1576 :: 		Pid := (BufferDescriptor^.Status shr 2) and $0F; // get the PID out of the endpoint buffer status
	MOVFF       USB_CDC_Library_BufferDescriptor+0, FSR0L
	MOVFF       USB_CDC_Library_BufferDescriptor+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       USB_Interrupt_Pid+0 
;USB_CDC_Library.mpas,1578 :: 		USB_TOKEN_IN:     TokenInPid;
	MOVF        R1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt408
	CALL        USB_CDC_Library_TokenInPID+0, 0
	GOTO        L__USB_Interrupt405
L__USB_Interrupt408:
;USB_CDC_Library.mpas,1579 :: 		USB_TOKEN_OUT:    TokenOutPid;
	MOVF        USB_Interrupt_Pid+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt411
	CALL        USB_CDC_Library_TokenOutPID+0, 0
	GOTO        L__USB_Interrupt405
L__USB_Interrupt411:
;USB_CDC_Library.mpas,1580 :: 		USB_TOKEN_SETUP:  TokenSetupPID
	MOVF        USB_Interrupt_Pid+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt414
	CALL        USB_CDC_Library_TokenSetupPID+0, 0
;USB_CDC_Library.mpas,1581 :: 		else StallEP0;
	GOTO        L__USB_Interrupt405
L__USB_Interrupt414:
	CALL        USB_CDC_Library_StallEP0+0, 0
L__USB_Interrupt405:
;USB_CDC_Library.mpas,1583 :: 		end;
L__USB_Interrupt403:
;USB_CDC_Library.mpas,1584 :: 		Tmp := UIR and UIE;
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_CDC_Library.mpas,1585 :: 		end;
	GOTO        L__USB_Interrupt398
L__USB_Interrupt399:
;USB_CDC_Library.mpas,1587 :: 		if Tmp.URSTIF  = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 0 
	GOTO        L__USB_Interrupt416
;USB_CDC_Library.mpas,1592 :: 		UsbReset;
	CALL        USB_CDC_Library_UsbReset+0, 0
;USB_CDC_Library.mpas,1593 :: 		end;
L__USB_Interrupt416:
;USB_CDC_Library.mpas,1595 :: 		if Tmp.STALLIF = 1 then UIR.STALLIF := 0; // clear interrupt flag
	BTFSS       USB_Interrupt_Tmp+0, 5 
	GOTO        L__USB_Interrupt419
	BCF         UIR+0, 5 
L__USB_Interrupt419:
;USB_CDC_Library.mpas,1597 :: 		if Tmp.IDLEIF  = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 4 
	GOTO        L__USB_Interrupt422
;USB_CDC_Library.mpas,1599 :: 		IsIdle := true;
	MOVLW       255
	MOVWF       USB_CDC_Library_IsIdle+0 
;USB_CDC_Library.mpas,1600 :: 		UIE.IDLEIE := 0; // disable the idle interrupt
	BCF         UIE+0, 4 
;USB_CDC_Library.mpas,1601 :: 		UIR.SOFIF  := 0;
	BCF         UIR+0, 6 
;USB_CDC_Library.mpas,1602 :: 		UIE.SOFIE :=  1; // enable the SOF interrupt
	BSF         UIE+0, 6 
;USB_CDC_Library.mpas,1603 :: 		UIR.IDLEIF := 0; // clear interrupt flag
	BCF         UIR+0, 4 
;USB_CDC_Library.mpas,1604 :: 		end;
L__USB_Interrupt422:
;USB_CDC_Library.mpas,1606 :: 		if Tmp.SOFIF = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 6 
	GOTO        L__USB_Interrupt425
;USB_CDC_Library.mpas,1608 :: 		IsIdle     := false; // clear the "is Idle" bit 0
	CLRF        USB_CDC_Library_IsIdle+0 
;USB_CDC_Library.mpas,1609 :: 		UIE.SOFIE  := 0;     // disable the SOF interrupt
	BCF         UIE+0, 6 
;USB_CDC_Library.mpas,1610 :: 		UIR.IDLEIF := 0;
	BCF         UIR+0, 4 
;USB_CDC_Library.mpas,1611 :: 		UIE.IDLEIE := 1;     // enable the idle interrupt
	BSF         UIE+0, 4 
;USB_CDC_Library.mpas,1612 :: 		UIR.SOFIF  := 0;     // clear interrupt flag
	BCF         UIR+0, 6 
;USB_CDC_Library.mpas,1613 :: 		end;
L__USB_Interrupt425:
;USB_CDC_Library.mpas,1615 :: 		Tmp := UIR and UIE; // get the enabled interrupts
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_CDC_Library.mpas,1616 :: 		end;
	GOTO        L__USB_Interrupt393
L__USB_Interrupt394:
;USB_CDC_Library.mpas,1618 :: 		end;
L__USB_Interrupt390:
;USB_CDC_Library.mpas,1620 :: 		end;
L_end_USB_Interrupt:
	RETURN      0
; end of _USB_Interrupt
