
_USB_HID_Read:

;USB_HID_Library.mpas,416 :: 		begin
;USB_HID_Library.mpas,417 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_HID_Library.mpas,419 :: 		if BDEP1OUTStat.UOWN = 0
	BTFSC       1032, 7 
	GOTO        L__USB_HID_Read2
;USB_HID_Library.mpas,420 :: 		then Result := true
	MOVLW       255
	MOVWF       USB_HID_Read_local_result+0 
	GOTO        L__USB_HID_Read3
;USB_HID_Library.mpas,421 :: 		else Result := false;
L__USB_HID_Read2:
	CLRF        USB_HID_Read_local_result+0 
L__USB_HID_Read3:
;USB_HID_Library.mpas,423 :: 		if Result then  // PIC owns the buffer
	MOVF        USB_HID_Read_local_result+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__USB_HID_Read5
;USB_HID_Library.mpas,426 :: 		ByteCount := BDEP1OUTCnt;   // get bytecount of EP1 out buffer
	MOVF        1033, 0 
	MOVWF       USB_HID_Read_ByteCount+0 
;USB_HID_Library.mpas,427 :: 		if ByteCount > MaxLen then ByteCount := MaxLen;
	MOVF        USB_HID_Read_ByteCount+0, 0 
	SUBWF       FARG_USB_HID_Read_MaxLen+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_HID_Read8
	MOVF        FARG_USB_HID_Read_MaxLen+0, 0 
	MOVWF       USB_HID_Read_ByteCount+0 
L__USB_HID_Read8:
;USB_HID_Library.mpas,429 :: 		if ByteCount > 0 then       // non empty
	MOVF        USB_HID_Read_ByteCount+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_HID_Read11
;USB_HID_Library.mpas,431 :: 		SrcPtr := ^byte(BDEP1OUTAdr);    // Source data pointer
	MOVF        1034, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        1035, 0 
	MOVWF       FARG_memcpy_p2+1 
;USB_HID_Library.mpas,432 :: 		memcpy(DstPtr, SrcPtr, ByteCount);
	MOVF        FARG_USB_HID_Read_DstPtr+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        FARG_USB_HID_Read_DstPtr+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        USB_HID_Read_ByteCount+0, 0 
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;USB_HID_Library.mpas,433 :: 		end;
L__USB_HID_Read11:
;USB_HID_Library.mpas,436 :: 		BDEP1OUTCnt  := USB_BUFF_SIZE;              // bytecount (= maximum = USB_BUFF_SIZE)
	MOVLW       64
	MOVWF       1033 
;USB_HID_Library.mpas,437 :: 		BDEP1OUTStat := BDEP1OUTStat and USB_DTSMask;   // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1032, 1 
;USB_HID_Library.mpas,438 :: 		BDEP1OUTStat := BDEP1OUTStat xor USB_DTSMask;   // toggle data 0/1
	BTG         1032, 6 
;USB_HID_Library.mpas,439 :: 		BDEP1OUTStat := BDEP1OUTStat OR  USB_DTSEN; // set the DTS bit
	BSF         1032, 3 
;USB_HID_Library.mpas,440 :: 		BDEP1OUTStat := BDEP1OUTStat OR  USB_USIE;  // set the UOWN bit
	BSF         1032, 7 
;USB_HID_Library.mpas,442 :: 		end;
L__USB_HID_Read5:
;USB_HID_Library.mpas,443 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_HID_Library.mpas,444 :: 		end;
	MOVF        USB_HID_Read_local_result+0, 0 
	MOVWF       R0 
L_end_USB_HID_Read:
	RETURN      0
; end of _USB_HID_Read

_USB_HID_Write:

;USB_HID_Library.mpas,449 :: 		begin
;USB_HID_Library.mpas,450 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_HID_Library.mpas,452 :: 		if (BDEP1INStat.UOWN = 0)
	BTFSC       1036, 7 
	GOTO        L__USB_HID_Write15
;USB_HID_Library.mpas,453 :: 		then Result := true
	MOVLW       255
	MOVWF       USB_HID_Write_local_result+0 
	GOTO        L__USB_HID_Write16
;USB_HID_Library.mpas,454 :: 		else Result := false;
L__USB_HID_Write15:
	CLRF        USB_HID_Write_local_result+0 
L__USB_HID_Write16:
;USB_HID_Library.mpas,456 :: 		if Result{ = true} then
	MOVF        USB_HID_Write_local_result+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__USB_HID_Write18
;USB_HID_Library.mpas,459 :: 		DstPtr := @BuffEP1IN;    // get destination address
	MOVLW       USB_HID_Library_BuffEP1IN+0
	MOVWF       USB_HID_Write_DstPtr+0 
	MOVLW       hi_addr(USB_HID_Library_BuffEP1IN+0)
	MOVWF       USB_HID_Write_DstPtr+1 
;USB_HID_Library.mpas,461 :: 		if ByteCount > 0 then memcpy(DstPtr, SrcPtr, ByteCount);   // fill the transmit buffer
	MOVF        FARG_USB_HID_Write_ByteCount+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_HID_Write21
	MOVF        USB_HID_Write_DstPtr+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        USB_HID_Write_DstPtr+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        FARG_USB_HID_Write_SrcPtr+0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        FARG_USB_HID_Write_SrcPtr+1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVF        FARG_USB_HID_Write_ByteCount+0, 0 
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
L__USB_HID_Write21:
;USB_HID_Library.mpas,464 :: 		if (ByteCount < HID_INPUT_REPORT_BYTES) then
	MOVLW       10
	SUBWF       FARG_USB_HID_Write_ByteCount+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_HID_Write24
;USB_HID_Library.mpas,466 :: 		DstPtr := @BuffEP1IN + ByteCount;
	MOVLW       USB_HID_Library_BuffEP1IN+0
	MOVWF       R0 
	MOVLW       hi_addr(USB_HID_Library_BuffEP1IN+0)
	MOVWF       R1 
	MOVF        FARG_USB_HID_Write_ByteCount+0, 0 
	ADDWF       R0, 1 
	BTFSC       STATUS+0, 0 
	INCF        R1, 1 
	MOVF        R0, 0 
	MOVWF       USB_HID_Write_DstPtr+0 
	MOVF        R1, 0 
	MOVWF       USB_HID_Write_DstPtr+1 
;USB_HID_Library.mpas,467 :: 		memset(DstPtr, 0, HID_INPUT_REPORT_BYTES - ByteCount);
	MOVF        R0, 0 
	MOVWF       FARG_memset_p+0 
	MOVF        R1, 0 
	MOVWF       FARG_memset_p+1 
	CLRF        FARG_memset_character+0 
	MOVF        FARG_USB_HID_Write_ByteCount+0, 0 
	SUBLW       10
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	MOVLW       0
	SUBFWB      FARG_memset_n+1, 1 
	CALL        _memset+0, 0
;USB_HID_Library.mpas,468 :: 		end;
L__USB_HID_Write24:
;USB_HID_Library.mpas,471 :: 		BDEP1INCnt  := HID_INPUT_REPORT_BYTES;    // set bytecount
	MOVLW       10
	MOVWF       1037 
;USB_HID_Library.mpas,472 :: 		BDEP1INStat := BDEP1INStat and USB_DTSMask;  // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1036, 1 
;USB_HID_Library.mpas,473 :: 		BDEP1INStat := BDEP1INStat xor USB_DTSMask;  // toggle the data 0/1 bit
	BTG         1036, 6 
;USB_HID_Library.mpas,474 :: 		BDEP1INStat := BDEP1INStat OR  USB_DTSEN; // set the DTS bit
	BSF         1036, 3 
;USB_HID_Library.mpas,475 :: 		BDEP1INStat := BDEP1INStat OR  USB_USIE;  // set the UOWN bit (enable sending)
	BSF         1036, 7 
;USB_HID_Library.mpas,477 :: 		end;
L__USB_HID_Write18:
;USB_HID_Library.mpas,479 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_HID_Library.mpas,480 :: 		end;
	MOVF        USB_HID_Write_local_result+0, 0 
	MOVWF       R0 
L_end_USB_HID_Write:
	RETURN      0
; end of _USB_HID_Write

_ConfiguredUsb:

;USB_HID_Library.mpas,483 :: 		begin
;USB_HID_Library.mpas,484 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE
	MOVF        USB_HID_Library_UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ConfiguredUsb28
;USB_HID_Library.mpas,485 :: 		then Result := true
	MOVLW       255
	MOVWF       R1 
	GOTO        L__ConfiguredUsb29
;USB_HID_Library.mpas,486 :: 		else Result := false;
L__ConfiguredUsb28:
	CLRF        R1 
L__ConfiguredUsb29:
;USB_HID_Library.mpas,487 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_ConfiguredUsb:
	RETURN      0
; end of _ConfiguredUsb

_ActiveUsb:

;USB_HID_Library.mpas,490 :: 		begin
;USB_HID_Library.mpas,491 :: 		if (IsIdle = false) and (UsbDeviceEnumState = USB_CONFIG_STATE)
	MOVF        USB_HID_Library_IsIdle+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        USB_HID_Library_UsbDeviceEnumState+0, 0 
	XORLW       3
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__ActiveUsb32
;USB_HID_Library.mpas,492 :: 		then Result := true
	MOVLW       255
	MOVWF       R2 
	GOTO        L__ActiveUsb33
;USB_HID_Library.mpas,493 :: 		else Result := false;
L__ActiveUsb32:
	CLRF        R2 
L__ActiveUsb33:
;USB_HID_Library.mpas,494 :: 		end;
	MOVF        R2, 0 
	MOVWF       R0 
L_end_ActiveUsb:
	RETURN      0
; end of _ActiveUsb

_InitUsb:

;USB_HID_Library.mpas,497 :: 		begin
;USB_HID_Library.mpas,507 :: 		UsbDeviceRequest  := $FF; // no device requests in progress
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,509 :: 		UsbDeviceEnumState := USB_POWERED_STATE;
	CLRF        USB_HID_Library_UsbDeviceEnumState+0 
;USB_HID_Library.mpas,510 :: 		UsbCurrentConfig  := 0; // no configuration selected
	CLRF        USB_HID_Library_UsbCurrentConfig+0 
;USB_HID_Library.mpas,511 :: 		Usb_Status_Device := 1; // ?
	MOVLW       1
	MOVWF       USB_HID_Library_Usb_Status_Device+0 
;USB_HID_Library.mpas,512 :: 		UsbInterface      := 0;
	CLRF        USB_HID_Library_UsbInterface+0 
;USB_HID_Library.mpas,514 :: 		UADDR := 0;
	CLRF        UADDR+0 
;USB_HID_Library.mpas,516 :: 		UCFG.7      := 0; // eye pattern disabled
	BCF         UCFG+0, 7 
;USB_HID_Library.mpas,517 :: 		UCFG.UOEMON := 0; // OE monitor disabled
	BCF         UCFG+0, 6 
;USB_HID_Library.mpas,518 :: 		UCFG.UPUEN  := 1; // on chip pull up enabled
	BSF         UCFG+0, 4 
;USB_HID_Library.mpas,519 :: 		UCFG.UTRDIS := 0; // on chip tranceiver active
	BCF         UCFG+0, 3 
;USB_HID_Library.mpas,520 :: 		UCFG.FSEN   := 1; // Full speed enable (48 MHz USB clock required)
	BSF         UCFG+0, 2 
;USB_HID_Library.mpas,521 :: 		UCFG.PPB1   := 0; // ping pong buffers disabled
	BCF         UCFG+0, 1 
;USB_HID_Library.mpas,522 :: 		UCFG.PPB0   := 0; //
	BCF         UCFG+0, 0 
;USB_HID_Library.mpas,524 :: 		UIR   := 0; // clear all Usb interrupt flags
	CLRF        UIR+0 
;USB_HID_Library.mpas,525 :: 		UIE   := 1; // the only interrupt enabled is "USB reset"
	MOVLW       1
	MOVWF       UIE+0 
;USB_HID_Library.mpas,527 :: 		PIR2.USBIF := 0; // clear usb interrupt flag
	BCF         PIR2+0, 5 
;USB_HID_Library.mpas,528 :: 		PIE2.USBIE := 1; // enable Usb interrupts
	BSF         PIE2+0, 5 
;USB_HID_Library.mpas,530 :: 		INTCON.PEIE := 1; // peripheral interrupt enable
	BSF         INTCON+0, 6 
;USB_HID_Library.mpas,531 :: 		INTCON.GIE  := 1; // global enable
	BSF         INTCON+0, 7 
;USB_HID_Library.mpas,533 :: 		UCON  := 8; // attach device (USBEN = 1)
	MOVLW       8
	MOVWF       UCON+0 
;USB_HID_Library.mpas,534 :: 		repeat
L__InitUsb35:
;USB_HID_Library.mpas,535 :: 		until UCON.SE0 = 0;
	BTFSC       UCON+0, 5 
	GOTO        L__InitUsb35
;USB_HID_Library.mpas,536 :: 		end;
L_end_InitUsb:
	RETURN      0
; end of _InitUsb

_DeInitUsb:

;USB_HID_Library.mpas,539 :: 		begin
;USB_HID_Library.mpas,540 :: 		UCON.USBEN  := 0; // detach
	BCF         UCON+0, 3 
;USB_HID_Library.mpas,541 :: 		UCON.SUSPND := 1; // suspend mode
	BSF         UCON+0, 1 
;USB_HID_Library.mpas,543 :: 		UsbDeviceEnumState := USB_POWERED_STATE;
	CLRF        USB_HID_Library_UsbDeviceEnumState+0 
;USB_HID_Library.mpas,545 :: 		PIE2.USBIE := 0;  // disable the USB interrupts
	BCF         PIE2+0, 5 
;USB_HID_Library.mpas,546 :: 		end;
L_end_DeInitUsb:
	RETURN      0
; end of _DeInitUsb

_SoftDetachUsb:

;USB_HID_Library.mpas,549 :: 		begin
;USB_HID_Library.mpas,550 :: 		UCON.USBEN := 0;
	BCF         UCON+0, 3 
;USB_HID_Library.mpas,551 :: 		Delay_ms(100);
	MOVLW       7
	MOVWF       R11, 0
	MOVLW       23
	MOVWF       R12, 0
	MOVLW       106
	MOVWF       R13, 0
L__SoftDetachUsb42:
	DECFSZ      R13, 1, 1
	BRA         L__SoftDetachUsb42
	DECFSZ      R12, 1, 1
	BRA         L__SoftDetachUsb42
	DECFSZ      R11, 1, 1
	BRA         L__SoftDetachUsb42
	NOP
;USB_HID_Library.mpas,552 :: 		InitUsb;
	CALL        _InitUsb+0, 0
;USB_HID_Library.mpas,553 :: 		end;
L_end_SoftDetachUsb:
	RETURN      0
; end of _SoftDetachUsb

USB_HID_Library_EP0InReset:

;USB_HID_Library.mpas,556 :: 		begin
;USB_HID_Library.mpas,557 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_HID_Library.mpas,558 :: 		BDEP0INStat := (USB_UCPU or USB_DAT0 or USB_DTSEN); // UOWN = 0, DTSEN = 1;
	MOVLW       8
	MOVWF       1028 
;USB_HID_Library.mpas,559 :: 		end;
L_end_EP0InReset:
	RETURN      0
; end of USB_HID_Library_EP0InReset

USB_HID_Library_EP0OutReset:

;USB_HID_Library.mpas,562 :: 		begin
;USB_HID_Library.mpas,563 :: 		BDEP0OUTCnt  := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_HID_Library.mpas,564 :: 		BDEP0OUTStat := (USB_USIE or USBDat or USB_DTSEN); // UOWN = 1 and DTSEN = 1; // ready to receive data
	MOVLW       128
	IORWF       FARG_EP0OutReset_USBDat+0, 0 
	MOVWF       R0 
	MOVLW       8
	IORWF       R0, 0 
	MOVWF       1024 
;USB_HID_Library.mpas,565 :: 		end;
L_end_EP0OutReset:
	RETURN      0
; end of USB_HID_Library_EP0OutReset

USB_HID_Library_GiveEP0INtoSIE__:

;USB_HID_Library.mpas,568 :: 		begin
;USB_HID_Library.mpas,569 :: 		BDEP0INStat := BDEP0INStat xor USB_DTSMASK;             // toggle the DTS bit
	BTG         1028, 6 
;USB_HID_Library.mpas,570 :: 		BDEP0INStat := BDEP0INStat and USB_DTSMASK;             // clear the PID bits except DTS
	MOVLW       64
	ANDWF       1028, 1 
;USB_HID_Library.mpas,571 :: 		BDEP0INStat := BDEP0INStat or (USB_DTSEN or USB_USIE);  // go: set DTSEN
	MOVLW       136
	IORWF       1028, 1 
;USB_HID_Library.mpas,572 :: 		end;
L_end_GiveEP0INtoSIE__:
	RETURN      0
; end of USB_HID_Library_GiveEP0INtoSIE__

USB_HID_Library_GiveEP0OUTtoSIE__:

;USB_HID_Library.mpas,575 :: 		begin
;USB_HID_Library.mpas,576 :: 		BDEP0OUTStat := BDEP0OUTStat and USB_DTSMask;            // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1024, 1 
;USB_HID_Library.mpas,577 :: 		BDEP0OUTStat := BDEP0OUTStat xor USB_DTSMask;            // toggle data 0/1
	BTG         1024, 6 
;USB_HID_Library.mpas,578 :: 		BDEP0OUTStat := BDEP0OUTStat or (USB_DTSEN or USB_USIE); // set the DTS bit and the UOWN bit
	MOVLW       136
	IORWF       1024, 1 
;USB_HID_Library.mpas,579 :: 		end;
L_end_GiveEP0OUTtoSIE__:
	RETURN      0
; end of USB_HID_Library_GiveEP0OUTtoSIE__

USB_HID_Library_StallEP0:

;USB_HID_Library.mpas,582 :: 		begin
;USB_HID_Library.mpas,586 :: 		UsbDeviceRequest := $FF; // disregard any pending device request
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,588 :: 		BDEP0OUTCnt      := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_HID_Library.mpas,589 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_HID_Library.mpas,590 :: 		BDEP0OUTStat     := (USB_USIE or USB_BSTALL);
	MOVLW       132
	MOVWF       1024 
;USB_HID_Library.mpas,591 :: 		BDEP0INStat      := (USB_USIE or USB_BSTALL);
	MOVLW       132
	MOVWF       1028 
;USB_HID_Library.mpas,592 :: 		end;
L_end_StallEP0:
	RETURN      0
; end of USB_HID_Library_StallEP0

USB_HID_Library_EP0Stalled:

;USB_HID_Library.mpas,595 :: 		begin
;USB_HID_Library.mpas,596 :: 		Result := (BDEP0INStat and USB_BSTALL) > 0;
	MOVLW       4
	ANDWF       1028, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	SUBLW       0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R1 
;USB_HID_Library.mpas,597 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_EP0Stalled:
	RETURN      0
; end of USB_HID_Library_EP0Stalled

USB_HID_Library_CpyMem__:

;USB_HID_Library.mpas,601 :: 		begin
;USB_HID_Library.mpas,602 :: 		while N > 0 do
L_USB_HID_Library_CpyMem__51:
	MOVLW       0
	MOVWF       R0 
	MOVF        FARG_CpyMem___n+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_CpyMem__428
	MOVF        FARG_CpyMem___n+0, 0 
	SUBLW       0
L_USB_HID_Library_CpyMem__428:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_CpyMem__52
;USB_HID_Library.mpas,604 :: 		Towards^ := From^;
	MOVFF       FARG_CpyMem___From+0, FSR0L
	MOVFF       FARG_CpyMem___From+1, FSR0H
	MOVFF       FARG_CpyMem___Towards+0, FSR1L
	MOVFF       FARG_CpyMem___Towards+1, FSR1H
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;USB_HID_Library.mpas,605 :: 		inc(Towards);
	INFSNZ      FARG_CpyMem___Towards+0, 1 
	INCF        FARG_CpyMem___Towards+1, 1 
;USB_HID_Library.mpas,606 :: 		inc(From);
	INFSNZ      FARG_CpyMem___From+0, 1 
	INCF        FARG_CpyMem___From+1, 1 
;USB_HID_Library.mpas,607 :: 		dec(N);
	MOVLW       1
	SUBWF       FARG_CpyMem___n+0, 1 
	MOVLW       0
	SUBWFB      FARG_CpyMem___n+1, 1 
;USB_HID_Library.mpas,608 :: 		end;
	GOTO        L_USB_HID_Library_CpyMem__51
L_USB_HID_Library_CpyMem__52:
;USB_HID_Library.mpas,609 :: 		end;
L_end_CpyMem__:
	RETURN      0
; end of USB_HID_Library_CpyMem__

USB_HID_Library_UsbReset:

;USB_HID_Library.mpas,612 :: 		begin
;USB_HID_Library.mpas,613 :: 		UEP0 := 0;  // disable UEP0
	CLRF        UEP0+0 
;USB_HID_Library.mpas,614 :: 		UEP1 := 0;  // disable UEP1
	CLRF        UEP1+0 
;USB_HID_Library.mpas,621 :: 		UCON.PKTDIS := 1;    // disable packet reception
	BSF         UCON+0, 4 
;USB_HID_Library.mpas,623 :: 		UsbCurrentConfig := 0;
	CLRF        USB_HID_Library_UsbCurrentConfig+0 
;USB_HID_Library.mpas,624 :: 		IsIdle := false;
	CLRF        USB_HID_Library_IsIdle+0 
;USB_HID_Library.mpas,626 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_HID_Library.mpas,627 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_HID_Library.mpas,628 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_HID_Library.mpas,629 :: 		UIR.TRNIF := 0;  // clear 4 times to make the status fifo empty
	BCF         UIR+0, 3 
;USB_HID_Library.mpas,632 :: 		BDEP0OUTAdr  := word(@BuffEP0OUT);
	MOVLW       USB_HID_Library_BuffEP0OUT+0
	MOVWF       1026 
	MOVLW       hi_addr(USB_HID_Library_BuffEP0OUT+0)
	MOVWF       1027 
;USB_HID_Library.mpas,633 :: 		EP0OutReset(USB_DAT0);  // Initial EP0OUT Status: start with DATA0 toggle bit
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,636 :: 		BDEP0INAdr  := word(@BuffEP0IN);
	MOVLW       USB_HID_Library_BuffEP0IN+0
	MOVWF       1030 
	MOVLW       hi_addr(USB_HID_Library_BuffEP0IN+0)
	MOVWF       1031 
;USB_HID_Library.mpas,637 :: 		EP0InReset;
	CALL        USB_HID_Library_EP0InReset+0, 0
;USB_HID_Library.mpas,639 :: 		UADDR      := 0; // no usb address assigned (yet)
	CLRF        UADDR+0 
;USB_HID_Library.mpas,640 :: 		UIR        := 0; // clear the usb interrupt flags
	CLRF        UIR+0 
;USB_HID_Library.mpas,641 :: 		PIR2.USBIF := 0;
	BCF         PIR2+0, 5 
;USB_HID_Library.mpas,643 :: 		UsbDeviceEnumState := USB_DEFAULT_STATE;
	MOVLW       1
	MOVWF       USB_HID_Library_UsbDeviceEnumState+0 
;USB_HID_Library.mpas,644 :: 		Usb_Status_Device := 0; // selfpowered, remote wakeup disabled
	CLRF        USB_HID_Library_Usb_Status_Device+0 
;USB_HID_Library.mpas,646 :: 		UIE  := $39; // enable all interrupts except "ACTIVE", "SOFIE" and "UEREIE"
	MOVLW       57
	MOVWF       UIE+0 
;USB_HID_Library.mpas,647 :: 		UEIE := 0;   // disable all error interrupts
	CLRF        UEIE+0 
;USB_HID_Library.mpas,650 :: 		UEP0 := (USB_EP_CTRL or USB_HSHK_EN);
	MOVLW       22
	MOVWF       UEP0+0 
;USB_HID_Library.mpas,651 :: 		UCON.PKTDIS := 0;                     // enable packet reception
	BCF         UCON+0, 4 
;USB_HID_Library.mpas,652 :: 		end;
L_end_UsbReset:
	RETURN      0
; end of USB_HID_Library_UsbReset

USB_HID_Library_USBError:

;USB_HID_Library.mpas,655 :: 		begin
;USB_HID_Library.mpas,656 :: 		UIR.UERRIF := 0; // clear error interrupt bit
	BCF         UIR+0, 1 
;USB_HID_Library.mpas,658 :: 		end;
L_end_USBError:
	RETURN      0
; end of USB_HID_Library_USBError

USB_HID_Library_SendZeroLenPacket:

;USB_HID_Library.mpas,661 :: 		begin
;USB_HID_Library.mpas,665 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,666 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_HID_Library.mpas,667 :: 		BDEP0INStat      := (USB_USIE or USB_DAT1 or USB_DTSEN); // UOWN, DTS (data1) and DTSEN are set
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,668 :: 		end;
L_end_SendZeroLenPacket:
	RETURN      0
; end of USB_HID_Library_SendZeroLenPacket

USB_HID_Library_SendAckToHost:

;USB_HID_Library.mpas,671 :: 		begin
;USB_HID_Library.mpas,675 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,676 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_HID_Library.mpas,677 :: 		BDEP0INStat      := (USB_USIE or USB_DAT1 or USB_DTSEN); // UOWN, DTS (data1) and DTSEN are set
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,678 :: 		end;
L_end_SendAckToHost:
	RETURN      0
; end of USB_HID_Library_SendAckToHost

USB_HID_Library_CopyDescriptorToEP0:

;USB_HID_Library.mpas,683 :: 		begin
;USB_HID_Library.mpas,684 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       CopyDescriptorToEP0_Dst+0 
	MOVF        1031, 0 
	MOVWF       CopyDescriptorToEP0_Dst+1 
;USB_HID_Library.mpas,685 :: 		Len := DescriptorBytesToSend;
	MOVF        USB_HID_Library_DescriptorBytesToSend+0, 0 
	MOVWF       CopyDescriptorToEP0_Len+0 
;USB_HID_Library.mpas,694 :: 		if (Len = 0)
	MOVF        USB_HID_Library_DescriptorBytesToSend+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_CopyDescriptorToEP061
;USB_HID_Library.mpas,695 :: 		then UsbDeviceRequest := $FF // all bytes have been sent previous time
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
	GOTO        L_USB_HID_Library_CopyDescriptorToEP062
;USB_HID_Library.mpas,697 :: 		else  // some left over of the descriptor is to be sent
L_USB_HID_Library_CopyDescriptorToEP061:
;USB_HID_Library.mpas,699 :: 		if (Len > EP0_PACKET_SIZE) then Len := EP0_PACKET_SIZE;
	MOVLW       0
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_CopyDescriptorToEP0434
	MOVF        CopyDescriptorToEP0_Len+0, 0 
	SUBLW       64
L_USB_HID_Library_CopyDescriptorToEP0434:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_CopyDescriptorToEP064
	MOVLW       64
	MOVWF       CopyDescriptorToEP0_Len+0 
L_USB_HID_Library_CopyDescriptorToEP064:
;USB_HID_Library.mpas,701 :: 		I := 0;
	CLRF        CopyDescriptorToEP0_I+0 
;USB_HID_Library.mpas,702 :: 		while I < Len do
L_USB_HID_Library_CopyDescriptorToEP067:
	MOVF        CopyDescriptorToEP0_Len+0, 0 
	SUBWF       CopyDescriptorToEP0_I+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_CopyDescriptorToEP068
;USB_HID_Library.mpas,704 :: 		Dst^:= DescriptorPointer^;
	MOVF        USB_HID_Library_DescriptorPointer+0, 0 
	MOVWF       TBLPTRL 
	MOVF        USB_HID_Library_DescriptorPointer+1, 0 
	MOVWF       TBLPTRH 
	MOVF        USB_HID_Library_DescriptorPointer+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       CopyDescriptorToEP0_Dst+0, FSR1L
	MOVFF       CopyDescriptorToEP0_Dst+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_HID_Library.mpas,705 :: 		Inc(Dst);
	INFSNZ      CopyDescriptorToEP0_Dst+0, 1 
	INCF        CopyDescriptorToEP0_Dst+1, 1 
;USB_HID_Library.mpas,706 :: 		Inc(DescriptorPointer);
	MOVLW       1
	ADDWF       USB_HID_Library_DescriptorPointer+0, 1 
	MOVLW       0
	ADDWFC      USB_HID_Library_DescriptorPointer+1, 1 
	ADDWFC      USB_HID_Library_DescriptorPointer+2, 1 
;USB_HID_Library.mpas,707 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_HID_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_HID_Library_DescriptorBytesToSend+1, 1 
;USB_HID_Library.mpas,708 :: 		Dec(DescriptorBytesRequested);
	MOVLW       1
	SUBWF       USB_HID_Library_DescriptorBytesRequested+0, 1 
	MOVLW       0
	SUBWFB      USB_HID_Library_DescriptorBytesRequested+1, 1 
;USB_HID_Library.mpas,709 :: 		inc(I);
	INCF        CopyDescriptorToEP0_I+0, 1 
;USB_HID_Library.mpas,710 :: 		end;
	GOTO        L_USB_HID_Library_CopyDescriptorToEP067
L_USB_HID_Library_CopyDescriptorToEP068:
;USB_HID_Library.mpas,711 :: 		end;
L_USB_HID_Library_CopyDescriptorToEP062:
;USB_HID_Library.mpas,713 :: 		if (DescriptorBytesRequested = 0)
	MOVLW       0
	XORWF       USB_HID_Library_DescriptorBytesRequested+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_CopyDescriptorToEP0435
	MOVLW       0
	XORWF       USB_HID_Library_DescriptorBytesRequested+0, 0 
L_USB_HID_Library_CopyDescriptorToEP0435:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_CopyDescriptorToEP072
;USB_HID_Library.mpas,714 :: 		then UsbDeviceRequest := $FF; // all bytes have been sent after this
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
L_USB_HID_Library_CopyDescriptorToEP072:
;USB_HID_Library.mpas,716 :: 		BDEP0INCnt  := Len;
	MOVF        CopyDescriptorToEP0_Len+0, 0 
	MOVWF       1029 
;USB_HID_Library.mpas,717 :: 		GiveEP0INtoSIE__; // send
	CALL        USB_HID_Library_GiveEP0INtoSIE__+0, 0
;USB_HID_Library.mpas,718 :: 		end;
L_end_CopyDescriptorToEP0:
	RETURN      0
; end of USB_HID_Library_CopyDescriptorToEP0

USB_HID_Library_SendStringDescriptorToEP0:

;USB_HID_Library.mpas,723 :: 		begin
;USB_HID_Library.mpas,725 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       SendStringDescriptorToEP0_Dst+0 
	MOVF        1031, 0 
	MOVWF       SendStringDescriptorToEP0_Dst+1 
;USB_HID_Library.mpas,726 :: 		Len := DescriptorBytesToSend;
	MOVF        USB_HID_Library_DescriptorBytesToSend+0, 0 
	MOVWF       SendStringDescriptorToEP0_Len+0 
;USB_HID_Library.mpas,728 :: 		if (Len = 0)
	MOVF        USB_HID_Library_DescriptorBytesToSend+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP076
;USB_HID_Library.mpas,729 :: 		then UsbDeviceRequest := $FF // all bytes have been sent previous time
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP077
;USB_HID_Library.mpas,732 :: 		else  // some left over of the descriptor is to be sent
L_USB_HID_Library_SendStringDescriptorToEP076:
;USB_HID_Library.mpas,734 :: 		if (Len > EP0_PACKET_SIZE) then Len := EP0_PACKET_SIZE;
	MOVLW       0
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP0437
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	SUBLW       64
L_USB_HID_Library_SendStringDescriptorToEP0437:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP079
	MOVLW       64
	MOVWF       SendStringDescriptorToEP0_Len+0 
L_USB_HID_Library_SendStringDescriptorToEP079:
;USB_HID_Library.mpas,741 :: 		I := 0;
	CLRF        SendStringDescriptorToEP0_I+0 
;USB_HID_Library.mpas,742 :: 		if StartStringDescriptor then     // first send length byte and string descriptor identifier
	MOVF        USB_HID_Library_StartStringDescriptor+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP082
;USB_HID_Library.mpas,744 :: 		Dst^ := Len;                    // length byte
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       POSTINC1+0 
;USB_HID_Library.mpas,745 :: 		inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_HID_Library.mpas,746 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_HID_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_HID_Library_DescriptorBytesToSend+1, 1 
;USB_HID_Library.mpas,748 :: 		Dst^ := USB_STRING;             // descriptor identifcation
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVLW       3
	MOVWF       POSTINC1+0 
;USB_HID_Library.mpas,749 :: 		inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_HID_Library.mpas,750 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_HID_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_HID_Library_DescriptorBytesToSend+1, 1 
;USB_HID_Library.mpas,752 :: 		I := 2;
	MOVLW       2
	MOVWF       SendStringDescriptorToEP0_I+0 
;USB_HID_Library.mpas,753 :: 		StartStringDescriptor := false;
	CLRF        USB_HID_Library_StartStringDescriptor+0 
;USB_HID_Library.mpas,754 :: 		end;
L_USB_HID_Library_SendStringDescriptorToEP082:
;USB_HID_Library.mpas,756 :: 		while I < Len do
L_USB_HID_Library_SendStringDescriptorToEP085:
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	SUBWF       SendStringDescriptorToEP0_I+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP086
;USB_HID_Library.mpas,758 :: 		Dst^:= DescriptorPointer^;     // copy byte
	MOVF        USB_HID_Library_DescriptorPointer+0, 0 
	MOVWF       TBLPTRL 
	MOVF        USB_HID_Library_DescriptorPointer+1, 0 
	MOVWF       TBLPTRH 
	MOVF        USB_HID_Library_DescriptorPointer+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_HID_Library.mpas,759 :: 		Inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_HID_Library.mpas,760 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_HID_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_HID_Library_DescriptorBytesToSend+1, 1 
;USB_HID_Library.mpas,761 :: 		Inc(DescriptorPointer);
	MOVLW       1
	ADDWF       USB_HID_Library_DescriptorPointer+0, 1 
	MOVLW       0
	ADDWFC      USB_HID_Library_DescriptorPointer+1, 1 
	ADDWFC      USB_HID_Library_DescriptorPointer+2, 1 
;USB_HID_Library.mpas,762 :: 		inc(I);
	INCF        SendStringDescriptorToEP0_I+0, 1 
;USB_HID_Library.mpas,764 :: 		Dst^:= 0;                     // and add zero
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	CLRF        POSTINC1+0 
;USB_HID_Library.mpas,765 :: 		Inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_HID_Library.mpas,766 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       USB_HID_Library_DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      USB_HID_Library_DescriptorBytesToSend+1, 1 
;USB_HID_Library.mpas,767 :: 		inc(I);
	INCF        SendStringDescriptorToEP0_I+0, 1 
;USB_HID_Library.mpas,768 :: 		end;
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP085
L_USB_HID_Library_SendStringDescriptorToEP086:
;USB_HID_Library.mpas,769 :: 		end;
L_USB_HID_Library_SendStringDescriptorToEP077:
;USB_HID_Library.mpas,771 :: 		if (DescriptorBytesToSend = 0)
	MOVLW       0
	XORWF       USB_HID_Library_DescriptorBytesToSend+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP0438
	MOVLW       0
	XORWF       USB_HID_Library_DescriptorBytesToSend+0, 0 
L_USB_HID_Library_SendStringDescriptorToEP0438:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_SendStringDescriptorToEP090
;USB_HID_Library.mpas,772 :: 		then UsbDeviceRequest := $FF; // all bytes have been sent after this
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
L_USB_HID_Library_SendStringDescriptorToEP090:
;USB_HID_Library.mpas,779 :: 		BDEP0INCnt  := Len;
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       1029 
;USB_HID_Library.mpas,780 :: 		GiveEP0INtoSIE__; // send
	CALL        USB_HID_Library_GiveEP0INtoSIE__+0, 0
;USB_HID_Library.mpas,781 :: 		end;
L_end_SendStringDescriptorToEP0:
	RETURN      0
; end of USB_HID_Library_SendStringDescriptorToEP0

USB_HID_Library_PrepareStringDescriptor:

;USB_HID_Library.mpas,786 :: 		begin
;USB_HID_Library.mpas,788 :: 		Len := 0;
	CLRF        R5 
;USB_HID_Library.mpas,789 :: 		Tmp := Src;
	MOVF        FARG_PrepareStringDescriptor_Src+0, 0 
	MOVWF       R2 
	MOVF        FARG_PrepareStringDescriptor_Src+1, 0 
	MOVWF       R3 
	MOVF        FARG_PrepareStringDescriptor_Src+2, 0 
	MOVWF       R4 
;USB_HID_Library.mpas,790 :: 		while Tmp^ > 0 do
L_USB_HID_Library_PrepareStringDescriptor94:
	MOVF        R2, 0 
	MOVWF       TBLPTRL 
	MOVF        R3, 0 
	MOVWF       TBLPTRH 
	MOVF        R4, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R1
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_PrepareStringDescriptor95
;USB_HID_Library.mpas,792 :: 		inc(Len);
	INCF        R5, 1 
;USB_HID_Library.mpas,793 :: 		inc(Tmp);
	MOVLW       1
	ADDWF       R2, 1 
	MOVLW       0
	ADDWFC      R3, 1 
	ADDWFC      R4, 1 
;USB_HID_Library.mpas,794 :: 		end;
	GOTO        L_USB_HID_Library_PrepareStringDescriptor94
L_USB_HID_Library_PrepareStringDescriptor95:
;USB_HID_Library.mpas,795 :: 		Len := (2 * Len) + 2;
	MOVF        R5, 0 
	MOVWF       R0 
	RLCF        R0, 1 
	BCF         R0, 0 
	MOVLW       2
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       R5 
;USB_HID_Library.mpas,797 :: 		DescriptorPointer     := Src;
	MOVF        FARG_PrepareStringDescriptor_Src+0, 0 
	MOVWF       USB_HID_Library_DescriptorPointer+0 
	MOVF        FARG_PrepareStringDescriptor_Src+1, 0 
	MOVWF       USB_HID_Library_DescriptorPointer+1 
	MOVF        FARG_PrepareStringDescriptor_Src+2, 0 
	MOVWF       USB_HID_Library_DescriptorPointer+2 
;USB_HID_Library.mpas,798 :: 		DescriptorBytesToSend := Len;
	MOVF        R0, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
;USB_HID_Library.mpas,799 :: 		UsbDeviceRequest      := USB_GET_STRING_DESCRIPTOR_ONGOING;
	MOVLW       2
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,800 :: 		StartStringDescriptor := true;
	MOVLW       255
	MOVWF       USB_HID_Library_StartStringDescriptor+0 
;USB_HID_Library.mpas,801 :: 		end;
L_end_PrepareStringDescriptor:
	RETURN      0
; end of USB_HID_Library_PrepareStringDescriptor

USB_HID_Library_GetDescriptor:

;USB_HID_Library.mpas,805 :: 		begin
;USB_HID_Library.mpas,806 :: 		Index := Lo(SetUpPacket.wValue);
	MOVF        USB_HID_Library_SetUpPacket+2, 0 
	MOVWF       GetDescriptor_Index+0 
;USB_HID_Library.mpas,830 :: 		USB_DEVICE                   : // GetDeviceDescriptor
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor102
;USB_HID_Library.mpas,832 :: 		UsbDeviceRequest           := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,833 :: 		DescriptorPointer          := @DeviceDescriptor;
	MOVLW       _DeviceDescriptor+0
	MOVWF       USB_HID_Library_DescriptorPointer+0 
	MOVLW       hi_addr(_DeviceDescriptor+0)
	MOVWF       USB_HID_Library_DescriptorPointer+1 
	MOVLW       higher_addr(_DeviceDescriptor+0)
	MOVWF       USB_HID_Library_DescriptorPointer+2 
;USB_HID_Library.mpas,834 :: 		DescriptorBytesToSend      := SizeOf(DeviceDescriptor);
	MOVLW       18
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
;USB_HID_Library.mpas,835 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        USB_HID_Library_SetUpPacket+6, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+0 
	MOVF        USB_HID_Library_SetUpPacket+7, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+1 
;USB_HID_Library.mpas,836 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVLW       0
	SUBWF       USB_HID_Library_SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor441
	MOVLW       18
	SUBWF       USB_HID_Library_SetUpPacket+6, 0 
L_USB_HID_Library_GetDescriptor441:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_GetDescriptor104
;USB_HID_Library.mpas,837 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        USB_HID_Library_DescriptorBytesRequested+0, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVF        USB_HID_Library_DescriptorBytesRequested+1, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
L_USB_HID_Library_GetDescriptor104:
;USB_HID_Library.mpas,838 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,839 :: 		CopyDescriptorToEP0;
	CALL        USB_HID_Library_CopyDescriptorToEP0+0, 0
;USB_HID_Library.mpas,840 :: 		end;
	GOTO        L_USB_HID_Library_GetDescriptor99
L_USB_HID_Library_GetDescriptor102:
;USB_HID_Library.mpas,842 :: 		USB_CONFIGURATION            : // GetConfigDescriptor;
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor108
;USB_HID_Library.mpas,844 :: 		UsbDeviceRequest           := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,845 :: 		DescriptorPointer          := @Config1;
	MOVLW       _Config1+0
	MOVWF       USB_HID_Library_DescriptorPointer+0 
	MOVLW       hi_addr(_Config1+0)
	MOVWF       USB_HID_Library_DescriptorPointer+1 
	MOVLW       higher_addr(_Config1+0)
	MOVWF       USB_HID_Library_DescriptorPointer+2 
;USB_HID_Library.mpas,846 :: 		DescriptorBytesToSend      := SizeOf(Config1);
	MOVLW       41
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
;USB_HID_Library.mpas,847 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        USB_HID_Library_SetUpPacket+6, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+0 
	MOVF        USB_HID_Library_SetUpPacket+7, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+1 
;USB_HID_Library.mpas,848 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVLW       0
	SUBWF       USB_HID_Library_SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor442
	MOVLW       41
	SUBWF       USB_HID_Library_SetUpPacket+6, 0 
L_USB_HID_Library_GetDescriptor442:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_GetDescriptor110
;USB_HID_Library.mpas,849 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        USB_HID_Library_DescriptorBytesRequested+0, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVF        USB_HID_Library_DescriptorBytesRequested+1, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
L_USB_HID_Library_GetDescriptor110:
;USB_HID_Library.mpas,850 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,851 :: 		CopyDescriptorToEP0;
	CALL        USB_HID_Library_CopyDescriptorToEP0+0, 0
;USB_HID_Library.mpas,852 :: 		end;
	GOTO        L_USB_HID_Library_GetDescriptor99
L_USB_HID_Library_GetDescriptor108:
;USB_HID_Library.mpas,854 :: 		USB_HID                      : // GetHIDDescriptor;
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       33
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor114
;USB_HID_Library.mpas,856 :: 		UsbDeviceRequest           := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,857 :: 		DescriptorPointer          := @Config1 + HIDDescrPos;
	MOVLW       18
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       _Config1+0
	ADDWF       R0, 0 
	MOVWF       USB_HID_Library_DescriptorPointer+0 
	MOVLW       hi_addr(_Config1+0)
	ADDWFC      R1, 0 
	MOVWF       USB_HID_Library_DescriptorPointer+1 
	MOVLW       higher_addr(_Config1+0)
	ADDWFC      R2, 0 
	MOVWF       USB_HID_Library_DescriptorPointer+2 
;USB_HID_Library.mpas,858 :: 		DescriptorBytesToSend      := Config1[HIDDescrPos];
	MOVLW       9
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
;USB_HID_Library.mpas,859 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        USB_HID_Library_SetUpPacket+6, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+0 
	MOVF        USB_HID_Library_SetUpPacket+7, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+1 
;USB_HID_Library.mpas,860 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVLW       0
	SUBWF       USB_HID_Library_SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor443
	MOVLW       9
	SUBWF       USB_HID_Library_SetUpPacket+6, 0 
L_USB_HID_Library_GetDescriptor443:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_GetDescriptor116
;USB_HID_Library.mpas,861 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        USB_HID_Library_DescriptorBytesRequested+0, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVF        USB_HID_Library_DescriptorBytesRequested+1, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
L_USB_HID_Library_GetDescriptor116:
;USB_HID_Library.mpas,867 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,868 :: 		CopyDescriptorToEP0;
	CALL        USB_HID_Library_CopyDescriptorToEP0+0, 0
;USB_HID_Library.mpas,869 :: 		end;
	GOTO        L_USB_HID_Library_GetDescriptor99
L_USB_HID_Library_GetDescriptor114:
;USB_HID_Library.mpas,871 :: 		USB_REPORT                   : // GetReportDescriptor;
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       34
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor120
;USB_HID_Library.mpas,873 :: 		UsbDeviceRequest           := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,874 :: 		DescriptorPointer          := @ReportDescriptor;
	MOVLW       _ReportDescriptor+0
	MOVWF       USB_HID_Library_DescriptorPointer+0 
	MOVLW       hi_addr(_ReportDescriptor+0)
	MOVWF       USB_HID_Library_DescriptorPointer+1 
	MOVLW       higher_addr(_ReportDescriptor+0)
	MOVWF       USB_HID_Library_DescriptorPointer+2 
;USB_HID_Library.mpas,875 :: 		DescriptorBytesToSend      := SizeOf(ReportDescriptor);
	MOVLW       34
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
;USB_HID_Library.mpas,876 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        USB_HID_Library_SetUpPacket+6, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+0 
	MOVF        USB_HID_Library_SetUpPacket+7, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+1 
;USB_HID_Library.mpas,877 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVLW       0
	SUBWF       USB_HID_Library_SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor444
	MOVLW       34
	SUBWF       USB_HID_Library_SetUpPacket+6, 0 
L_USB_HID_Library_GetDescriptor444:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_GetDescriptor122
;USB_HID_Library.mpas,878 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        USB_HID_Library_DescriptorBytesRequested+0, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVF        USB_HID_Library_DescriptorBytesRequested+1, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
L_USB_HID_Library_GetDescriptor122:
;USB_HID_Library.mpas,879 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,880 :: 		CopyDescriptorToEP0;
	CALL        USB_HID_Library_CopyDescriptorToEP0+0, 0
;USB_HID_Library.mpas,881 :: 		end;
	GOTO        L_USB_HID_Library_GetDescriptor99
L_USB_HID_Library_GetDescriptor120:
;USB_HID_Library.mpas,883 :: 		USB_STRING                   : // GetStringDescriptor(Index);
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor126
;USB_HID_Library.mpas,885 :: 		if Index <= 3 then
	MOVF        GetDescriptor_Index+0, 0 
	SUBLW       3
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_HID_Library_GetDescriptor128
;USB_HID_Library.mpas,889 :: 		0: //
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor133
;USB_HID_Library.mpas,891 :: 		DescriptorPointer     := @LanguageString;
	MOVLW       _LanguageString+0
	MOVWF       USB_HID_Library_DescriptorPointer+0 
	MOVLW       hi_addr(_LanguageString+0)
	MOVWF       USB_HID_Library_DescriptorPointer+1 
	MOVLW       higher_addr(_LanguageString+0)
	MOVWF       USB_HID_Library_DescriptorPointer+2 
;USB_HID_Library.mpas,892 :: 		DescriptorBytesToSend := SizeOf(LanguageString);
	MOVLW       4
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
;USB_HID_Library.mpas,893 :: 		UsbDeviceRequest := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,894 :: 		end;
	GOTO        L_USB_HID_Library_GetDescriptor130
L_USB_HID_Library_GetDescriptor133:
;USB_HID_Library.mpas,895 :: 		1: PrepareStringDescriptor(@UsbManufacturer);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor136
	MOVLW       _UsbManufacturer+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbManufacturer+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbManufacturer+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_HID_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_HID_Library_GetDescriptor130
L_USB_HID_Library_GetDescriptor136:
;USB_HID_Library.mpas,896 :: 		2: PrepareStringDescriptor(@UsbProduct);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor139
	MOVLW       _UsbProduct+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbProduct+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbProduct+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_HID_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_HID_Library_GetDescriptor130
L_USB_HID_Library_GetDescriptor139:
;USB_HID_Library.mpas,897 :: 		3: PrepareStringDescriptor(@UsbSerialNo);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor142
	MOVLW       _UsbSerialNo+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbSerialNo+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbSerialNo+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_HID_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_HID_Library_GetDescriptor130
L_USB_HID_Library_GetDescriptor142:
L_USB_HID_Library_GetDescriptor130:
;USB_HID_Library.mpas,900 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        USB_HID_Library_SetUpPacket+6, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+0 
	MOVF        USB_HID_Library_SetUpPacket+7, 0 
	MOVWF       USB_HID_Library_DescriptorBytesRequested+1 
;USB_HID_Library.mpas,901 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVF        USB_HID_Library_DescriptorBytesToSend+1, 0 
	SUBWF       USB_HID_Library_SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor445
	MOVF        USB_HID_Library_DescriptorBytesToSend+0, 0 
	SUBWF       USB_HID_Library_SetUpPacket+6, 0 
L_USB_HID_Library_GetDescriptor445:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_GetDescriptor144
;USB_HID_Library.mpas,902 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        USB_HID_Library_DescriptorBytesRequested+0, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+0 
	MOVF        USB_HID_Library_DescriptorBytesRequested+1, 0 
	MOVWF       USB_HID_Library_DescriptorBytesToSend+1 
L_USB_HID_Library_GetDescriptor144:
;USB_HID_Library.mpas,904 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,905 :: 		if Index = 0
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_GetDescriptor147
;USB_HID_Library.mpas,906 :: 		then CopyDescriptorToEP0        // string is in constant memory
	CALL        USB_HID_Library_CopyDescriptorToEP0+0, 0
	GOTO        L_USB_HID_Library_GetDescriptor148
;USB_HID_Library.mpas,907 :: 		else SendStringDescriptorToEP0; // special case
L_USB_HID_Library_GetDescriptor147:
	CALL        USB_HID_Library_SendStringDescriptorToEP0+0, 0
L_USB_HID_Library_GetDescriptor148:
;USB_HID_Library.mpas,908 :: 		end
	GOTO        L_USB_HID_Library_GetDescriptor129
;USB_HID_Library.mpas,909 :: 		else StallEP0;
L_USB_HID_Library_GetDescriptor128:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_GetDescriptor129:
;USB_HID_Library.mpas,915 :: 		else StallEp0;
	GOTO        L_USB_HID_Library_GetDescriptor99
L_USB_HID_Library_GetDescriptor126:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_GetDescriptor99:
;USB_HID_Library.mpas,917 :: 		end;
L_end_GetDescriptor:
	RETURN      0
; end of USB_HID_Library_GetDescriptor

USB_HID_Library_SetHIDReport:

;USB_HID_Library.mpas,921 :: 		begin
;USB_HID_Library.mpas,925 :: 		USB_HID_OUTPUT_REPORT: //
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_SetHIDReport153
;USB_HID_Library.mpas,929 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,932 :: 		Src := ^byte(BDEP0OUTAdr);
	MOVF        1026, 0 
	MOVWF       FARG_CpyMem___From+0 
	MOVF        1027, 0 
	MOVWF       FARG_CpyMem___From+1 
;USB_HID_Library.mpas,933 :: 		Dst := ^byte(BDEP1OUTAdr);
	MOVF        1034, 0 
	MOVWF       FARG_CpyMem___Towards+0 
	MOVF        1035, 0 
	MOVWF       FARG_CpyMem___Towards+1 
;USB_HID_Library.mpas,935 :: 		CpyMem__(Dst, Src, BDEP0OUTCnt);
	MOVF        1025, 0 
	MOVWF       FARG_CpyMem___n+0 
	MOVLW       0
	MOVWF       FARG_CpyMem___n+1 
	CALL        USB_HID_Library_CpyMem__+0, 0
;USB_HID_Library.mpas,937 :: 		BDEP1OUTCnt  := BDEP0OUTCnt;   // copy the bytecount
	MOVF        1025, 0 
	MOVWF       1033 
;USB_HID_Library.mpas,938 :: 		BDEP1OUTStat := BDEP0OUTStat;  // copy the status
	MOVF        1024, 0 
	MOVWF       1032 
;USB_HID_Library.mpas,943 :: 		end;
	GOTO        L_USB_HID_Library_SetHIDReport150
L_USB_HID_Library_SetHIDReport153:
;USB_HID_Library.mpas,945 :: 		USB_HID_FEATURE_REPORT: //
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_SetHIDReport156
;USB_HID_Library.mpas,947 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,948 :: 		end;
	GOTO        L_USB_HID_Library_SetHIDReport150
L_USB_HID_Library_SetHIDReport156:
L_USB_HID_Library_SetHIDReport150:
;USB_HID_Library.mpas,950 :: 		end;
L_end_SetHIDReport:
	RETURN      0
; end of USB_HID_Library_SetHIDReport

USB_HID_Library_TokenOutPID:

;USB_HID_Library.mpas,954 :: 		begin
;USB_HID_Library.mpas,955 :: 		Ep := (USTATCopy shr 3) and $0f; // get endpoint
	MOVF        USB_HID_Library_USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       TokenOutPID_Ep+0 
;USB_HID_Library.mpas,957 :: 		if (Ep = 0) and (BDEP0OUTCnt = 0) then  // ZLP received , reset EP0 out, ready for reception
	MOVF        R0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        1025, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenOutPID159
;USB_HID_Library.mpas,959 :: 		EP0OutReset(USB_DAT0);  // reset EP0 to its initial state
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,963 :: 		exit;
	GOTO        L_end_USB_HID_Library_TokenOutPID
;USB_HID_Library.mpas,964 :: 		end;
L_USB_HID_Library_TokenOutPID159:
;USB_HID_Library.mpas,967 :: 		0: // Endpoint 0 out
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenOutPID164
;USB_HID_Library.mpas,969 :: 		if UsbDeviceRequest = USB_HID_SET_REPORT_ONGOING then
	MOVF        USB_HID_Library_UsbDeviceRequest+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenOutPID166
;USB_HID_Library.mpas,971 :: 		SetHIDReport;
	CALL        USB_HID_Library_SetHIDReport+0, 0
;USB_HID_Library.mpas,972 :: 		end;
L_USB_HID_Library_TokenOutPID166:
;USB_HID_Library.mpas,973 :: 		end;
	GOTO        L_USB_HID_Library_TokenOutPID161
L_USB_HID_Library_TokenOutPID164:
;USB_HID_Library.mpas,975 :: 		1: // endpoint 1 out
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenOutPID170
;USB_HID_Library.mpas,981 :: 		end;
	GOTO        L_USB_HID_Library_TokenOutPID161
L_USB_HID_Library_TokenOutPID170:
L_USB_HID_Library_TokenOutPID161:
;USB_HID_Library.mpas,984 :: 		if Ep = 0 then
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenOutPID172
;USB_HID_Library.mpas,986 :: 		if (BDEP0OutCnt < EP0_PACKET_SIZE) then                // this was the last packet
	MOVLW       0
	MOVWF       R0 
	MOVLW       0
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenOutPID448
	MOVLW       64
	SUBWF       1025, 0 
L_USB_HID_Library_TokenOutPID448:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_TokenOutPID175
;USB_HID_Library.mpas,988 :: 		EP0OutReset(USB_DAT0);                               // reset EP0 to its initial state
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,989 :: 		SendZeroLenPacket;
	CALL        USB_HID_Library_SendZeroLenPacket+0, 0
;USB_HID_Library.mpas,990 :: 		end
	GOTO        L_USB_HID_Library_TokenOutPID176
;USB_HID_Library.mpas,991 :: 		else
L_USB_HID_Library_TokenOutPID175:
;USB_HID_Library.mpas,993 :: 		GiveEP0OUTtoSIE__;                                   // toggle the DTS bit and set DTSEN and USB_USIE (give to SIE = prepare to receive data)
	CALL        USB_HID_Library_GiveEP0OUTtoSIE__+0, 0
;USB_HID_Library.mpas,994 :: 		end;
L_USB_HID_Library_TokenOutPID176:
;USB_HID_Library.mpas,995 :: 		end;
L_USB_HID_Library_TokenOutPID172:
;USB_HID_Library.mpas,996 :: 		end;
L_end_USB_HID_Library_TokenOutPID:
L_end_TokenOutPID:
	RETURN      0
; end of USB_HID_Library_TokenOutPID

USB_HID_Library_TokenInPID:

;USB_HID_Library.mpas,1000 :: 		begin
;USB_HID_Library.mpas,1001 :: 		Ep := (USTATCopy shr 3) and $0f; // get endpoint
	MOVF        USB_HID_Library_USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       TokenInPID_Ep+0 
;USB_HID_Library.mpas,1004 :: 		0: // endpoint 0
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenInPID181
;USB_HID_Library.mpas,1008 :: 		USB_GET_DESCRIPTOR_ONGOING:   CopyDescriptorToEP0;
	MOVF        USB_HID_Library_UsbDeviceRequest+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenInPID185
	CALL        USB_HID_Library_CopyDescriptorToEP0+0, 0
	GOTO        L_USB_HID_Library_TokenInPID182
L_USB_HID_Library_TokenInPID185:
;USB_HID_Library.mpas,1010 :: 		USB_GET_STRING_DESCRIPTOR_ONGOING:  SendStringDescriptorToEP0;
	MOVF        USB_HID_Library_UsbDeviceRequest+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenInPID188
	CALL        USB_HID_Library_SendStringDescriptorToEP0+0, 0
	GOTO        L_USB_HID_Library_TokenInPID182
L_USB_HID_Library_TokenInPID188:
;USB_HID_Library.mpas,1012 :: 		USB_SET_ADDRESS_ONGOING:      //  FinishSetAddress;
	MOVF        USB_HID_Library_UsbDeviceRequest+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenInPID191
;USB_HID_Library.mpas,1014 :: 		UsbDeviceRequest := $FF;    // clear current device request
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,1015 :: 		UsbCurrentConfig := 0;      // clear configuration
	CLRF        USB_HID_Library_UsbCurrentConfig+0 
;USB_HID_Library.mpas,1016 :: 		UADDR := UsbAddressPending; // set USB Address
	MOVF        USB_HID_Library_UsbAddressPending+0, 0 
	MOVWF       UADDR+0 
;USB_HID_Library.mpas,1017 :: 		if UsbAddressPending > 0
	MOVF        USB_HID_Library_UsbAddressPending+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_TokenInPID193
;USB_HID_Library.mpas,1018 :: 		then UsbDeviceEnumState := USB_ADDRESS_STATE; // change status
	MOVLW       2
	MOVWF       USB_HID_Library_UsbDeviceEnumState+0 
L_USB_HID_Library_TokenInPID193:
;USB_HID_Library.mpas,1023 :: 		end;
	GOTO        L_USB_HID_Library_TokenInPID182
L_USB_HID_Library_TokenInPID191:
L_USB_HID_Library_TokenInPID182:
;USB_HID_Library.mpas,1026 :: 		end;
	GOTO        L_USB_HID_Library_TokenInPID178
L_USB_HID_Library_TokenInPID181:
;USB_HID_Library.mpas,1028 :: 		1: // endpoint 1
	MOVF        TokenInPID_Ep+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenInPID197
;USB_HID_Library.mpas,1034 :: 		end;
	GOTO        L_USB_HID_Library_TokenInPID178
L_USB_HID_Library_TokenInPID197:
L_USB_HID_Library_TokenInPID178:
;USB_HID_Library.mpas,1037 :: 		end;
L_end_TokenInPID:
	RETURN      0
; end of USB_HID_Library_TokenInPID

USB_HID_Library_ClassSpecificRequestHID:

;USB_HID_Library.mpas,1041 :: 		begin
;USB_HID_Library.mpas,1051 :: 		USB_CLASS_HOST_TO_INTERFACE:  //
	MOVF        USB_HID_Library_SetUpPacket+0, 0 
	XORLW       33
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID202
;USB_HID_Library.mpas,1054 :: 		USB_SET_HID_REPORT: //
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID206
;USB_HID_Library.mpas,1059 :: 		UsbDeviceRequest := USB_HID_SET_REPORT_ONGOING;
	MOVLW       4
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,1060 :: 		EP0OutReset(USB_DAT1);
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1063 :: 		end;
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID203
L_USB_HID_Library_ClassSpecificRequestHID206:
;USB_HID_Library.mpas,1065 :: 		USB_SET_HID_IDLE: //
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID209
;USB_HID_Library.mpas,1070 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1071 :: 		SendAckToHost;
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1072 :: 		end;
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID203
L_USB_HID_Library_ClassSpecificRequestHID209:
L_USB_HID_Library_ClassSpecificRequestHID203:
;USB_HID_Library.mpas,1075 :: 		end;
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID199
L_USB_HID_Library_ClassSpecificRequestHID202:
;USB_HID_Library.mpas,1077 :: 		USB_CLASS_INTERFACE_TO_HOST:  //
	MOVF        USB_HID_Library_SetUpPacket+0, 0 
	XORLW       161
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID212
;USB_HID_Library.mpas,1080 :: 		USB_GET_HID_REPORT: // GetHIDReport
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID216
;USB_HID_Library.mpas,1086 :: 		EP0OutReset(USB_DAT1);
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1090 :: 		USB_HID_INPUT_REPORT: //
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID220
;USB_HID_Library.mpas,1097 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,1104 :: 		BDEP1INStat.UOWN := 0;          // take back buffer EP1
	BCF         1036, 7 
;USB_HID_Library.mpas,1107 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       FARG_CpyMem___Towards+0 
	MOVF        1031, 0 
	MOVWF       FARG_CpyMem___Towards+1 
;USB_HID_Library.mpas,1108 :: 		Src := ^byte(BDEP1INAdr);
	MOVF        1038, 0 
	MOVWF       FARG_CpyMem___From+0 
	MOVF        1039, 0 
	MOVWF       FARG_CpyMem___From+1 
;USB_HID_Library.mpas,1110 :: 		CpyMem__(Dst, Src, BDEP1INCnt);
	MOVF        1037, 0 
	MOVWF       FARG_CpyMem___n+0 
	MOVLW       0
	MOVWF       FARG_CpyMem___n+1 
	CALL        USB_HID_Library_CpyMem__+0, 0
;USB_HID_Library.mpas,1112 :: 		BDEP0INCnt  := BDEP1INCnt;                  // copy the bytecount
	MOVF        1037, 0 
	MOVWF       1029 
;USB_HID_Library.mpas,1113 :: 		BDEP0INStat := (USB_DTSEN or USB_DAT1 or USB_USIE); // send
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,1114 :: 		end;
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID217
L_USB_HID_Library_ClassSpecificRequestHID220:
;USB_HID_Library.mpas,1116 :: 		USB_HID_FEATURE_REPORT: //
	MOVF        USB_HID_Library_SetUpPacket+3, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID223
;USB_HID_Library.mpas,1118 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,1121 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_HID_Library.mpas,1124 :: 		BDEP0INStat := (USB_DTSEN or USB_DAT1 or USB_USIE);  // send
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,1131 :: 		end;
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID217
L_USB_HID_Library_ClassSpecificRequestHID223:
L_USB_HID_Library_ClassSpecificRequestHID217:
;USB_HID_Library.mpas,1134 :: 		end;
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID213
L_USB_HID_Library_ClassSpecificRequestHID216:
L_USB_HID_Library_ClassSpecificRequestHID213:
;USB_HID_Library.mpas,1136 :: 		end;
	GOTO        L_USB_HID_Library_ClassSpecificRequestHID199
L_USB_HID_Library_ClassSpecificRequestHID212:
L_USB_HID_Library_ClassSpecificRequestHID199:
;USB_HID_Library.mpas,1139 :: 		end;
L_end_ClassSpecificRequestHID:
	RETURN      0
; end of USB_HID_Library_ClassSpecificRequestHID

USB_HID_Library_ClassSpecificRequest:

;USB_HID_Library.mpas,1142 :: 		begin
;USB_HID_Library.mpas,1143 :: 		ClassSpecificRequestHID;
	CALL        USB_HID_Library_ClassSpecificRequestHID+0, 0
;USB_HID_Library.mpas,1144 :: 		end;
L_end_ClassSpecificRequest:
	RETURN      0
; end of USB_HID_Library_ClassSpecificRequest

USB_HID_Library_ClassSetupEndPointsHID:

;USB_HID_Library.mpas,1147 :: 		begin
;USB_HID_Library.mpas,1153 :: 		BDEP1OUTCnt  := USB_BUFF_SIZE;
	MOVLW       64
	MOVWF       1033 
;USB_HID_Library.mpas,1154 :: 		BDEP1OUTAdr  := word(@BuffEP1OUT);
	MOVLW       USB_HID_Library_BuffEP1OUT+0
	MOVWF       1034 
	MOVLW       hi_addr(USB_HID_Library_BuffEP1OUT+0)
	MOVWF       1035 
;USB_HID_Library.mpas,1155 :: 		BDEP1OUTStat := (USB_USIE or USB_DAT0 or USB_DTSEN); // set the UOWN bit (give to SIE)
	MOVLW       136
	MOVWF       1032 
;USB_HID_Library.mpas,1158 :: 		BDEP1INCnt   := 0;
	CLRF        1037 
;USB_HID_Library.mpas,1159 :: 		BDEP1INAdr   := word(@BuffEP1IN);
	MOVLW       USB_HID_Library_BuffEP1IN+0
	MOVWF       1038 
	MOVLW       hi_addr(USB_HID_Library_BuffEP1IN+0)
	MOVWF       1039 
;USB_HID_Library.mpas,1160 :: 		BDEP1INStat  := (USB_UCPU + USB_DAT1 or USB_DTSEN); // clear the UOWN bit (give to PIC)
	MOVLW       72
	MOVWF       1036 
;USB_HID_Library.mpas,1162 :: 		UEP1 := (USB_EP_OUT_IN or USB_HSHK_EN);             // in/out endpoint, handshake enabled
	MOVLW       30
	MOVWF       UEP1+0 
;USB_HID_Library.mpas,1163 :: 		end;
L_end_ClassSetupEndPointsHID:
	RETURN      0
; end of USB_HID_Library_ClassSetupEndPointsHID

USB_HID_Library_TokenSetupPID:

;USB_HID_Library.mpas,1169 :: 		begin
;USB_HID_Library.mpas,1170 :: 		UsbDeviceRequest := $FF; // clear the device request
	MOVLW       255
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,1173 :: 		Dst := ^byte(@SetupPacket);
	MOVLW       USB_HID_Library_SetUpPacket+0
	MOVWF       TokenSetupPID_Dst+0 
	MOVLW       hi_addr(USB_HID_Library_SetUpPacket+0)
	MOVWF       TokenSetupPID_Dst+1 
;USB_HID_Library.mpas,1174 :: 		Src := ^byte(BufferDescriptor^.Address);
	MOVLW       2
	ADDWF       USB_HID_Library_BufferDescriptor+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      USB_HID_Library_BufferDescriptor+1, 0 
	MOVWF       R1 
	MOVFF       R0, FSR0L
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       TokenSetupPID_Src+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       TokenSetupPID_Src+1 
;USB_HID_Library.mpas,1175 :: 		for I := 0 to (SizeOf(SetupPacket) - 1) do
	CLRF        TokenSetupPID_I+0 
L_USB_HID_Library_TokenSetupPID228:
;USB_HID_Library.mpas,1177 :: 		Dst^ := Src^;
	MOVFF       TokenSetupPID_Src+0, FSR0L
	MOVFF       TokenSetupPID_Src+1, FSR0H
	MOVFF       TokenSetupPID_Dst+0, FSR1L
	MOVFF       TokenSetupPID_Dst+1, FSR1H
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;USB_HID_Library.mpas,1178 :: 		Inc(Src);
	INFSNZ      TokenSetupPID_Src+0, 1 
	INCF        TokenSetupPID_Src+1, 1 
;USB_HID_Library.mpas,1179 :: 		Inc(Dst);
	INFSNZ      TokenSetupPID_Dst+0, 1 
	INCF        TokenSetupPID_Dst+1, 1 
;USB_HID_Library.mpas,1180 :: 		end;
	MOVF        TokenSetupPID_I+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID231
	INCF        TokenSetupPID_I+0, 1 
	GOTO        L_USB_HID_Library_TokenSetupPID228
L_USB_HID_Library_TokenSetupPID231:
;USB_HID_Library.mpas,1182 :: 		BDEP0OUTStat := 0; // make empty
	CLRF        1024 
;USB_HID_Library.mpas,1183 :: 		BDEP0INStat  := (USB_UCPU or USB_DAT0 or USB_DTSEN); // return the IN buffer to us (dequeue any pending requests)
	MOVLW       8
	MOVWF       1028 
;USB_HID_Library.mpas,1184 :: 		UCON.PKTDIS := 0; // enable setup packets
	BCF         UCON+0, 4 
;USB_HID_Library.mpas,1222 :: 		USB_STD_HOST_TO_DEVICE: //
	MOVF        USB_HID_Library_SetUpPacket+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID235
;USB_HID_Library.mpas,1226 :: 		USB_CLEAR_FEATURE:      // ClearDeviceFeature;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID239
;USB_HID_Library.mpas,1228 :: 		if SetUpPacket.wValue = 1 then // device remote wakeup
	MOVLW       0
	XORWF       USB_HID_Library_SetUpPacket+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID454
	MOVLW       1
	XORWF       USB_HID_Library_SetUpPacket+2, 0 
L_USB_HID_Library_TokenSetupPID454:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID241
;USB_HID_Library.mpas,1230 :: 		Usb_Status_Device.1 := 0;
	BCF         USB_HID_Library_Usb_Status_Device+0, 1 
;USB_HID_Library.mpas,1231 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1232 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1233 :: 		end else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID242
L_USB_HID_Library_TokenSetupPID241:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID242:
;USB_HID_Library.mpas,1234 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID236
L_USB_HID_Library_TokenSetupPID239:
;USB_HID_Library.mpas,1236 :: 		USB_SET_ADDRESS:        //SetAddress;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID245
;USB_HID_Library.mpas,1238 :: 		UsbDeviceRequest := USB_SET_ADDRESS_ONGOING;
	MOVLW       3
	MOVWF       USB_HID_Library_UsbDeviceRequest+0 
;USB_HID_Library.mpas,1239 :: 		UsbAddressPending := SetUpPacket.wValue; // USB address
	MOVF        USB_HID_Library_SetUpPacket+2, 0 
	MOVWF       USB_HID_Library_UsbAddressPending+0 
;USB_HID_Library.mpas,1244 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1245 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_HID_Library.mpas,1246 :: 		BDEP0INStat := (USB_USIE or USB_DAT1 or USB_DTSEN); // echo the buffer
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,1247 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID236
L_USB_HID_Library_TokenSetupPID245:
;USB_HID_Library.mpas,1249 :: 		USB_SET_CONFIGURATION:  // SetConfiguration;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID248
;USB_HID_Library.mpas,1251 :: 		Config := Lo(SetUpPacket.wValue);
	MOVF        USB_HID_Library_SetUpPacket+2, 0 
	MOVWF       TokenSetupPID_Config+0 
;USB_HID_Library.mpas,1252 :: 		if Config <= USB_NUM_CONFIGURATIONS then
	MOVF        USB_HID_Library_SetUpPacket+2, 0 
	SUBLW       1
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_HID_Library_TokenSetupPID250
;USB_HID_Library.mpas,1254 :: 		UsbCurrentConfig := Config;   // set configuration
	MOVF        TokenSetupPID_Config+0, 0 
	MOVWF       USB_HID_Library_UsbCurrentConfig+0 
;USB_HID_Library.mpas,1255 :: 		if Config > 0 then
	MOVF        TokenSetupPID_Config+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_HID_Library_TokenSetupPID253
;USB_HID_Library.mpas,1257 :: 		UsbDeviceEnumState := USB_CONFIG_STATE;
	MOVLW       3
	MOVWF       USB_HID_Library_UsbDeviceEnumState+0 
;USB_HID_Library.mpas,1258 :: 		ClassSetupEndPointsHID;
	CALL        USB_HID_Library_ClassSetupEndPointsHID+0, 0
;USB_HID_Library.mpas,1263 :: 		end
	GOTO        L_USB_HID_Library_TokenSetupPID254
;USB_HID_Library.mpas,1264 :: 		else
L_USB_HID_Library_TokenSetupPID253:
;USB_HID_Library.mpas,1266 :: 		UsbDeviceEnumState := USB_ADDRESS_STATE; // no configuration selected
	MOVLW       2
	MOVWF       USB_HID_Library_UsbDeviceEnumState+0 
;USB_HID_Library.mpas,1270 :: 		end;
L_USB_HID_Library_TokenSetupPID254:
;USB_HID_Library.mpas,1271 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1272 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1279 :: 		end else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID251
L_USB_HID_Library_TokenSetupPID250:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID251:
;USB_HID_Library.mpas,1280 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID236
L_USB_HID_Library_TokenSetupPID248:
;USB_HID_Library.mpas,1282 :: 		USB_SET_FEATURE:        // SetDeviceFeature
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID257
;USB_HID_Library.mpas,1284 :: 		if SetUpPacket.wValue = 1 then // device remote wakeup
	MOVLW       0
	XORWF       USB_HID_Library_SetUpPacket+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID455
	MOVLW       1
	XORWF       USB_HID_Library_SetUpPacket+2, 0 
L_USB_HID_Library_TokenSetupPID455:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID259
;USB_HID_Library.mpas,1286 :: 		Usb_Status_Device.1 := 1;  // remote wakeup
	BSF         USB_HID_Library_Usb_Status_Device+0, 1 
;USB_HID_Library.mpas,1287 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1288 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1289 :: 		end else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID260
L_USB_HID_Library_TokenSetupPID259:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID260:
;USB_HID_Library.mpas,1292 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID236
L_USB_HID_Library_TokenSetupPID257:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID236:
;USB_HID_Library.mpas,1295 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID232
L_USB_HID_Library_TokenSetupPID235:
;USB_HID_Library.mpas,1297 :: 		USB_STD_HOST_TO_INTERFACE: //
	MOVF        USB_HID_Library_SetUpPacket+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID263
;USB_HID_Library.mpas,1301 :: 		USB_CLEAR_FEATURE:      // ClearInterfaceFeature;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID267
;USB_HID_Library.mpas,1306 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1307 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1308 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID264
L_USB_HID_Library_TokenSetupPID267:
;USB_HID_Library.mpas,1310 :: 		USB_SET_INTERFACE:      // SetInterface;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       11
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID270
;USB_HID_Library.mpas,1312 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE then
	MOVF        USB_HID_Library_UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID272
;USB_HID_Library.mpas,1314 :: 		UsbInterface := SetupPacket.wIndex;
	MOVF        USB_HID_Library_SetUpPacket+4, 0 
	MOVWF       USB_HID_Library_UsbInterface+0 
;USB_HID_Library.mpas,1315 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1316 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1317 :: 		end else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID273
L_USB_HID_Library_TokenSetupPID272:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID273:
;USB_HID_Library.mpas,1318 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID264
L_USB_HID_Library_TokenSetupPID270:
;USB_HID_Library.mpas,1320 :: 		USB_SET_FEATURE:        // SetInterfaceFeature
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID276
;USB_HID_Library.mpas,1325 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1326 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1329 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID264
L_USB_HID_Library_TokenSetupPID276:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID264:
;USB_HID_Library.mpas,1332 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID232
L_USB_HID_Library_TokenSetupPID263:
;USB_HID_Library.mpas,1334 :: 		USB_STD_HOST_TO_ENDPOINT: //
	MOVF        USB_HID_Library_SetUpPacket+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID279
;USB_HID_Library.mpas,1337 :: 		Ep := SetUpPacket.wIndex and $8F; // endpoint
	MOVLW       143
	ANDWF       USB_HID_Library_SetUpPacket+4, 0 
	MOVWF       TokenSetupPID_Ep+0 
;USB_HID_Library.mpas,1341 :: 		USB_CLEAR_FEATURE:      // ClearEndpointFeature
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID283
;USB_HID_Library.mpas,1344 :: 		USB_EP01_OUT : BDEP1OUTStat := (USB_USIE or USB_DAT0 or USB_DTSEN);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID287
	MOVLW       136
	MOVWF       1032 
	GOTO        L_USB_HID_Library_TokenSetupPID284
L_USB_HID_Library_TokenSetupPID287:
;USB_HID_Library.mpas,1345 :: 		USB_EP01_IN  : BDEP1INStat  := (USB_UCPU or USB_DAT1)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       129
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID290
	MOVLW       64
	MOVWF       1036 
;USB_HID_Library.mpas,1346 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID284
L_USB_HID_Library_TokenSetupPID290:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID284:
;USB_HID_Library.mpas,1348 :: 		if not EP0Stalled then
	CALL        USB_HID_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID292
;USB_HID_Library.mpas,1350 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1351 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1352 :: 		end;
L_USB_HID_Library_TokenSetupPID292:
;USB_HID_Library.mpas,1356 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID280
L_USB_HID_Library_TokenSetupPID283:
;USB_HID_Library.mpas,1358 :: 		USB_SET_FEATURE:        // SetEndpointFeature
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID296
;USB_HID_Library.mpas,1361 :: 		USB_EP01_OUT : BDEP1OUTStat := (USB_USIE or USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID300
	MOVLW       132
	MOVWF       1032 
	GOTO        L_USB_HID_Library_TokenSetupPID297
L_USB_HID_Library_TokenSetupPID300:
;USB_HID_Library.mpas,1362 :: 		USB_EP01_IN  : BDEP1INStat  := (USB_USIE or USB_BSTALL)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       129
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID303
	MOVLW       132
	MOVWF       1036 
;USB_HID_Library.mpas,1363 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID297
L_USB_HID_Library_TokenSetupPID303:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID297:
;USB_HID_Library.mpas,1365 :: 		if not EP0Stalled then
	CALL        USB_HID_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID305
;USB_HID_Library.mpas,1367 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1368 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1369 :: 		end;
L_USB_HID_Library_TokenSetupPID305:
;USB_HID_Library.mpas,1375 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID280
L_USB_HID_Library_TokenSetupPID296:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID280:
;USB_HID_Library.mpas,1378 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID232
L_USB_HID_Library_TokenSetupPID279:
;USB_HID_Library.mpas,1380 :: 		USB_STD_DEVICE_TO_HOST: //
	MOVF        USB_HID_Library_SetUpPacket+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID309
;USB_HID_Library.mpas,1384 :: 		USB_GET_CONFIGURATION:  // GetConfiguration;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID313
;USB_HID_Library.mpas,1386 :: 		BuffEP0IN[0] := 0;
	CLRF        1104 
;USB_HID_Library.mpas,1387 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE
	MOVF        USB_HID_Library_UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID315
;USB_HID_Library.mpas,1388 :: 		then BuffEP0IN[0] := UsbCurrentConfig;
	MOVF        USB_HID_Library_UsbCurrentConfig+0, 0 
	MOVWF       1104 
L_USB_HID_Library_TokenSetupPID315:
;USB_HID_Library.mpas,1389 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1390 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_HID_Library.mpas,1391 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,1392 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID310
L_USB_HID_Library_TokenSetupPID313:
;USB_HID_Library.mpas,1394 :: 		USB_GET_DESCRIPTOR:     GetDescriptor;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID319
	CALL        USB_HID_Library_GetDescriptor+0, 0
	GOTO        L_USB_HID_Library_TokenSetupPID310
L_USB_HID_Library_TokenSetupPID319:
;USB_HID_Library.mpas,1396 :: 		USB_GET_STATUS:         // GetDeviceStatus
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID322
;USB_HID_Library.mpas,1398 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1399 :: 		BuffEP0IN[0] := Usb_Status_Device;
	MOVF        USB_HID_Library_Usb_Status_Device+0, 0 
	MOVWF       1104 
;USB_HID_Library.mpas,1400 :: 		BuffEP0IN[1] := 0;
	CLRF        1105 
;USB_HID_Library.mpas,1401 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_HID_Library.mpas,1402 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,1405 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID310
L_USB_HID_Library_TokenSetupPID322:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID310:
;USB_HID_Library.mpas,1408 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID232
L_USB_HID_Library_TokenSetupPID309:
;USB_HID_Library.mpas,1410 :: 		USB_STD_INTERFACE_TO_HOST: //
	MOVF        USB_HID_Library_SetUpPacket+0, 0 
	XORLW       129
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID325
;USB_HID_Library.mpas,1414 :: 		USB_GET_INTERFACE:      // GetInterface;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID329
;USB_HID_Library.mpas,1417 :: 		if UsbDeviceEnumState <> USB_ADDRESS_STATE then
	MOVF        USB_HID_Library_UsbDeviceEnumState+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID331
;USB_HID_Library.mpas,1419 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1420 :: 		BuffEP0IN[0] := UsbInterface;
	MOVF        USB_HID_Library_UsbInterface+0, 0 
	MOVWF       1104 
;USB_HID_Library.mpas,1421 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_HID_Library.mpas,1422 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,1423 :: 		end else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID332
L_USB_HID_Library_TokenSetupPID331:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID332:
;USB_HID_Library.mpas,1424 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID326
L_USB_HID_Library_TokenSetupPID329:
;USB_HID_Library.mpas,1426 :: 		USB_GET_STATUS:         // GetInterfaceStatus;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID335
;USB_HID_Library.mpas,1428 :: 		if UsbDeviceEnumState <> USB_ADDRESS_STATE then
	MOVF        USB_HID_Library_UsbDeviceEnumState+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID337
;USB_HID_Library.mpas,1430 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1431 :: 		BuffEP0IN[0] := 0;
	CLRF        1104 
;USB_HID_Library.mpas,1432 :: 		BuffEP0IN[1] := 0;
	CLRF        1105 
;USB_HID_Library.mpas,1433 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_HID_Library.mpas,1434 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: go
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,1435 :: 		end else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID338
L_USB_HID_Library_TokenSetupPID337:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID338:
;USB_HID_Library.mpas,1436 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID326
L_USB_HID_Library_TokenSetupPID335:
;USB_HID_Library.mpas,1438 :: 		USB_GET_DESCRIPTOR:     GetDescriptor
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID341
	CALL        USB_HID_Library_GetDescriptor+0, 0
;USB_HID_Library.mpas,1440 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID326
L_USB_HID_Library_TokenSetupPID341:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID326:
;USB_HID_Library.mpas,1443 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID232
L_USB_HID_Library_TokenSetupPID325:
;USB_HID_Library.mpas,1445 :: 		USB_STD_ENDPOINT_TO_HOST: //
	MOVF        USB_HID_Library_SetUpPacket+0, 0 
	XORLW       130
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID344
;USB_HID_Library.mpas,1448 :: 		Ep := SetUpPacket.wIndex and $8F;  // endpoint number
	MOVLW       143
	ANDWF       USB_HID_Library_SetUpPacket+4, 0 
	MOVWF       TokenSetupPID_Ep+0 
;USB_HID_Library.mpas,1452 :: 		USB_GET_STATUS:         //GetEndpointStatus;
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID348
;USB_HID_Library.mpas,1456 :: 		USB_EP00_OUT : BuffEP0IN[0] := bit_(BDEP0OUTStat and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID352
	MOVLW       4
	ANDWF       1024, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1104 
	GOTO        L_USB_HID_Library_TokenSetupPID349
L_USB_HID_Library_TokenSetupPID352:
;USB_HID_Library.mpas,1457 :: 		USB_EP00_IN  : BuffEP0IN[0] := bit_(BDEP0INStat  and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID355
	MOVLW       4
	ANDWF       1028, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1104 
	GOTO        L_USB_HID_Library_TokenSetupPID349
L_USB_HID_Library_TokenSetupPID355:
;USB_HID_Library.mpas,1458 :: 		USB_EP01_OUT : BuffEP0IN[0] := bit_(BDEP1OUTStat and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID358
	MOVLW       4
	ANDWF       1032, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1104 
	GOTO        L_USB_HID_Library_TokenSetupPID349
L_USB_HID_Library_TokenSetupPID358:
;USB_HID_Library.mpas,1459 :: 		USB_EP01_IN  : BuffEP0IN[0] := bit_(BDEP1INStat  and USB_BSTALL)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       129
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID361
	MOVLW       4
	ANDWF       1036, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1104 
;USB_HID_Library.mpas,1460 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID349
L_USB_HID_Library_TokenSetupPID361:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID349:
;USB_HID_Library.mpas,1462 :: 		if not EP0Stalled then
	CALL        USB_HID_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID363
;USB_HID_Library.mpas,1464 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1465 :: 		BuffEP0IN[1] := 0;
	CLRF        1105 
;USB_HID_Library.mpas,1466 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_HID_Library.mpas,1467 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: go
	MOVLW       200
	MOVWF       1028 
;USB_HID_Library.mpas,1468 :: 		end;
L_USB_HID_Library_TokenSetupPID363:
;USB_HID_Library.mpas,1469 :: 		end;
	GOTO        L_USB_HID_Library_TokenSetupPID345
L_USB_HID_Library_TokenSetupPID348:
;USB_HID_Library.mpas,1471 :: 		USB_SYNCH_FRAME: //
	MOVF        USB_HID_Library_SetUpPacket+1, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID367
;USB_HID_Library.mpas,1476 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_HID_Library_EP0OutReset+0, 0
;USB_HID_Library.mpas,1477 :: 		SendAckToHost; // send acknowledge
	CALL        USB_HID_Library_SendAckToHost+0, 0
;USB_HID_Library.mpas,1480 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID345
L_USB_HID_Library_TokenSetupPID367:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID345:
;USB_HID_Library.mpas,1485 :: 		else
	GOTO        L_USB_HID_Library_TokenSetupPID232
L_USB_HID_Library_TokenSetupPID344:
;USB_HID_Library.mpas,1487 :: 		case (SetUpPacket.bmRequestType and $60) shr 5 of
	MOVLW       96
	ANDWF       USB_HID_Library_SetUpPacket+0, 0 
	MOVWF       R1 
	MOVLW       5
	MOVWF       R0 
	MOVF        R1, 0 
	MOVWF       FLOC_USB_HID_Library_TokenSetupPID+0 
	MOVF        R0, 0 
L_USB_HID_Library_TokenSetupPID456:
	BZ          L_USB_HID_Library_TokenSetupPID457
	RRCF        FLOC_USB_HID_Library_TokenSetupPID+0, 1 
	BCF         FLOC_USB_HID_Library_TokenSetupPID+0, 7 
	ADDLW       255
	GOTO        L_USB_HID_Library_TokenSetupPID456
L_USB_HID_Library_TokenSetupPID457:
;USB_HID_Library.mpas,1489 :: 		USB_CLASS: ClassSpecificRequest;      // Class specific request
	MOVF        FLOC_USB_HID_Library_TokenSetupPID+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID371
	CALL        USB_HID_Library_ClassSpecificRequest+0, 0
	GOTO        L_USB_HID_Library_TokenSetupPID368
L_USB_HID_Library_TokenSetupPID371:
;USB_HID_Library.mpas,1490 :: 		USB_VENDOR:                           // CheckforVendorRequest;
	MOVF        FLOC_USB_HID_Library_TokenSetupPID+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_TokenSetupPID374
;USB_HID_Library.mpas,1493 :: 		else StallEP0;
	GOTO        L_USB_HID_Library_TokenSetupPID368
L_USB_HID_Library_TokenSetupPID374:
	CALL        USB_HID_Library_StallEP0+0, 0
L_USB_HID_Library_TokenSetupPID368:
;USB_HID_Library.mpas,1495 :: 		end;
L_USB_HID_Library_TokenSetupPID232:
;USB_HID_Library.mpas,1497 :: 		end;
L_end_TokenSetupPID:
	RETURN      0
; end of USB_HID_Library_TokenSetupPID

_USB_Interrupt:

;USB_HID_Library.mpas,1501 :: 		begin
;USB_HID_Library.mpas,1506 :: 		if PIR2.USBIF = 1 then // usb interrupt occurred
	BTFSS       PIR2+0, 5 
	GOTO        L__USB_Interrupt377
;USB_HID_Library.mpas,1508 :: 		PIR2.USBIF := 0;
	BCF         PIR2+0, 5 
;USB_HID_Library.mpas,1510 :: 		Tmp := UIR and UIE; // get the enabled interrupts
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_HID_Library.mpas,1512 :: 		while Tmp > 0 do    // some interrupts have occured
L__USB_Interrupt380:
	MOVF        USB_Interrupt_Tmp+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_Interrupt381
;USB_HID_Library.mpas,1514 :: 		while Tmp.TRNIF = 1 do
L__USB_Interrupt385:
	BTFSS       USB_Interrupt_Tmp+0, 3 
	GOTO        L__USB_Interrupt386
;USB_HID_Library.mpas,1517 :: 		USTATCopy := USTAT; // get copy of the status register
	MOVF        USTAT+0, 0 
	MOVWF       USB_HID_Library_USTATCopy+0 
;USB_HID_Library.mpas,1519 :: 		BufferDescriptor := ^TBufferDescriptor(@BDEP0OUTStat) + ((USTATCopy shr 2) and $1F); // create pointer to BufferDescriptor of EPx
	MOVF        USB_HID_Library_USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       31
	ANDWF       R0, 0 
	MOVWF       R3 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       USB_HID_Library_BDEP0OUTStat+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(USB_HID_Library_BDEP0OUTStat+0)
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       USB_HID_Library_BufferDescriptor+0 
	MOVF        R1, 0 
	MOVWF       USB_HID_Library_BufferDescriptor+1 
;USB_HID_Library.mpas,1521 :: 		UIR.TRNIF := 0;    // clear the interrupt flag (enable further activity)
	BCF         UIR+0, 3 
;USB_HID_Library.mpas,1523 :: 		if BufferDescriptor^.Status.UOWN = 0 then
	MOVF        R0, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0L
	MOVFF       R3, FSR0H
	BTFSC       POSTINC0+0, 7 
	GOTO        L__USB_Interrupt390
;USB_HID_Library.mpas,1525 :: 		Pid := (BufferDescriptor^.Status shr 2) and $0f; // get the PID out of the endpoint buffer status
	MOVFF       USB_HID_Library_BufferDescriptor+0, FSR0L
	MOVFF       USB_HID_Library_BufferDescriptor+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       USB_Interrupt_Pid+0 
;USB_HID_Library.mpas,1527 :: 		USB_TOKEN_IN:     TokenInPid;
	MOVF        R1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt395
	CALL        USB_HID_Library_TokenInPID+0, 0
	GOTO        L__USB_Interrupt392
L__USB_Interrupt395:
;USB_HID_Library.mpas,1528 :: 		USB_TOKEN_OUT:    TokenOutPid;
	MOVF        USB_Interrupt_Pid+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt398
	CALL        USB_HID_Library_TokenOutPID+0, 0
	GOTO        L__USB_Interrupt392
L__USB_Interrupt398:
;USB_HID_Library.mpas,1529 :: 		USB_TOKEN_SETUP:  TokenSetupPID
	MOVF        USB_Interrupt_Pid+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt401
	CALL        USB_HID_Library_TokenSetupPID+0, 0
;USB_HID_Library.mpas,1530 :: 		else StallEP0;
	GOTO        L__USB_Interrupt392
L__USB_Interrupt401:
	CALL        USB_HID_Library_StallEP0+0, 0
L__USB_Interrupt392:
;USB_HID_Library.mpas,1532 :: 		end;
L__USB_Interrupt390:
;USB_HID_Library.mpas,1533 :: 		Tmp := UIR and UIE;
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_HID_Library.mpas,1534 :: 		end;
	GOTO        L__USB_Interrupt385
L__USB_Interrupt386:
;USB_HID_Library.mpas,1536 :: 		if Tmp.URSTIF  = 1 then UsbReset;
	BTFSS       USB_Interrupt_Tmp+0, 0 
	GOTO        L__USB_Interrupt403
	CALL        USB_HID_Library_UsbReset+0, 0
L__USB_Interrupt403:
;USB_HID_Library.mpas,1538 :: 		if Tmp.STALLIF = 1 then UIR.STALLIF := 0; // clear interrupt flag
	BTFSS       USB_Interrupt_Tmp+0, 5 
	GOTO        L__USB_Interrupt406
	BCF         UIR+0, 5 
L__USB_Interrupt406:
;USB_HID_Library.mpas,1548 :: 		if Tmp.IDLEIF  = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 4 
	GOTO        L__USB_Interrupt409
;USB_HID_Library.mpas,1550 :: 		IsIdle := true;
	MOVLW       255
	MOVWF       USB_HID_Library_IsIdle+0 
;USB_HID_Library.mpas,1551 :: 		UIE.IDLEIE := 0; // disable the idle interrupt
	BCF         UIE+0, 4 
;USB_HID_Library.mpas,1552 :: 		UIR.SOFIF  := 0;
	BCF         UIR+0, 6 
;USB_HID_Library.mpas,1553 :: 		UIE.SOFIE :=  1; // enable the SOF interrupt
	BSF         UIE+0, 6 
;USB_HID_Library.mpas,1554 :: 		UIR.IDLEIF := 0; // clear interrupt flag
	BCF         UIR+0, 4 
;USB_HID_Library.mpas,1555 :: 		end;
L__USB_Interrupt409:
;USB_HID_Library.mpas,1557 :: 		if Tmp.SOFIF = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 6 
	GOTO        L__USB_Interrupt412
;USB_HID_Library.mpas,1559 :: 		IsIdle     := false; // clear the "is Idle" bit 0
	CLRF        USB_HID_Library_IsIdle+0 
;USB_HID_Library.mpas,1560 :: 		UIE.SOFIE  := 0;     // disable the SOF interrupt
	BCF         UIE+0, 6 
;USB_HID_Library.mpas,1561 :: 		UIR.IDLEIF := 0;
	BCF         UIR+0, 4 
;USB_HID_Library.mpas,1562 :: 		UIE.IDLEIE := 1;     // enable the idle interrupt
	BSF         UIE+0, 4 
;USB_HID_Library.mpas,1563 :: 		UIR.SOFIF  := 0;     // clear interrupt flag
	BCF         UIR+0, 6 
;USB_HID_Library.mpas,1564 :: 		end;
L__USB_Interrupt412:
;USB_HID_Library.mpas,1566 :: 		Tmp := UIR and UIE; // get the enabled interrupts
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_HID_Library.mpas,1567 :: 		end;
	GOTO        L__USB_Interrupt380
L__USB_Interrupt381:
;USB_HID_Library.mpas,1569 :: 		end;
L__USB_Interrupt377:
;USB_HID_Library.mpas,1571 :: 		end;
L_end_USB_Interrupt:
	RETURN      0
; end of _USB_Interrupt
