
_ConfiguredUsb:

;USB_MSD_Library.mpas,707 :: 		begin
;USB_MSD_Library.mpas,708 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ConfiguredUsb2
;USB_MSD_Library.mpas,709 :: 		then Result := true
	MOVLW       255
	MOVWF       R1 
	GOTO        L__ConfiguredUsb3
;USB_MSD_Library.mpas,710 :: 		else Result := false;
L__ConfiguredUsb2:
	CLRF        R1 
L__ConfiguredUsb3:
;USB_MSD_Library.mpas,711 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_ConfiguredUsb:
	RETURN      0
; end of _ConfiguredUsb

_ActiveUsb:

;USB_MSD_Library.mpas,714 :: 		begin
;USB_MSD_Library.mpas,715 :: 		if (IsIdle = false) and (UsbDeviceEnumState = USB_CONFIG_STATE)
	MOVF        _IsIdle+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       3
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__ActiveUsb6
;USB_MSD_Library.mpas,716 :: 		then Result := true
	MOVLW       255
	MOVWF       R2 
	GOTO        L__ActiveUsb7
;USB_MSD_Library.mpas,717 :: 		else Result := false;
L__ActiveUsb6:
	CLRF        R2 
L__ActiveUsb7:
;USB_MSD_Library.mpas,718 :: 		end;
	MOVF        R2, 0 
	MOVWF       R0 
L_end_ActiveUsb:
	RETURN      0
; end of _ActiveUsb

_InitUsb:

;USB_MSD_Library.mpas,721 :: 		begin
;USB_MSD_Library.mpas,735 :: 		UsbDeviceRequest  := $FF; // no device requests in progress
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,737 :: 		UsbDeviceEnumState := USB_POWERED_STATE;
	CLRF        _UsbDeviceEnumState+0 
;USB_MSD_Library.mpas,742 :: 		UsbCurrentConfig  := 0; // no configuration selected
	CLRF        _UsbCurrentConfig+0 
;USB_MSD_Library.mpas,743 :: 		Usb_Status_Device := 1; //
	MOVLW       1
	MOVWF       _Usb_Status_Device+0 
;USB_MSD_Library.mpas,744 :: 		UsbInterface      := 0;
	CLRF        _UsbInterface+0 
;USB_MSD_Library.mpas,746 :: 		UADDR := 0;
	CLRF        UADDR+0 
;USB_MSD_Library.mpas,748 :: 		UCFG.7      := 0; // eye pattern disabled
	BCF         UCFG+0, 7 
;USB_MSD_Library.mpas,749 :: 		UCFG.UOEMON := 0; // OE monitor disabled
	BCF         UCFG+0, 6 
;USB_MSD_Library.mpas,750 :: 		UCFG.UPUEN  := 1; // on chip pull up enabled
	BSF         UCFG+0, 4 
;USB_MSD_Library.mpas,751 :: 		UCFG.UTRDIS := 0; // on chip tranceiver active
	BCF         UCFG+0, 3 
;USB_MSD_Library.mpas,752 :: 		UCFG.FSEN   := 1; // Full speed enable (48 MHz USB clock required)
	BSF         UCFG+0, 2 
;USB_MSD_Library.mpas,753 :: 		UCFG.PPB1   := 0; // ping pong buffers disabled
	BCF         UCFG+0, 1 
;USB_MSD_Library.mpas,754 :: 		UCFG.PPB0   := 0; //
	BCF         UCFG+0, 0 
;USB_MSD_Library.mpas,756 :: 		UIR   := 0; // clear all Usb interrupt flags
	CLRF        UIR+0 
;USB_MSD_Library.mpas,757 :: 		UIE   := 1; // the only interrupt enabled is "USB reset"
	MOVLW       1
	MOVWF       UIE+0 
;USB_MSD_Library.mpas,759 :: 		PIR2.USBIF := 0; // clear usb interrupt flag
	BCF         PIR2+0, 5 
;USB_MSD_Library.mpas,760 :: 		PIE2.USBIE := 1; // enable Usb interrupts
	BSF         PIE2+0, 5 
;USB_MSD_Library.mpas,762 :: 		INTCON.PEIE := 1; // peripheral interrupt enable
	BSF         INTCON+0, 6 
;USB_MSD_Library.mpas,763 :: 		INTCON.GIE  := 1; // global enable
	BSF         INTCON+0, 7 
;USB_MSD_Library.mpas,765 :: 		UCON  := 8; // attach device (USBEN = 1)
	MOVLW       8
	MOVWF       UCON+0 
;USB_MSD_Library.mpas,766 :: 		repeat
L__InitUsb9:
;USB_MSD_Library.mpas,767 :: 		until UCON.SE0 = 0;
	BTFSC       UCON+0, 5 
	GOTO        L__InitUsb9
;USB_MSD_Library.mpas,768 :: 		end;
L_end_InitUsb:
	RETURN      0
; end of _InitUsb

_DeInitUsb:

;USB_MSD_Library.mpas,771 :: 		begin
;USB_MSD_Library.mpas,772 :: 		UCON.USBEN  := 0; // detach
	BCF         UCON+0, 3 
;USB_MSD_Library.mpas,773 :: 		UCON.SUSPND := 1; // suspend mode
	BSF         UCON+0, 1 
;USB_MSD_Library.mpas,775 :: 		UsbDeviceEnumState := USB_POWERED_STATE;
	CLRF        _UsbDeviceEnumState+0 
;USB_MSD_Library.mpas,780 :: 		PIE2.USBIE := 0;  // disable the USB interrupts
	BCF         PIE2+0, 5 
;USB_MSD_Library.mpas,781 :: 		end;
L_end_DeInitUsb:
	RETURN      0
; end of _DeInitUsb

_SoftDetachUsb:

;USB_MSD_Library.mpas,784 :: 		begin
;USB_MSD_Library.mpas,785 :: 		UCON.USBEN := 0;
	BCF         UCON+0, 3 
;USB_MSD_Library.mpas,786 :: 		Delay_ms(100);
	MOVLW       7
	MOVWF       R11, 0
	MOVLW       23
	MOVWF       R12, 0
	MOVLW       106
	MOVWF       R13, 0
L__SoftDetachUsb16:
	DECFSZ      R13, 1, 1
	BRA         L__SoftDetachUsb16
	DECFSZ      R12, 1, 1
	BRA         L__SoftDetachUsb16
	DECFSZ      R11, 1, 1
	BRA         L__SoftDetachUsb16
	NOP
;USB_MSD_Library.mpas,787 :: 		InitUsb;
	CALL        _InitUsb+0, 0
;USB_MSD_Library.mpas,788 :: 		end;
L_end_SoftDetachUsb:
	RETURN      0
; end of _SoftDetachUsb

USB_MSD_Library_EP0InReset:

;USB_MSD_Library.mpas,791 :: 		begin
;USB_MSD_Library.mpas,792 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_MSD_Library.mpas,793 :: 		BDEP0INStat := (USB_UCPU or USB_DAT0 or USB_DTSEN); // UOWN = 0, DTSEN = 1;
	MOVLW       8
	MOVWF       1028 
;USB_MSD_Library.mpas,794 :: 		end;
L_end_EP0InReset:
	RETURN      0
; end of USB_MSD_Library_EP0InReset

USB_MSD_Library_EP0OutReset:

;USB_MSD_Library.mpas,797 :: 		begin
;USB_MSD_Library.mpas,798 :: 		BDEP0OUTCnt  := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_MSD_Library.mpas,799 :: 		BDEP0OUTStat := (USB_USIE or USBDat or USB_DTSEN); // UOWN = 1 and DTSEN = 1; // ready to receive data
	MOVLW       128
	IORWF       FARG_EP0OutReset_USBDat+0, 0 
	MOVWF       R0 
	MOVLW       8
	IORWF       R0, 0 
	MOVWF       1024 
;USB_MSD_Library.mpas,800 :: 		end;
L_end_EP0OutReset:
	RETURN      0
; end of USB_MSD_Library_EP0OutReset

USB_MSD_Library_GiveEP0INtoSIE__:

;USB_MSD_Library.mpas,803 :: 		begin
;USB_MSD_Library.mpas,804 :: 		BDEP0INStat := BDEP0INStat xor USB_DTSMASK;             // toggle the DTS bit
	BTG         1028, 6 
;USB_MSD_Library.mpas,805 :: 		BDEP0INStat := BDEP0INStat and USB_DTSMASK;             // clear the PID bits except DTS
	MOVLW       64
	ANDWF       1028, 1 
;USB_MSD_Library.mpas,806 :: 		BDEP0INStat := BDEP0INStat or (USB_DTSEN or USB_USIE);  // go: set DTSEN
	MOVLW       136
	IORWF       1028, 1 
;USB_MSD_Library.mpas,807 :: 		end;
L_end_GiveEP0INtoSIE__:
	RETURN      0
; end of USB_MSD_Library_GiveEP0INtoSIE__

USB_MSD_Library_GiveEP0OUTtoSIE__:

;USB_MSD_Library.mpas,810 :: 		begin
;USB_MSD_Library.mpas,811 :: 		BDEP0OUTStat := BDEP0OUTStat and USB_DTSMask;            // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1024, 1 
;USB_MSD_Library.mpas,812 :: 		BDEP0OUTStat := BDEP0OUTStat xor USB_DTSMask;            // toggle data 0/1
	BTG         1024, 6 
;USB_MSD_Library.mpas,813 :: 		BDEP0OUTStat := BDEP0OUTStat or (USB_DTSEN or USB_USIE); // set the DTS bit and the UOWN bit
	MOVLW       136
	IORWF       1024, 1 
;USB_MSD_Library.mpas,814 :: 		end;
L_end_GiveEP0OUTtoSIE__:
	RETURN      0
; end of USB_MSD_Library_GiveEP0OUTtoSIE__

USB_MSD_Library_StallEP0:

;USB_MSD_Library.mpas,817 :: 		begin
;USB_MSD_Library.mpas,821 :: 		UsbDeviceRequest := $FF; // disregard any pending device request
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,823 :: 		BDEP0OUTCnt      := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_MSD_Library.mpas,824 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_MSD_Library.mpas,825 :: 		BDEP0OUTStat     := (USB_USIE or USB_BSTALL);
	MOVLW       132
	MOVWF       1024 
;USB_MSD_Library.mpas,826 :: 		BDEP0INStat      := (USB_USIE or USB_BSTALL);
	MOVLW       132
	MOVWF       1028 
;USB_MSD_Library.mpas,827 :: 		end;
L_end_StallEP0:
	RETURN      0
; end of USB_MSD_Library_StallEP0

USB_MSD_Library_EP0Stalled:

;USB_MSD_Library.mpas,830 :: 		begin
;USB_MSD_Library.mpas,831 :: 		Result := (BDEP0INStat and USB_BSTALL) > 0;
	MOVLW       4
	ANDWF       1028, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	SUBLW       0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R1 
;USB_MSD_Library.mpas,832 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_EP0Stalled:
	RETURN      0
; end of USB_MSD_Library_EP0Stalled

USB_MSD_Library_Msd_SendPacket:

;USB_MSD_Library.mpas,840 :: 		begin
;USB_MSD_Library.mpas,850 :: 		repeat
L_USB_MSD_Library_Msd_SendPacket24:
;USB_MSD_Library.mpas,851 :: 		until (BDEP4INStat.UOWN = 0);                                  // wait until the PIC owns the buffer
	BTFSC       1060, 7 
	GOTO        L_USB_MSD_Library_Msd_SendPacket24
;USB_MSD_Library.mpas,852 :: 		BDEP4INCnt  := Len;
	MOVF        FARG_Msd_SendPacket_Len+0, 0 
	MOVWF       1061 
;USB_MSD_Library.mpas,853 :: 		BDEP4INStat := BDEP4INStat and USB_DTSMASK;                    // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1060, 1 
;USB_MSD_Library.mpas,854 :: 		BDEP4INStat := BDEP4INStat xor USB_DTSMASK;  // toggle the data 0/1 bit
	BTG         1060, 6 
;USB_MSD_Library.mpas,855 :: 		BDEP4INStat := BDEP4INStat or (USB_DTSEN or USB_USIE);         // set the DTSEN bit and UOWN bit (enable sending)
	MOVLW       136
	IORWF       1060, 1 
;USB_MSD_Library.mpas,856 :: 		end;
L_end_Msd_SendPacket:
	RETURN      0
; end of USB_MSD_Library_Msd_SendPacket

USB_MSD_Library_Msd_ReceivePacket:

;USB_MSD_Library.mpas,860 :: 		begin
;USB_MSD_Library.mpas,861 :: 		BDEP4OUTCnt  := USB_MSD_BULK_OUT_EP_SIZE;
	MOVLW       64
	MOVWF       1057 
;USB_MSD_Library.mpas,862 :: 		BDEP4OUTStat := BDEP4OUTStat and USB_DTSMASK;                   // save data 0/1 bit
	MOVLW       64
	ANDWF       1056, 1 
;USB_MSD_Library.mpas,863 :: 		BDEP4OUTStat := BDEP4OUTStat xor USB_DTSMASK; // toggle the data 0/1 bit
	BTG         1056, 6 
;USB_MSD_Library.mpas,864 :: 		BDEP4OUTStat := BDEP4OUTStat or (USB_USIE or USB_DTSEN);        // set UOWN and DTS: give buffer back to SIE
	MOVLW       136
	IORWF       1056, 1 
;USB_MSD_Library.mpas,865 :: 		end;
L_end_Msd_ReceivePacket:
	RETURN      0
; end of USB_MSD_Library_Msd_ReceivePacket

USB_MSD_Library_Msd_SendBulkZeroLenPacket:

;USB_MSD_Library.mpas,868 :: 		begin
;USB_MSD_Library.mpas,869 :: 		Msd_SendPacket(0); // zero length packet
	CLRF        FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_Msd_SendPacket+0, 0
;USB_MSD_Library.mpas,870 :: 		end;
L_end_Msd_SendBulkZeroLenPacket:
	RETURN      0
; end of USB_MSD_Library_Msd_SendBulkZeroLenPacket

USB_MSD_Library_SendZeroLenPacket:

;USB_MSD_Library.mpas,873 :: 		begin
;USB_MSD_Library.mpas,877 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,878 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_MSD_Library.mpas,879 :: 		BDEP0INStat      := (USB_USIE or USB_DAT1 or USB_DTSEN); // UOWN, DTS (data1) and DTSEN are set
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,880 :: 		end;
L_end_SendZeroLenPacket:
	RETURN      0
; end of USB_MSD_Library_SendZeroLenPacket

USB_MSD_Library_SendAckToHost:

;USB_MSD_Library.mpas,883 :: 		begin
;USB_MSD_Library.mpas,887 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,888 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_MSD_Library.mpas,889 :: 		BDEP0INStat      := (USB_USIE or USB_DAT1 or USB_DTSEN); // UOWN, DTS (data1) and DTSEN are set
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,890 :: 		end;
L_end_SendAckToHost:
	RETURN      0
; end of USB_MSD_Library_SendAckToHost

USB_MSD_Library_Msd_ResetSenseData:

;USB_MSD_Library.mpas,893 :: 		begin
;USB_MSD_Library.mpas,894 :: 		Msd_SenseData.ResponseCode_Valid       := USB_MSD_S_CURRENT;
	MOVLW       112
	MOVWF       USB_MSD_Library_Msd_SenseData+0 
;USB_MSD_Library.mpas,895 :: 		Msd_SenseData.ResponseCode_Valid.valid := 0;
	BCF         USB_MSD_Library_Msd_SenseData+0, 7 
;USB_MSD_Library.mpas,896 :: 		Msd_SenseData.Obsolete                 := 0;
	CLRF        USB_MSD_Library_Msd_SenseData+1 
;USB_MSD_Library.mpas,897 :: 		Msd_SenseData.SenseKey_etc             := USB_MSD_S_NO_SENSE;
	CLRF        USB_MSD_Library_Msd_SenseData+2 
;USB_MSD_Library.mpas,898 :: 		Msd_SenseData.SenseKey_etc.ILI         :=0;
	BCF         USB_MSD_Library_Msd_SenseData+2, 5 
;USB_MSD_Library.mpas,899 :: 		Msd_SenseData.SenseKey_etc.EOM         :=0;
	BCF         USB_MSD_Library_Msd_SenseData+2, 6 
;USB_MSD_Library.mpas,900 :: 		Msd_SenseData.SenseKey_etc.FILEMARK    :=0;
	BCF         USB_MSD_Library_Msd_SenseData+2, 7 
;USB_MSD_Library.mpas,901 :: 		Msd_SenseData.InformationB0            := 0x00;
	CLRF        USB_MSD_Library_Msd_SenseData+3 
;USB_MSD_Library.mpas,902 :: 		Msd_SenseData.InformationB1            := 0x00;
	CLRF        USB_MSD_Library_Msd_SenseData+4 
;USB_MSD_Library.mpas,903 :: 		Msd_SenseData.InformationB2            := 0x00;
	CLRF        USB_MSD_Library_Msd_SenseData+5 
;USB_MSD_Library.mpas,904 :: 		Msd_SenseData.InformationB3            := 0x00;
	CLRF        USB_MSD_Library_Msd_SenseData+6 
;USB_MSD_Library.mpas,905 :: 		Msd_SenseData.AddSenseLen              := 0x0a;        // n-7 (n=17 (0..17))
	MOVLW       10
	MOVWF       USB_MSD_Library_Msd_SenseData+7 
;USB_MSD_Library.mpas,906 :: 		Msd_SenseData.CmdSpecificInfo          := 0x0;
	CLRF        USB_MSD_Library_Msd_SenseData+8 
	CLRF        USB_MSD_Library_Msd_SenseData+9 
	CLRF        USB_MSD_Library_Msd_SenseData+10 
	CLRF        USB_MSD_Library_Msd_SenseData+11 
;USB_MSD_Library.mpas,907 :: 		Msd_SenseData.ASC                      := 0x0;
	CLRF        USB_MSD_Library_Msd_SenseData+12 
;USB_MSD_Library.mpas,908 :: 		Msd_SenseData.ASCQ                     := 0x0;
	CLRF        USB_MSD_Library_Msd_SenseData+13 
;USB_MSD_Library.mpas,909 :: 		Msd_SenseData.FRUC                     := 0x0;
	CLRF        USB_MSD_Library_Msd_SenseData+14 
;USB_MSD_Library.mpas,910 :: 		Msd_SenseData.SenseKeySpecific[0]      := 0x0;
	CLRF        USB_MSD_Library_Msd_SenseData+15 
;USB_MSD_Library.mpas,911 :: 		Msd_SenseData.SenseKeySpecific[1]      := 0x0;
	CLRF        USB_MSD_Library_Msd_SenseData+16 
;USB_MSD_Library.mpas,912 :: 		Msd_SenseData.SenseKeySpecific[2]      := 0x0;
	CLRF        USB_MSD_Library_Msd_SenseData+17 
;USB_MSD_Library.mpas,913 :: 		end;
L_end_Msd_ResetSenseData:
	RETURN      0
; end of USB_MSD_Library_Msd_ResetSenseData

USB_MSD_Library_MemCpy__:

;USB_MSD_Library.mpas,916 :: 		begin
;USB_MSD_Library.mpas,917 :: 		while N > 0 do
L_USB_MSD_Library_MemCpy__36:
	MOVLW       0
	MOVWF       R0 
	MOVF        FARG_MemCpy___n+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MemCpy__519
	MOVF        FARG_MemCpy___n+0, 0 
	SUBLW       0
L_USB_MSD_Library_MemCpy__519:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_MemCpy__37
;USB_MSD_Library.mpas,919 :: 		Towards^ := From^;
	MOVFF       FARG_MemCpy___From+0, FSR0L
	MOVFF       FARG_MemCpy___From+1, FSR0H
	MOVFF       FARG_MemCpy___Towards+0, FSR1L
	MOVFF       FARG_MemCpy___Towards+1, FSR1H
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;USB_MSD_Library.mpas,920 :: 		inc(Towards);
	INFSNZ      FARG_MemCpy___Towards+0, 1 
	INCF        FARG_MemCpy___Towards+1, 1 
;USB_MSD_Library.mpas,921 :: 		inc(From);
	INFSNZ      FARG_MemCpy___From+0, 1 
	INCF        FARG_MemCpy___From+1, 1 
;USB_MSD_Library.mpas,922 :: 		dec(N);
	MOVLW       1
	SUBWF       FARG_MemCpy___n+0, 1 
	MOVLW       0
	SUBWFB      FARG_MemCpy___n+1, 1 
;USB_MSD_Library.mpas,923 :: 		end;
	GOTO        L_USB_MSD_Library_MemCpy__36
L_USB_MSD_Library_MemCpy__37:
;USB_MSD_Library.mpas,924 :: 		end;
L_end_MemCpy__:
	RETURN      0
; end of USB_MSD_Library_MemCpy__

USB_MSD_Library_memCpyC__:

;USB_MSD_Library.mpas,928 :: 		begin
;USB_MSD_Library.mpas,929 :: 		while N > 0 do
L_USB_MSD_Library_memCpyC__42:
	MOVLW       0
	MOVWF       R0 
	MOVF        FARG_memCpyC___N+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_memCpyC__521
	MOVF        FARG_memCpyC___N+0, 0 
	SUBLW       0
L_USB_MSD_Library_memCpyC__521:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_memCpyC__43
;USB_MSD_Library.mpas,931 :: 		P1^ := P2^;
	MOVF        FARG_memCpyC___p2+0, 0 
	MOVWF       TBLPTRL 
	MOVF        FARG_memCpyC___p2+1, 0 
	MOVWF       TBLPTRH 
	MOVF        FARG_memCpyC___p2+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       FARG_memCpyC___p1+0, FSR1L
	MOVFF       FARG_memCpyC___p1+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_MSD_Library.mpas,932 :: 		inc(P1);
	INFSNZ      FARG_memCpyC___p1+0, 1 
	INCF        FARG_memCpyC___p1+1, 1 
;USB_MSD_Library.mpas,933 :: 		inc(P2);
	MOVLW       1
	ADDWF       FARG_memCpyC___p2+0, 1 
	MOVLW       0
	ADDWFC      FARG_memCpyC___p2+1, 1 
	ADDWFC      FARG_memCpyC___p2+2, 1 
;USB_MSD_Library.mpas,934 :: 		dec(N);
	MOVLW       1
	SUBWF       FARG_memCpyC___N+0, 1 
	MOVLW       0
	SUBWFB      FARG_memCpyC___N+1, 1 
;USB_MSD_Library.mpas,935 :: 		end;
	GOTO        L_USB_MSD_Library_memCpyC__42
L_USB_MSD_Library_memCpyC__43:
;USB_MSD_Library.mpas,936 :: 		end;
L_end_memCpyC__:
	RETURN      0
; end of USB_MSD_Library_memCpyC__

USB_MSD_Library_UsbMsdSendCsw:

;USB_MSD_Library.mpas,943 :: 		begin
;USB_MSD_Library.mpas,944 :: 		repeat
L_USB_MSD_Library_UsbMsdSendCsw47:
;USB_MSD_Library.mpas,945 :: 		until (BDEP4INStat.UOWN = 0);
	BTFSC       1060, 7 
	GOTO        L_USB_MSD_Library_UsbMsdSendCsw47
;USB_MSD_Library.mpas,957 :: 		MemCpy__(^byte(@BuffEP4IN), ^byte(@Msd_Csw), USB_Msd_Csw_SIZE);
	MOVLW       _BuffEP4IN+0
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       USB_MSD_Library_Msd_Csw+0
	MOVWF       FARG_MemCpy___From+0 
	MOVLW       hi_addr(USB_MSD_Library_Msd_Csw+0)
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       13
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        USB_MSD_Library_MemCpy__+0, 0
;USB_MSD_Library.mpas,958 :: 		Msd_SendPacket(USB_Msd_Csw_SIZE);
	MOVLW       13
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_Msd_SendPacket+0, 0
;USB_MSD_Library.mpas,959 :: 		MSD_State  := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,960 :: 		Msd_Command:= USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,962 :: 		Msd_ReceivePacket;                           // prepare for next packetreception
	CALL        USB_MSD_Library_Msd_ReceivePacket+0, 0
;USB_MSD_Library.mpas,963 :: 		end;
L_end_UsbMsdSendCsw:
	RETURN      0
; end of USB_MSD_Library_UsbMsdSendCsw

USB_MSD_Library_Msd_WriteHandler:

;USB_MSD_Library.mpas,967 :: 		begin
;USB_MSD_Library.mpas,980 :: 		if Msd_NrSectors > 0 then
	MOVLW       0
	MOVWF       R0 
	MOVF        USB_MSD_Library_Msd_NrSectors+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler524
	MOVF        USB_MSD_Library_Msd_NrSectors+0, 0 
	SUBLW       0
L_USB_MSD_Library_Msd_WriteHandler524:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler54
;USB_MSD_Library.mpas,982 :: 		MemCpy__(@MSD_Buffer[Msd_SectorChunk * 64], @BuffEP4OUT,  64); // copy the received packet to the 512 bytes (USB_MSD_BLOCKLEN) sectorbuffer
	MOVLW       6
	MOVWF       R2 
	MOVF        USB_MSD_Library_Msd_SectorChunk+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L_USB_MSD_Library_Msd_WriteHandler525:
	BZ          L_USB_MSD_Library_Msd_WriteHandler526
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L_USB_MSD_Library_Msd_WriteHandler525
L_USB_MSD_Library_Msd_WriteHandler526:
	MOVLW       USB_MSD_Library_MSD_buffer+0
	ADDWF       R0, 0 
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(USB_MSD_Library_MSD_buffer+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       _BuffEP4OUT+0
	MOVWF       FARG_MemCpy___From+0 
	MOVLW       hi_addr(_BuffEP4OUT+0)
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       64
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        USB_MSD_Library_MemCpy__+0, 0
;USB_MSD_Library.mpas,984 :: 		inc(Msd_SectorChunk);                                        // next chunk of 64 bytes
	INCF        USB_MSD_Library_Msd_SectorChunk+0, 1 
;USB_MSD_Library.mpas,986 :: 		if Msd_SectorChunk = 8 then                                  // last Chunk of a sector has been received
	MOVF        USB_MSD_Library_Msd_SectorChunk+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler57
;USB_MSD_Library.mpas,990 :: 		if MSD_SDMMC_RetryAttempt = 0 then                           // no persistent error condition yet
	MOVF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler60
;USB_MSD_Library.mpas,992 :: 		repeat
L_USB_MSD_Library_Msd_WriteHandler62:
;USB_MSD_Library.mpas,993 :: 		mmc_Result := Mmc_Write_Sector(Msd_Sector, MSD_buffer);  // write to card
	MOVF        USB_MSD_Library_Msd_Sector+0, 0 
	MOVWF       FARG_Mmc_Write_Sector_sector+0 
	MOVF        USB_MSD_Library_Msd_Sector+1, 0 
	MOVWF       FARG_Mmc_Write_Sector_sector+1 
	MOVF        USB_MSD_Library_Msd_Sector+2, 0 
	MOVWF       FARG_Mmc_Write_Sector_sector+2 
	MOVF        USB_MSD_Library_Msd_Sector+3, 0 
	MOVWF       FARG_Mmc_Write_Sector_sector+3 
	MOVLW       USB_MSD_Library_MSD_buffer+0
	MOVWF       FARG_Mmc_Write_Sector_dbuff+0 
	MOVLW       hi_addr(USB_MSD_Library_MSD_buffer+0)
	MOVWF       FARG_Mmc_Write_Sector_dbuff+1 
	CALL        _Mmc_Write_Sector+0, 0
	MOVF        R0, 0 
	MOVWF       Msd_WriteHandler_mmc_Result+0 
;USB_MSD_Library.mpas,994 :: 		if mmc_Result > 0 then                                     // write error
	MOVF        R0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler68
;USB_MSD_Library.mpas,996 :: 		inc(MSD_SDMMC_RetryAttempt);
	INCF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0, 1 
;USB_MSD_Library.mpas,997 :: 		if MSD_SDMMC_RetryAttempt = MSD_MAX_RETRIES then
	MOVF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       100
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler71
;USB_MSD_Library.mpas,999 :: 		Msd_Csw.Status             := USB_MSD_STATUS_FAILED;
	MOVLW       1
	MOVWF       USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1000 :: 		Msd_SenseData.Sensekey_etc := USB_MSD_S_MEDIUM_ERROR;
	MOVLW       3
	MOVWF       USB_MSD_Library_Msd_SenseData+2 
;USB_MSD_Library.mpas,1001 :: 		Msd_SenseData.ASC          := USB_MSD_ASC_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_Msd_SenseData+12 
;USB_MSD_Library.mpas,1002 :: 		Msd_SenseData.ASCQ         := USB_MSD_ASCQ_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_Msd_SenseData+13 
;USB_MSD_Library.mpas,1003 :: 		end;
L_USB_MSD_Library_Msd_WriteHandler71:
;USB_MSD_Library.mpas,1004 :: 		end;
L_USB_MSD_Library_Msd_WriteHandler68:
;USB_MSD_Library.mpas,1005 :: 		until (mmc_Result = 0) or (MSD_SDMMC_RetryAttempt = MSD_MAX_RETRIES);
	MOVF        Msd_WriteHandler_mmc_Result+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       100
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	IORWF       R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler65
	GOTO        L_USB_MSD_Library_Msd_WriteHandler62
L_USB_MSD_Library_Msd_WriteHandler65:
;USB_MSD_Library.mpas,1006 :: 		if mmc_Result = 0 then MSD_SDMMC_RetryAttempt := 0;
	MOVF        Msd_WriteHandler_mmc_Result+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler74
	CLRF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0 
L_USB_MSD_Library_Msd_WriteHandler74:
;USB_MSD_Library.mpas,1007 :: 		end;
L_USB_MSD_Library_Msd_WriteHandler60:
;USB_MSD_Library.mpas,1009 :: 		Msd_SectorChunk := 0;                                      // next Chunk is zero
	CLRF        USB_MSD_Library_Msd_SectorChunk+0 
;USB_MSD_Library.mpas,1010 :: 		dec(Msd_NrSectors);                                        // one sector less to write
	MOVLW       1
	SUBWF       USB_MSD_Library_Msd_NrSectors+0, 1 
	MOVLW       0
	SUBWFB      USB_MSD_Library_Msd_NrSectors+1, 1 
;USB_MSD_Library.mpas,1011 :: 		inc(Msd_Sector);                                           // get next sector to write
	MOVLW       1
	ADDWF       USB_MSD_Library_Msd_Sector+0, 1 
	MOVLW       0
	ADDWFC      USB_MSD_Library_Msd_Sector+1, 1 
	ADDWFC      USB_MSD_Library_Msd_Sector+2, 1 
	ADDWFC      USB_MSD_Library_Msd_Sector+3, 1 
;USB_MSD_Library.mpas,1012 :: 		end;
L_USB_MSD_Library_Msd_WriteHandler57:
;USB_MSD_Library.mpas,1015 :: 		if Msd_NrSectors = 0
	MOVLW       0
	XORWF       USB_MSD_Library_Msd_NrSectors+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler527
	MOVLW       0
	XORWF       USB_MSD_Library_Msd_NrSectors+0, 0 
L_USB_MSD_Library_Msd_WriteHandler527:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_WriteHandler77
;USB_MSD_Library.mpas,1016 :: 		then UsbMsdSendCsw                                             // done, send CSW right away
	CALL        USB_MSD_Library_UsbMsdSendCsw+0, 0
	GOTO        L_USB_MSD_Library_Msd_WriteHandler78
;USB_MSD_Library.mpas,1017 :: 		else Msd_ReceivePacket;                            // arm EP4 out for reception
L_USB_MSD_Library_Msd_WriteHandler77:
	CALL        USB_MSD_Library_Msd_ReceivePacket+0, 0
L_USB_MSD_Library_Msd_WriteHandler78:
;USB_MSD_Library.mpas,1018 :: 		end;
L_USB_MSD_Library_Msd_WriteHandler54:
;USB_MSD_Library.mpas,1019 :: 		end;
L_end_Msd_WriteHandler:
	RETURN      0
; end of USB_MSD_Library_Msd_WriteHandler

USB_MSD_Library_Msd_ReadHandler:

;USB_MSD_Library.mpas,1027 :: 		begin
;USB_MSD_Library.mpas,1029 :: 		if Msd_NrSectors > 0 then
	MOVLW       0
	MOVWF       R0 
	MOVF        USB_MSD_Library_Msd_NrSectors+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler529
	MOVF        USB_MSD_Library_Msd_NrSectors+0, 0 
	SUBLW       0
L_USB_MSD_Library_Msd_ReadHandler529:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler81
;USB_MSD_Library.mpas,1033 :: 		if Msd_SectorChunk = 0 then
	MOVF        USB_MSD_Library_Msd_SectorChunk+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler84
;USB_MSD_Library.mpas,1035 :: 		if MSD_SDMMC_RetryAttempt = 0 then                           // no persistent error condition yet
	MOVF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler87
;USB_MSD_Library.mpas,1037 :: 		repeat
L_USB_MSD_Library_Msd_ReadHandler89:
;USB_MSD_Library.mpas,1038 :: 		mmc_Result := Mmc_Read_Sector(Msd_Sector, MSD_buffer);  // read from card
	MOVF        USB_MSD_Library_Msd_Sector+0, 0 
	MOVWF       FARG_Mmc_Read_Sector_sector+0 
	MOVF        USB_MSD_Library_Msd_Sector+1, 0 
	MOVWF       FARG_Mmc_Read_Sector_sector+1 
	MOVF        USB_MSD_Library_Msd_Sector+2, 0 
	MOVWF       FARG_Mmc_Read_Sector_sector+2 
	MOVF        USB_MSD_Library_Msd_Sector+3, 0 
	MOVWF       FARG_Mmc_Read_Sector_sector+3 
	MOVLW       USB_MSD_Library_MSD_buffer+0
	MOVWF       FARG_Mmc_Read_Sector_dbuff+0 
	MOVLW       hi_addr(USB_MSD_Library_MSD_buffer+0)
	MOVWF       FARG_Mmc_Read_Sector_dbuff+1 
	CALL        _Mmc_Read_Sector+0, 0
	MOVF        R0, 0 
	MOVWF       Msd_ReadHandler_Mmc_Result+0 
;USB_MSD_Library.mpas,1039 :: 		if mmc_Result > 0 then                                  // read error
	MOVF        R0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler95
;USB_MSD_Library.mpas,1041 :: 		inc(MSD_SDMMC_RetryAttempt);
	INCF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0, 1 
;USB_MSD_Library.mpas,1042 :: 		if MSD_SDMMC_RetryAttempt = MSD_MAX_RETRIES then
	MOVF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       100
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler98
;USB_MSD_Library.mpas,1044 :: 		Msd_Csw.Status             := USB_MSD_STATUS_FAILED;
	MOVLW       1
	MOVWF       USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1045 :: 		Msd_SenseData.Sensekey_etc := USB_MSD_S_MEDIUM_ERROR;
	MOVLW       3
	MOVWF       USB_MSD_Library_Msd_SenseData+2 
;USB_MSD_Library.mpas,1046 :: 		Msd_SenseData.ASC          := USB_MSD_ASC_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_Msd_SenseData+12 
;USB_MSD_Library.mpas,1047 :: 		Msd_SenseData.ASCQ         := USB_MSD_ASCQ_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_Msd_SenseData+13 
;USB_MSD_Library.mpas,1048 :: 		end;
L_USB_MSD_Library_Msd_ReadHandler98:
;USB_MSD_Library.mpas,1049 :: 		end;
L_USB_MSD_Library_Msd_ReadHandler95:
;USB_MSD_Library.mpas,1050 :: 		until (mmc_Result = 0) or (MSD_SDMMC_RetryAttempt = MSD_MAX_RETRIES);
	MOVF        Msd_ReadHandler_Mmc_Result+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       100
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	IORWF       R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler92
	GOTO        L_USB_MSD_Library_Msd_ReadHandler89
L_USB_MSD_Library_Msd_ReadHandler92:
;USB_MSD_Library.mpas,1051 :: 		if mmc_Result = 0 then MSD_SDMMC_RetryAttempt := 0;
	MOVF        Msd_ReadHandler_Mmc_Result+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler101
	CLRF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0 
L_USB_MSD_Library_Msd_ReadHandler101:
;USB_MSD_Library.mpas,1052 :: 		end;
L_USB_MSD_Library_Msd_ReadHandler87:
;USB_MSD_Library.mpas,1053 :: 		end;
L_USB_MSD_Library_Msd_ReadHandler84:
;USB_MSD_Library.mpas,1055 :: 		MemCpy__(@BuffEP4IN, @MSD_Buffer[Msd_SectorChunk * 64], 64);              // send a chunk of 64 bytes to the host
	MOVLW       _BuffEP4IN+0
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       6
	MOVWF       R2 
	MOVF        USB_MSD_Library_Msd_SectorChunk+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L_USB_MSD_Library_Msd_ReadHandler530:
	BZ          L_USB_MSD_Library_Msd_ReadHandler531
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L_USB_MSD_Library_Msd_ReadHandler530
L_USB_MSD_Library_Msd_ReadHandler531:
	MOVLW       USB_MSD_Library_MSD_buffer+0
	ADDWF       R0, 0 
	MOVWF       FARG_MemCpy___From+0 
	MOVLW       hi_addr(USB_MSD_Library_MSD_buffer+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       64
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        USB_MSD_Library_MemCpy__+0, 0
;USB_MSD_Library.mpas,1063 :: 		Msd_SendPacket(64);
	MOVLW       64
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_Msd_SendPacket+0, 0
;USB_MSD_Library.mpas,1070 :: 		inc(Msd_SectorChunk);                                                   // next chunk of 64 bytes
	INCF        USB_MSD_Library_Msd_SectorChunk+0, 1 
;USB_MSD_Library.mpas,1071 :: 		if Msd_SectorChunk = 8 then                                             // last Chunk of a sector sent to the host
	MOVF        USB_MSD_Library_Msd_SectorChunk+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler104
;USB_MSD_Library.mpas,1073 :: 		Msd_SectorChunk := 0;                                                 // next Chunk is zero
	CLRF        USB_MSD_Library_Msd_SectorChunk+0 
;USB_MSD_Library.mpas,1074 :: 		dec(Msd_NrSectors);                                                   // one sector less to read
	MOVLW       1
	SUBWF       USB_MSD_Library_Msd_NrSectors+0, 1 
	MOVLW       0
	SUBWFB      USB_MSD_Library_Msd_NrSectors+1, 1 
;USB_MSD_Library.mpas,1075 :: 		inc(Msd_Sector);                                                      // next sector to read
	MOVLW       1
	ADDWF       USB_MSD_Library_Msd_Sector+0, 1 
	MOVLW       0
	ADDWFC      USB_MSD_Library_Msd_Sector+1, 1 
	ADDWFC      USB_MSD_Library_Msd_Sector+2, 1 
	ADDWFC      USB_MSD_Library_Msd_Sector+3, 1 
;USB_MSD_Library.mpas,1076 :: 		end;
L_USB_MSD_Library_Msd_ReadHandler104:
;USB_MSD_Library.mpas,1078 :: 		if Msd_NrSectors = 0 then Msd_State := USB_MSD_SEND_CSW;                // done, wait for the next "TokenIn" to send the CSW
	MOVLW       0
	XORWF       USB_MSD_Library_Msd_NrSectors+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler532
	MOVLW       0
	XORWF       USB_MSD_Library_Msd_NrSectors+0, 0 
L_USB_MSD_Library_Msd_ReadHandler532:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_Msd_ReadHandler107
	MOVLW       3
	MOVWF       USB_MSD_Library_MSD_State+0 
L_USB_MSD_Library_Msd_ReadHandler107:
;USB_MSD_Library.mpas,1079 :: 		end;
L_USB_MSD_Library_Msd_ReadHandler81:
;USB_MSD_Library.mpas,1080 :: 		end;
L_end_Msd_ReadHandler:
	RETURN      0
; end of USB_MSD_Library_Msd_ReadHandler

USB_MSD_Library_MsdProcessCommand:

;USB_MSD_Library.mpas,1087 :: 		begin
;USB_MSD_Library.mpas,1088 :: 		if Msd_Command = USB_MSD_COMMAND_IDLE
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand111
;USB_MSD_Library.mpas,1089 :: 		then Msd_Command := Command; // get new command
	MOVF        FARG_MsdProcessCommand_Command+0, 0 
	MOVWF       USB_MSD_Library_Msd_Command+0 
L_USB_MSD_Library_MsdProcessCommand111:
;USB_MSD_Library.mpas,1097 :: 		USB_MSD_COMMAND_IDLE: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand116
;USB_MSD_Library.mpas,1102 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand116:
;USB_MSD_Library.mpas,1104 :: 		USB_MSD_INQUIRY: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       18
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand119
;USB_MSD_Library.mpas,1111 :: 		memCpyC__(^byte(@BuffEP4IN), Dword(@inq_resp), sizeOf(T_Usb_Msd_Inquiry_Response));
	MOVLW       _BuffEP4IN+0
	MOVWF       FARG_memCpyC___p1+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       FARG_memCpyC___p1+1 
	MOVLW       USB_MSD_Library_inq_resp+0
	MOVWF       R0 
	MOVLW       hi_addr(USB_MSD_Library_inq_resp+0)
	MOVWF       R1 
	MOVLW       higher_addr(USB_MSD_Library_inq_resp+0)
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	MOVF        R0, 0 
	MOVWF       FARG_memCpyC___p2+0 
	MOVF        R1, 0 
	MOVWF       FARG_memCpyC___p2+1 
	MOVF        R2, 0 
	MOVWF       FARG_memCpyC___p2+2 
	MOVLW       36
	MOVWF       FARG_memCpyC___N+0 
	MOVLW       0
	MOVWF       FARG_memCpyC___N+1 
	CALL        USB_MSD_Library_memCpyC__+0, 0
;USB_MSD_Library.mpas,1113 :: 		Msd_Csw.Status := USB_MSD_STATUS_OK;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1114 :: 		Msd_SendPacket(sizeOf(T_Usb_Msd_Inquiry_Response));
	MOVLW       36
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_Msd_SendPacket+0, 0
;USB_MSD_Library.mpas,1115 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1116 :: 		Msd_State   := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1117 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand119:
;USB_MSD_Library.mpas,1119 :: 		USB_MSD_READ_CAPACITY: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       37
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand122
;USB_MSD_Library.mpas,1121 :: 		SectorSize := USB_MSD_BLOCKLEN;  // 512 bytes per sector
	MOVLW       0
	MOVWF       MsdProcessCommand_SectorSize+0 
	MOVLW       2
	MOVWF       MsdProcessCommand_SectorSize+1 
	MOVLW       0
	MOVWF       MsdProcessCommand_SectorSize+2 
	MOVWF       MsdProcessCommand_SectorSize+3 
;USB_MSD_Library.mpas,1123 :: 		Capacity   := (SDMMC_CardSize shl 9); // # of sectors
	CALL        _SDMMC_CardSize+0, 0
	MOVLW       9
	MOVWF       R4 
	MOVF        R0, 0 
	MOVWF       MsdProcessCommand_Capacity+0 
	MOVF        R1, 0 
	MOVWF       MsdProcessCommand_Capacity+1 
	MOVF        R2, 0 
	MOVWF       MsdProcessCommand_Capacity+2 
	MOVF        R3, 0 
	MOVWF       MsdProcessCommand_Capacity+3 
	MOVF        R4, 0 
L_USB_MSD_Library_MsdProcessCommand534:
	BZ          L_USB_MSD_Library_MsdProcessCommand535
	RLCF        MsdProcessCommand_Capacity+0, 1 
	BCF         MsdProcessCommand_Capacity+0, 0 
	RLCF        MsdProcessCommand_Capacity+1, 1 
	RLCF        MsdProcessCommand_Capacity+2, 1 
	RLCF        MsdProcessCommand_Capacity+3, 1 
	ADDLW       255
	GOTO        L_USB_MSD_Library_MsdProcessCommand534
L_USB_MSD_Library_MsdProcessCommand535:
;USB_MSD_Library.mpas,1124 :: 		Capacity   := dec(Capacity);            // max sectornumber
	MOVLW       1
	SUBWF       MsdProcessCommand_Capacity+0, 1 
	MOVLW       0
	SUBWFB      MsdProcessCommand_Capacity+1, 1 
	SUBWFB      MsdProcessCommand_Capacity+2, 1 
	SUBWFB      MsdProcessCommand_Capacity+3, 1 
;USB_MSD_Library.mpas,1127 :: 		BuffEP4IN[0] := Highest(Capacity);
	MOVF        MsdProcessCommand_Capacity+3, 0 
	MOVWF       1856 
;USB_MSD_Library.mpas,1128 :: 		BuffEP4IN[1] := Higher(Capacity);
	MOVF        MsdProcessCommand_Capacity+2, 0 
	MOVWF       1857 
;USB_MSD_Library.mpas,1129 :: 		BuffEP4IN[2] := Hi(Capacity);
	MOVF        MsdProcessCommand_Capacity+1, 0 
	MOVWF       1858 
;USB_MSD_Library.mpas,1130 :: 		BuffEP4IN[3] := Lo(Capacity);
	MOVF        MsdProcessCommand_Capacity+0, 0 
	MOVWF       1859 
;USB_MSD_Library.mpas,1132 :: 		BuffEP4IN[4] := Highest(SectorSize);
	MOVF        MsdProcessCommand_SectorSize+3, 0 
	MOVWF       1860 
;USB_MSD_Library.mpas,1133 :: 		BuffEP4IN[5] := Higher(SectorSize);
	MOVF        MsdProcessCommand_SectorSize+2, 0 
	MOVWF       1861 
;USB_MSD_Library.mpas,1134 :: 		BuffEP4IN[6] := Hi(SectorSize);
	MOVF        MsdProcessCommand_SectorSize+1, 0 
	MOVWF       1862 
;USB_MSD_Library.mpas,1135 :: 		BuffEP4IN[7] := Lo(SectorSize);
	MOVF        MsdProcessCommand_SectorSize+0, 0 
	MOVWF       1863 
;USB_MSD_Library.mpas,1142 :: 		Msd_Csw.Status := USB_MSD_STATUS_OK;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1143 :: 		Msd_Sendpacket(8);
	MOVLW       8
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_Msd_SendPacket+0, 0
;USB_MSD_Library.mpas,1144 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1145 :: 		Msd_State   := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1146 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand122:
;USB_MSD_Library.mpas,1148 :: 		USB_MSD_READ_10: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       40
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand125
;USB_MSD_Library.mpas,1153 :: 		Highest(Msd_Sector) := Msd_Cbw.CommandBlock[2];
	MOVF        USB_MSD_Library_Msd_Cbw+17, 0 
	MOVWF       USB_MSD_Library_Msd_Sector+3 
;USB_MSD_Library.mpas,1154 :: 		Higher(Msd_Sector)  := Msd_Cbw.CommandBlock[3];
	MOVF        USB_MSD_Library_Msd_Cbw+18, 0 
	MOVWF       USB_MSD_Library_Msd_Sector+2 
;USB_MSD_Library.mpas,1155 :: 		Hi(Msd_Sector)      := Msd_Cbw.CommandBlock[4];
	MOVF        USB_MSD_Library_Msd_Cbw+19, 0 
	MOVWF       USB_MSD_Library_Msd_Sector+1 
;USB_MSD_Library.mpas,1156 :: 		Lo(Msd_Sector)      := Msd_Cbw.CommandBlock[5];
	MOVF        USB_MSD_Library_Msd_Cbw+20, 0 
	MOVWF       USB_MSD_Library_Msd_Sector+0 
;USB_MSD_Library.mpas,1158 :: 		Hi(Msd_NrSectors)   := Msd_Cbw.CommandBlock[7];
	MOVF        USB_MSD_Library_Msd_Cbw+22, 0 
	MOVWF       USB_MSD_Library_Msd_NrSectors+1 
;USB_MSD_Library.mpas,1159 :: 		Lo(Msd_NrSectors)   := Msd_Cbw.CommandBlock[8];
	MOVF        USB_MSD_Library_Msd_Cbw+23, 0 
	MOVWF       USB_MSD_Library_Msd_NrSectors+0 
;USB_MSD_Library.mpas,1171 :: 		Msd_SectorChunk := 0;
	CLRF        USB_MSD_Library_Msd_SectorChunk+0 
;USB_MSD_Library.mpas,1174 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1175 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1177 :: 		MSD_SDMMC_RetryAttempt := 0;
	CLRF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0 
;USB_MSD_Library.mpas,1178 :: 		MSD_State := USB_MSD_DATA_IN;
	MOVLW       1
	MOVWF       USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1179 :: 		Msd_ReadHandler;              // read first chunk of data
	CALL        USB_MSD_Library_Msd_ReadHandler+0, 0
;USB_MSD_Library.mpas,1181 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand125:
;USB_MSD_Library.mpas,1183 :: 		USB_MSD_WRITE_10: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       42
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand128
;USB_MSD_Library.mpas,1188 :: 		Highest(Msd_Sector) := Msd_Cbw.CommandBlock[2];
	MOVF        USB_MSD_Library_Msd_Cbw+17, 0 
	MOVWF       USB_MSD_Library_Msd_Sector+3 
;USB_MSD_Library.mpas,1189 :: 		Higher(Msd_Sector)  := Msd_Cbw.CommandBlock[3];
	MOVF        USB_MSD_Library_Msd_Cbw+18, 0 
	MOVWF       USB_MSD_Library_Msd_Sector+2 
;USB_MSD_Library.mpas,1190 :: 		Hi(Msd_Sector)      := Msd_Cbw.CommandBlock[4];
	MOVF        USB_MSD_Library_Msd_Cbw+19, 0 
	MOVWF       USB_MSD_Library_Msd_Sector+1 
;USB_MSD_Library.mpas,1191 :: 		Lo(Msd_Sector)      := Msd_Cbw.CommandBlock[5];
	MOVF        USB_MSD_Library_Msd_Cbw+20, 0 
	MOVWF       USB_MSD_Library_Msd_Sector+0 
;USB_MSD_Library.mpas,1193 :: 		Hi(Msd_NrSectors)   := Msd_Cbw.CommandBlock[7];
	MOVF        USB_MSD_Library_Msd_Cbw+22, 0 
	MOVWF       USB_MSD_Library_Msd_NrSectors+1 
;USB_MSD_Library.mpas,1194 :: 		Lo(Msd_NrSectors)   := Msd_Cbw.CommandBlock[8];
	MOVF        USB_MSD_Library_Msd_Cbw+23, 0 
	MOVWF       USB_MSD_Library_Msd_NrSectors+0 
;USB_MSD_Library.mpas,1196 :: 		Msd_SectorChunk     := 0;
	CLRF        USB_MSD_Library_Msd_SectorChunk+0 
;USB_MSD_Library.mpas,1210 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1211 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1213 :: 		MSD_SDMMC_RetryAttempt := 0;
	CLRF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0 
;USB_MSD_Library.mpas,1214 :: 		MSD_State              := USB_MSD_DATA_OUT;
	MOVLW       2
	MOVWF       USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1216 :: 		Msd_ReceivePacket; // arm EP4 out for packet reception
	CALL        USB_MSD_Library_Msd_ReceivePacket+0, 0
;USB_MSD_Library.mpas,1219 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand128:
;USB_MSD_Library.mpas,1221 :: 		USB_MSD_REQUEST_SENSE: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand131
;USB_MSD_Library.mpas,1226 :: 		MemCpy__(^byte(@BuffEP4IN), ^byte(@Msd_SenseData), SizeOf(Msd_SenseData));
	MOVLW       _BuffEP4IN+0
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       USB_MSD_Library_Msd_SenseData+0
	MOVWF       FARG_MemCpy___From+0 
	MOVLW       hi_addr(USB_MSD_Library_Msd_SenseData+0)
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       18
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        USB_MSD_Library_MemCpy__+0, 0
;USB_MSD_Library.mpas,1227 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1228 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1230 :: 		Msd_Sendpacket(SizeOf(Msd_SenseData));
	MOVLW       18
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_Msd_SendPacket+0, 0
;USB_MSD_Library.mpas,1231 :: 		Msd_Command    := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1232 :: 		Msd_State      := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1233 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand131:
;USB_MSD_Library.mpas,1235 :: 		USB_MSD_MODE_SENSE: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       26
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand134
;USB_MSD_Library.mpas,1240 :: 		BuffEP4IN[0] := 2;
	MOVLW       2
	MOVWF       1856 
;USB_MSD_Library.mpas,1241 :: 		BuffEP4IN[1] := 0;
	CLRF        1857 
;USB_MSD_Library.mpas,1242 :: 		BuffEP4IN[2] := 0;
	CLRF        1858 
;USB_MSD_Library.mpas,1243 :: 		BuffEP4IN[3] := 0;
	CLRF        1859 
;USB_MSD_Library.mpas,1245 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1246 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1248 :: 		Msd_Sendpacket(4);
	MOVLW       4
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_Msd_SendPacket+0, 0
;USB_MSD_Library.mpas,1249 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1250 :: 		Msd_State   := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1251 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand134:
;USB_MSD_Library.mpas,1253 :: 		USB_MSD_PREVENT_ALLOW_MEDIUM_REMOVAL: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       30
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand137
;USB_MSD_Library.mpas,1259 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1260 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1261 :: 		Msd_Command         := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1262 :: 		Msd_State           := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1263 :: 		UsbMsdSendCsw;
	CALL        USB_MSD_Library_UsbMsdSendCsw+0, 0
;USB_MSD_Library.mpas,1264 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand137:
;USB_MSD_Library.mpas,1266 :: 		USB_MSD_TEST_UNIT_READY: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand140
;USB_MSD_Library.mpas,1271 :: 		Msd_ResetSenseData;
	CALL        USB_MSD_Library_Msd_ResetSenseData+0, 0
;USB_MSD_Library.mpas,1272 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1273 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1274 :: 		Msd_Command         := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1275 :: 		Msd_State           := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1276 :: 		UsbMsdSendCsw;
	CALL        USB_MSD_Library_UsbMsdSendCsw+0, 0
;USB_MSD_Library.mpas,1277 :: 		end;
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand140:
;USB_MSD_Library.mpas,1280 :: 		USB_MSD_STOP_START: //
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       47
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand143
	GOTO        L_USB_MSD_Library_MsdProcessCommand141
L_USB_MSD_Library_MsdProcessCommand143:
	MOVF        USB_MSD_Library_Msd_Command+0, 0 
	XORLW       27
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_MsdProcessCommand144
L_USB_MSD_Library_MsdProcessCommand141:
;USB_MSD_Library.mpas,1285 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1286 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1287 :: 		Msd_Command         := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1288 :: 		Msd_State           := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1289 :: 		UsbMsdSendCsw;
	CALL        USB_MSD_Library_UsbMsdSendCsw+0, 0
;USB_MSD_Library.mpas,1292 :: 		else // Other and USB_MSD_COMMAND_ERROR: //
	GOTO        L_USB_MSD_Library_MsdProcessCommand113
L_USB_MSD_Library_MsdProcessCommand144:
;USB_MSD_Library.mpas,1298 :: 		Msd_ResetSenseData;
	CALL        USB_MSD_Library_Msd_ResetSenseData+0, 0
;USB_MSD_Library.mpas,1299 :: 		Msd_SenseData.SenseKey_etc := USB_MSD_S_ILLEGAL_REQUEST;
	MOVLW       5
	MOVWF       USB_MSD_Library_Msd_SenseData+2 
;USB_MSD_Library.mpas,1300 :: 		Msd_SenseData.asc          := USB_MSD_ASC_INVALID_COMMAND_OPCODE;
	MOVLW       32
	MOVWF       USB_MSD_Library_Msd_SenseData+12 
;USB_MSD_Library.mpas,1301 :: 		Msd_SenseData.ascq         := USB_MSD_ASCQ_INVALID_COMMAND_OPCODE;
	CLRF        USB_MSD_Library_Msd_SenseData+13 
;USB_MSD_Library.mpas,1302 :: 		Msd_Csw.status             := USB_MSD_STATUS_FAILED;
	MOVLW       1
	MOVWF       USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1303 :: 		Msd_Csw.DataResidue        := 0;
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1305 :: 		Msd_SendBulkZeroLenPacket;
	CALL        USB_MSD_Library_Msd_SendBulkZeroLenPacket+0, 0
;USB_MSD_Library.mpas,1306 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1307 :: 		Msd_State   := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1308 :: 		end;
L_USB_MSD_Library_MsdProcessCommand113:
;USB_MSD_Library.mpas,1311 :: 		end;
L_end_MsdProcessCommand:
	RETURN      0
; end of USB_MSD_Library_MsdProcessCommand

USB_MSD_Library_ClassTokenOutMSD:

;USB_MSD_Library.mpas,1314 :: 		begin
;USB_MSD_Library.mpas,1315 :: 		Result := false;
	CLRF        ClassTokenOutMSD_local_result+0 
;USB_MSD_Library.mpas,1324 :: 		4: // endpoint 4 out
	MOVF        FARG_ClassTokenOutMSD_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD149
;USB_MSD_Library.mpas,1326 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassTokenOutMSD_local_result+0 
;USB_MSD_Library.mpas,1330 :: 		USB_MSD_IDLE: //
	MOVF        USB_MSD_Library_MSD_State+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD153
;USB_MSD_Library.mpas,1332 :: 		if BDEP4OUTCnt = USB_Msd_Cbw_SIZE then // possibly a CBW has arrived
	MOVF        1057, 0 
	XORLW       31
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD155
;USB_MSD_Library.mpas,1342 :: 		MemCpy__(^byte(@Msd_Cbw), BDEP4OUTAdr, USB_Msd_Cbw_SIZE);
	MOVLW       USB_MSD_Library_Msd_Cbw+0
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(USB_MSD_Library_Msd_Cbw+0)
	MOVWF       FARG_MemCpy___Towards+1 
	MOVF        1058, 0 
	MOVWF       FARG_MemCpy___From+0 
	MOVF        1059, 0 
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       31
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        USB_MSD_Library_MemCpy__+0, 0
;USB_MSD_Library.mpas,1358 :: 		if (Msd_Cbw.Signature = $43425355) then
	MOVF        USB_MSD_Library_Msd_Cbw+3, 0 
	XORLW       67
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD537
	MOVF        USB_MSD_Library_Msd_Cbw+2, 0 
	XORLW       66
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD537
	MOVF        USB_MSD_Library_Msd_Cbw+1, 0 
	XORLW       83
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD537
	MOVF        USB_MSD_Library_Msd_Cbw+0, 0 
	XORLW       85
L_USB_MSD_Library_ClassTokenOutMSD537:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD158
;USB_MSD_Library.mpas,1364 :: 		if (Msd_Cbw.Lun = 0) and
	MOVF        USB_MSD_Library_Msd_Cbw+13, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
;USB_MSD_Library.mpas,1365 :: 		(Msd_Cbw.CbLen <= 16) and
	MOVF        USB_MSD_Library_Msd_Cbw+14, 0 
	SUBLW       16
	MOVLW       0
	BTFSC       STATUS+0, 0 
	MOVLW       255
	MOVWF       R0 
	MOVF        R0, 0 
	ANDWF       R1, 1 
;USB_MSD_Library.mpas,1366 :: 		(Msd_Cbw.CbLen >= 1) and
	MOVLW       1
	SUBWF       USB_MSD_Library_Msd_Cbw+14, 0 
	MOVLW       0
	BTFSC       STATUS+0, 0 
	MOVLW       255
	MOVWF       R0 
	MOVF        R0, 0 
	ANDWF       R1, 0 
	MOVWF       R2 
;USB_MSD_Library.mpas,1367 :: 		((Msd_Cbw.Flags = 0) or (Msd_Cbw.Flags = $80)) then
	MOVF        USB_MSD_Library_Msd_Cbw+12, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        USB_MSD_Library_Msd_Cbw+12, 0 
	XORLW       128
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	IORWF       R0, 1 
	MOVF        R2, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD161
;USB_MSD_Library.mpas,1376 :: 		Msd_Csw.Tag         := Msd_Cbw.Tag; // copy tag to CSW
	MOVF        USB_MSD_Library_Msd_Cbw+4, 0 
	MOVWF       USB_MSD_Library_Msd_Csw+4 
	MOVF        USB_MSD_Library_Msd_Cbw+5, 0 
	MOVWF       USB_MSD_Library_Msd_Csw+5 
	MOVF        USB_MSD_Library_Msd_Cbw+6, 0 
	MOVWF       USB_MSD_Library_Msd_Csw+6 
	MOVF        USB_MSD_Library_Msd_Cbw+7, 0 
	MOVWF       USB_MSD_Library_Msd_Csw+7 
;USB_MSD_Library.mpas,1377 :: 		Msd_Csw.Signature   := $53425355;  // Give CSW its signature
	MOVLW       85
	MOVWF       USB_MSD_Library_Msd_Csw+0 
	MOVLW       83
	MOVWF       USB_MSD_Library_Msd_Csw+1 
	MOVLW       66
	MOVWF       USB_MSD_Library_Msd_Csw+2 
	MOVLW       83
	MOVWF       USB_MSD_Library_Msd_Csw+3 
;USB_MSD_Library.mpas,1378 :: 		Msd_Csw.DataResidue := 0;          // default
	CLRF        USB_MSD_Library_Msd_Csw+8 
	CLRF        USB_MSD_Library_Msd_Csw+9 
	CLRF        USB_MSD_Library_Msd_Csw+10 
	CLRF        USB_MSD_Library_Msd_Csw+11 
;USB_MSD_Library.mpas,1379 :: 		Msd_Csw.Status      := 0;          // default
	CLRF        USB_MSD_Library_Msd_Csw+12 
;USB_MSD_Library.mpas,1381 :: 		MSD_SDMMC_RetryAttempt    := 0;
	CLRF        USB_MSD_Library_MSD_SDMMC_RetryAttempt+0 
;USB_MSD_Library.mpas,1383 :: 		if Msd_Cbw.CommandBlock[0] <> USB_MSD_REQUEST_SENSE then
	MOVF        USB_MSD_Library_Msd_Cbw+15, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD164
;USB_MSD_Library.mpas,1385 :: 		Msd_SenseData.SenseKey_etc := USB_MSD_S_NO_SENSE;
	CLRF        USB_MSD_Library_Msd_SenseData+2 
;USB_MSD_Library.mpas,1386 :: 		Msd_SenseData.ASC          := USB_MSD_ASC_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_Msd_SenseData+12 
;USB_MSD_Library.mpas,1387 :: 		Msd_SenseData.ASCQ         := USB_MSD_ASCQ_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_Msd_SenseData+13 
;USB_MSD_Library.mpas,1388 :: 		end;
L_USB_MSD_Library_ClassTokenOutMSD164:
;USB_MSD_Library.mpas,1390 :: 		MsdProcessCommand(Msd_Cbw.CommandBlock[0]); // execute command
	MOVF        USB_MSD_Library_Msd_Cbw+15, 0 
	MOVWF       FARG_MsdProcessCommand_Command+0 
	CALL        USB_MSD_Library_MsdProcessCommand+0, 0
;USB_MSD_Library.mpas,1392 :: 		end;
L_USB_MSD_Library_ClassTokenOutMSD161:
;USB_MSD_Library.mpas,1393 :: 		end;
L_USB_MSD_Library_ClassTokenOutMSD158:
;USB_MSD_Library.mpas,1394 :: 		end;
L_USB_MSD_Library_ClassTokenOutMSD155:
;USB_MSD_Library.mpas,1395 :: 		end;
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD150
L_USB_MSD_Library_ClassTokenOutMSD153:
;USB_MSD_Library.mpas,1397 :: 		USB_MSD_DATA_OUT: //
	MOVF        USB_MSD_Library_MSD_State+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD168
;USB_MSD_Library.mpas,1402 :: 		Msd_WriteHandler;
	CALL        USB_MSD_Library_Msd_WriteHandler+0, 0
;USB_MSD_Library.mpas,1405 :: 		else
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD150
L_USB_MSD_Library_ClassTokenOutMSD168:
;USB_MSD_Library.mpas,1411 :: 		Msd_State := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1412 :: 		end;
L_USB_MSD_Library_ClassTokenOutMSD150:
;USB_MSD_Library.mpas,1416 :: 		end;
	GOTO        L_USB_MSD_Library_ClassTokenOutMSD146
L_USB_MSD_Library_ClassTokenOutMSD149:
L_USB_MSD_Library_ClassTokenOutMSD146:
;USB_MSD_Library.mpas,1419 :: 		end;
	MOVF        ClassTokenOutMSD_local_result+0, 0 
	MOVWF       R0 
L_end_ClassTokenOutMSD:
	RETURN      0
; end of USB_MSD_Library_ClassTokenOutMSD

USB_MSD_Library_ClassTokenInMSD:

;USB_MSD_Library.mpas,1422 :: 		begin
;USB_MSD_Library.mpas,1423 :: 		Result := false;
	CLRF        ClassTokenInMSD_local_result+0 
;USB_MSD_Library.mpas,1435 :: 		4: // endpoint 4 in
	MOVF        FARG_ClassTokenInMSD_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenInMSD173
;USB_MSD_Library.mpas,1437 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassTokenInMSD_local_result+0 
;USB_MSD_Library.mpas,1440 :: 		USB_MSD_IDLE: //
	MOVF        USB_MSD_Library_MSD_State+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenInMSD177
;USB_MSD_Library.mpas,1445 :: 		end;
	GOTO        L_USB_MSD_Library_ClassTokenInMSD174
L_USB_MSD_Library_ClassTokenInMSD177:
;USB_MSD_Library.mpas,1447 :: 		USB_MSD_DATA_IN: //
	MOVF        USB_MSD_Library_MSD_State+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenInMSD180
;USB_MSD_Library.mpas,1452 :: 		Msd_ReadHandler;
	CALL        USB_MSD_Library_Msd_ReadHandler+0, 0
;USB_MSD_Library.mpas,1453 :: 		end;
	GOTO        L_USB_MSD_Library_ClassTokenInMSD174
L_USB_MSD_Library_ClassTokenInMSD180:
;USB_MSD_Library.mpas,1455 :: 		USB_MSD_SEND_CSW: //
	MOVF        USB_MSD_Library_MSD_State+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassTokenInMSD183
;USB_MSD_Library.mpas,1460 :: 		UsbMsdSendCsw;
	CALL        USB_MSD_Library_UsbMsdSendCsw+0, 0
;USB_MSD_Library.mpas,1463 :: 		else
	GOTO        L_USB_MSD_Library_ClassTokenInMSD174
L_USB_MSD_Library_ClassTokenInMSD183:
;USB_MSD_Library.mpas,1468 :: 		Msd_State := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1469 :: 		end;
L_USB_MSD_Library_ClassTokenInMSD174:
;USB_MSD_Library.mpas,1472 :: 		end;
	GOTO        L_USB_MSD_Library_ClassTokenInMSD170
L_USB_MSD_Library_ClassTokenInMSD173:
L_USB_MSD_Library_ClassTokenInMSD170:
;USB_MSD_Library.mpas,1474 :: 		end;
	MOVF        ClassTokenInMSD_local_result+0, 0 
	MOVWF       R0 
L_end_ClassTokenInMSD:
	RETURN      0
; end of USB_MSD_Library_ClassTokenInMSD

USB_MSD_Library_UsbReset:

;USB_MSD_Library.mpas,1477 :: 		begin
;USB_MSD_Library.mpas,1478 :: 		UEP0 := 0;  // disable UEP0
	CLRF        UEP0+0 
;USB_MSD_Library.mpas,1479 :: 		UEP4 := 0;  // disable UEP4
	CLRF        UEP4+0 
;USB_MSD_Library.mpas,1486 :: 		UCON.PKTDIS := 1;    // disable packet reception
	BSF         UCON+0, 4 
;USB_MSD_Library.mpas,1488 :: 		UsbCurrentConfig := 0;
	CLRF        _UsbCurrentConfig+0 
;USB_MSD_Library.mpas,1489 :: 		IsIdle := false;
	CLRF        _IsIdle+0 
;USB_MSD_Library.mpas,1491 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_MSD_Library.mpas,1492 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_MSD_Library.mpas,1493 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_MSD_Library.mpas,1494 :: 		UIR.TRNIF := 0;  // clear 4 times to make the status fifo empty
	BCF         UIR+0, 3 
;USB_MSD_Library.mpas,1497 :: 		BDEP0OUTAdr  := word(@BuffEP0OUT);
	MOVLW       _BuffEP0OUT+0
	MOVWF       1026 
	MOVLW       hi_addr(_BuffEP0OUT+0)
	MOVWF       1027 
;USB_MSD_Library.mpas,1498 :: 		EP0OutReset(USB_DAT0);  // Initial EP0OUT Status: start with DATA0 toggle bit
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1501 :: 		BDEP0INAdr  := word(@BuffEP0IN);
	MOVLW       _BuffEP0IN+0
	MOVWF       1030 
	MOVLW       hi_addr(_BuffEP0IN+0)
	MOVWF       1031 
;USB_MSD_Library.mpas,1502 :: 		EP0InReset;
	CALL        USB_MSD_Library_EP0InReset+0, 0
;USB_MSD_Library.mpas,1504 :: 		UADDR      := 0; // no usb address assigned (yet)
	CLRF        UADDR+0 
;USB_MSD_Library.mpas,1505 :: 		UIR        := 0; // clear the usb interrupt flags
	CLRF        UIR+0 
;USB_MSD_Library.mpas,1506 :: 		PIR2.USBIF := 0; // enable the USB interrupts
	BCF         PIR2+0, 5 
;USB_MSD_Library.mpas,1508 :: 		UsbDeviceEnumState := USB_DEFAULT_STATE;
	MOVLW       1
	MOVWF       _UsbDeviceEnumState+0 
;USB_MSD_Library.mpas,1513 :: 		Usb_Status_Device := 0; // selfpowered, remote wakeup disabled
	CLRF        _Usb_Status_Device+0 
;USB_MSD_Library.mpas,1515 :: 		UIE  := $39; // enable all interrupts except "ACTIVE", "SOFIE" and "UEREIE"
	MOVLW       57
	MOVWF       UIE+0 
;USB_MSD_Library.mpas,1516 :: 		UEIE := 0;   // disable all error interrupts
	CLRF        UEIE+0 
;USB_MSD_Library.mpas,1519 :: 		UEP0 := USB_EP_CTRL or USB_HSHK_EN;
	MOVLW       22
	MOVWF       UEP0+0 
;USB_MSD_Library.mpas,1520 :: 		UCON.PKTDIS := 0;                     // enable packet reception
	BCF         UCON+0, 4 
;USB_MSD_Library.mpas,1521 :: 		end;
L_end_UsbReset:
	RETURN      0
; end of USB_MSD_Library_UsbReset

USB_MSD_Library_USBError:

;USB_MSD_Library.mpas,1524 :: 		begin
;USB_MSD_Library.mpas,1529 :: 		UEIR := 0;
	CLRF        UEIR+0 
;USB_MSD_Library.mpas,1530 :: 		UIR.UERRIF := 0; // clear error interrupt bit
	BCF         UIR+0, 1 
;USB_MSD_Library.mpas,1532 :: 		end;
L_end_USBError:
	RETURN      0
; end of USB_MSD_Library_USBError

USB_MSD_Library_CopyDescriptorToEP0:

;USB_MSD_Library.mpas,1537 :: 		begin
;USB_MSD_Library.mpas,1538 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       CopyDescriptorToEP0_Dst+0 
	MOVF        1031, 0 
	MOVWF       CopyDescriptorToEP0_Dst+1 
;USB_MSD_Library.mpas,1539 :: 		Len := DescriptorBytesToSend;
	MOVF        _DescriptorBytesToSend+0, 0 
	MOVWF       CopyDescriptorToEP0_Len+0 
;USB_MSD_Library.mpas,1550 :: 		if (Len = 0)
	MOVF        _DescriptorBytesToSend+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_CopyDescriptorToEP0188
;USB_MSD_Library.mpas,1551 :: 		then UsbDeviceRequest := $FF // all bytes have been sent previous time
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
	GOTO        L_USB_MSD_Library_CopyDescriptorToEP0189
;USB_MSD_Library.mpas,1554 :: 		else  // some left over of the descriptor is to be sent
L_USB_MSD_Library_CopyDescriptorToEP0188:
;USB_MSD_Library.mpas,1556 :: 		if (Len > EP0_PACKET_SIZE) then Len := EP0_PACKET_SIZE;
	MOVF        CopyDescriptorToEP0_Len+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_CopyDescriptorToEP0191
	MOVLW       64
	MOVWF       CopyDescriptorToEP0_Len+0 
L_USB_MSD_Library_CopyDescriptorToEP0191:
;USB_MSD_Library.mpas,1557 :: 		for I := 0 to (Len - 1) do
	CLRF        CopyDescriptorToEP0_I+0 
L_USB_MSD_Library_CopyDescriptorToEP0193:
	DECF        CopyDescriptorToEP0_Len+0, 0 
	MOVWF       R1 
	MOVF        CopyDescriptorToEP0_I+0, 0 
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_CopyDescriptorToEP0197
;USB_MSD_Library.mpas,1559 :: 		Dst^:= DescriptorPointer^;
	MOVF        _DescriptorPointer+0, 0 
	MOVWF       TBLPTRL 
	MOVF        _DescriptorPointer+1, 0 
	MOVWF       TBLPTRH 
	MOVF        _DescriptorPointer+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       CopyDescriptorToEP0_Dst+0, FSR1L
	MOVFF       CopyDescriptorToEP0_Dst+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_MSD_Library.mpas,1560 :: 		Inc(Dst);
	INFSNZ      CopyDescriptorToEP0_Dst+0, 1 
	INCF        CopyDescriptorToEP0_Dst+1, 1 
;USB_MSD_Library.mpas,1561 :: 		Inc(DescriptorPointer);
	MOVLW       1
	ADDWF       _DescriptorPointer+0, 1 
	MOVLW       0
	ADDWFC      _DescriptorPointer+1, 1 
	ADDWFC      _DescriptorPointer+2, 1 
;USB_MSD_Library.mpas,1562 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       _DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      _DescriptorBytesToSend+1, 1 
;USB_MSD_Library.mpas,1563 :: 		Dec(DescriptorBytesRequested);
	MOVLW       1
	SUBWF       _DescriptorBytesRequested+0, 1 
	MOVLW       0
	SUBWFB      _DescriptorBytesRequested+1, 1 
;USB_MSD_Library.mpas,1564 :: 		end;
	MOVF        CopyDescriptorToEP0_I+0, 0 
	XORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_CopyDescriptorToEP0197
	INCF        CopyDescriptorToEP0_I+0, 1 
	GOTO        L_USB_MSD_Library_CopyDescriptorToEP0193
L_USB_MSD_Library_CopyDescriptorToEP0197:
;USB_MSD_Library.mpas,1565 :: 		end;
L_USB_MSD_Library_CopyDescriptorToEP0189:
;USB_MSD_Library.mpas,1567 :: 		if (DescriptorBytesRequested = 0)
	MOVLW       0
	XORWF       _DescriptorBytesRequested+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_CopyDescriptorToEP0542
	MOVLW       0
	XORWF       _DescriptorBytesRequested+0, 0 
L_USB_MSD_Library_CopyDescriptorToEP0542:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_CopyDescriptorToEP0199
;USB_MSD_Library.mpas,1568 :: 		then UsbDeviceRequest := $FF; // all bytes have been sent after this
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
L_USB_MSD_Library_CopyDescriptorToEP0199:
;USB_MSD_Library.mpas,1570 :: 		BDEP0INCnt  := Len;
	MOVF        CopyDescriptorToEP0_Len+0, 0 
	MOVWF       1029 
;USB_MSD_Library.mpas,1571 :: 		BDEP0INAdr  := word(@BuffEP0IN);
	MOVLW       _BuffEP0IN+0
	MOVWF       1030 
	MOVLW       hi_addr(_BuffEP0IN+0)
	MOVWF       1031 
;USB_MSD_Library.mpas,1572 :: 		GiveEP0INtoSIE__; // send
	CALL        USB_MSD_Library_GiveEP0INtoSIE__+0, 0
;USB_MSD_Library.mpas,1573 :: 		end;
L_end_CopyDescriptorToEP0:
	RETURN      0
; end of USB_MSD_Library_CopyDescriptorToEP0

USB_MSD_Library_SendStringDescriptorToEP0:

;USB_MSD_Library.mpas,1578 :: 		begin
;USB_MSD_Library.mpas,1580 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       SendStringDescriptorToEP0_Dst+0 
	MOVF        1031, 0 
	MOVWF       SendStringDescriptorToEP0_Dst+1 
;USB_MSD_Library.mpas,1581 :: 		Len := DescriptorBytesToSend;
	MOVF        _DescriptorBytesToSend+0, 0 
	MOVWF       SendStringDescriptorToEP0_Len+0 
;USB_MSD_Library.mpas,1583 :: 		if (Len = 0)
	MOVF        _DescriptorBytesToSend+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_SendStringDescriptorToEP0203
;USB_MSD_Library.mpas,1584 :: 		then UsbDeviceRequest := $FF // all bytes have been sent previous time
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
	GOTO        L_USB_MSD_Library_SendStringDescriptorToEP0204
;USB_MSD_Library.mpas,1587 :: 		else  // some left over of the descriptor is to be sent
L_USB_MSD_Library_SendStringDescriptorToEP0203:
;USB_MSD_Library.mpas,1589 :: 		if (Len > EP0_PACKET_SIZE) then Len := EP0_PACKET_SIZE;
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_SendStringDescriptorToEP0206
	MOVLW       64
	MOVWF       SendStringDescriptorToEP0_Len+0 
L_USB_MSD_Library_SendStringDescriptorToEP0206:
;USB_MSD_Library.mpas,1596 :: 		I := 0;
	CLRF        SendStringDescriptorToEP0_I+0 
;USB_MSD_Library.mpas,1597 :: 		if StartStringDescriptor then     // first send length byte and string descriptor identifier
	MOVF        _StartStringDescriptor+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_SendStringDescriptorToEP0209
;USB_MSD_Library.mpas,1599 :: 		Dst^ := Len;                    // length byte
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       POSTINC1+0 
;USB_MSD_Library.mpas,1600 :: 		inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_MSD_Library.mpas,1601 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       _DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      _DescriptorBytesToSend+1, 1 
;USB_MSD_Library.mpas,1603 :: 		Dst^ := USB_STRING_DESCRIPTOR;  // descriptor identifcation
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVLW       3
	MOVWF       POSTINC1+0 
;USB_MSD_Library.mpas,1604 :: 		inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_MSD_Library.mpas,1605 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       _DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      _DescriptorBytesToSend+1, 1 
;USB_MSD_Library.mpas,1607 :: 		I := 2;
	MOVLW       2
	MOVWF       SendStringDescriptorToEP0_I+0 
;USB_MSD_Library.mpas,1608 :: 		StartStringDescriptor := false;
	CLRF        _StartStringDescriptor+0 
;USB_MSD_Library.mpas,1609 :: 		end;
L_USB_MSD_Library_SendStringDescriptorToEP0209:
;USB_MSD_Library.mpas,1611 :: 		while I < Len do
L_USB_MSD_Library_SendStringDescriptorToEP0212:
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	SUBWF       SendStringDescriptorToEP0_I+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_SendStringDescriptorToEP0213
;USB_MSD_Library.mpas,1613 :: 		Dst^:= DescriptorPointer^;     // copy byte
	MOVF        _DescriptorPointer+0, 0 
	MOVWF       TBLPTRL 
	MOVF        _DescriptorPointer+1, 0 
	MOVWF       TBLPTRH 
	MOVF        _DescriptorPointer+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_MSD_Library.mpas,1614 :: 		Inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_MSD_Library.mpas,1615 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       _DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      _DescriptorBytesToSend+1, 1 
;USB_MSD_Library.mpas,1616 :: 		Inc(DescriptorPointer);
	MOVLW       1
	ADDWF       _DescriptorPointer+0, 1 
	MOVLW       0
	ADDWFC      _DescriptorPointer+1, 1 
	ADDWFC      _DescriptorPointer+2, 1 
;USB_MSD_Library.mpas,1617 :: 		inc(I);
	INCF        SendStringDescriptorToEP0_I+0, 1 
;USB_MSD_Library.mpas,1619 :: 		Dst^:= 0;                     // and add zero
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	CLRF        POSTINC1+0 
;USB_MSD_Library.mpas,1620 :: 		Inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_MSD_Library.mpas,1621 :: 		Dec(DescriptorBytesToSend);
	MOVLW       1
	SUBWF       _DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      _DescriptorBytesToSend+1, 1 
;USB_MSD_Library.mpas,1622 :: 		inc(I);
	INCF        SendStringDescriptorToEP0_I+0, 1 
;USB_MSD_Library.mpas,1623 :: 		end;
	GOTO        L_USB_MSD_Library_SendStringDescriptorToEP0212
L_USB_MSD_Library_SendStringDescriptorToEP0213:
;USB_MSD_Library.mpas,1624 :: 		end;
L_USB_MSD_Library_SendStringDescriptorToEP0204:
;USB_MSD_Library.mpas,1626 :: 		if (DescriptorBytesToSend = 0)
	MOVLW       0
	XORWF       _DescriptorBytesToSend+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_SendStringDescriptorToEP0544
	MOVLW       0
	XORWF       _DescriptorBytesToSend+0, 0 
L_USB_MSD_Library_SendStringDescriptorToEP0544:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_SendStringDescriptorToEP0217
;USB_MSD_Library.mpas,1627 :: 		then UsbDeviceRequest := $FF; // all bytes have been sent after this
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
L_USB_MSD_Library_SendStringDescriptorToEP0217:
;USB_MSD_Library.mpas,1634 :: 		BDEP0INCnt  := Len;
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       1029 
;USB_MSD_Library.mpas,1635 :: 		BDEP0INAdr  := word(@BuffEP0IN);
	MOVLW       _BuffEP0IN+0
	MOVWF       1030 
	MOVLW       hi_addr(_BuffEP0IN+0)
	MOVWF       1031 
;USB_MSD_Library.mpas,1636 :: 		GiveEP0INtoSIE__; // send
	CALL        USB_MSD_Library_GiveEP0INtoSIE__+0, 0
;USB_MSD_Library.mpas,1637 :: 		end;
L_end_SendStringDescriptorToEP0:
	RETURN      0
; end of USB_MSD_Library_SendStringDescriptorToEP0

USB_MSD_Library_PrepareStringDescriptor:

;USB_MSD_Library.mpas,1642 :: 		begin
;USB_MSD_Library.mpas,1644 :: 		Len := 0;
	CLRF        R5 
;USB_MSD_Library.mpas,1645 :: 		Tmp := Src;
	MOVF        FARG_PrepareStringDescriptor_Src+0, 0 
	MOVWF       R2 
	MOVF        FARG_PrepareStringDescriptor_Src+1, 0 
	MOVWF       R3 
	MOVF        FARG_PrepareStringDescriptor_Src+2, 0 
	MOVWF       R4 
;USB_MSD_Library.mpas,1646 :: 		while Tmp^ > 0 do
L_USB_MSD_Library_PrepareStringDescriptor221:
	MOVF        R2, 0 
	MOVWF       TBLPTRL 
	MOVF        R3, 0 
	MOVWF       TBLPTRH 
	MOVF        R4, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R1
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_PrepareStringDescriptor222
;USB_MSD_Library.mpas,1648 :: 		inc(Len);
	INCF        R5, 1 
;USB_MSD_Library.mpas,1649 :: 		inc(Tmp);
	MOVLW       1
	ADDWF       R2, 1 
	MOVLW       0
	ADDWFC      R3, 1 
	ADDWFC      R4, 1 
;USB_MSD_Library.mpas,1650 :: 		end;
	GOTO        L_USB_MSD_Library_PrepareStringDescriptor221
L_USB_MSD_Library_PrepareStringDescriptor222:
;USB_MSD_Library.mpas,1651 :: 		Len := (2 * Len) + 2;
	MOVF        R5, 0 
	MOVWF       R0 
	RLCF        R0, 1 
	BCF         R0, 0 
	MOVLW       2
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       R5 
;USB_MSD_Library.mpas,1653 :: 		DescriptorPointer     := Src;
	MOVF        FARG_PrepareStringDescriptor_Src+0, 0 
	MOVWF       _DescriptorPointer+0 
	MOVF        FARG_PrepareStringDescriptor_Src+1, 0 
	MOVWF       _DescriptorPointer+1 
	MOVF        FARG_PrepareStringDescriptor_Src+2, 0 
	MOVWF       _DescriptorPointer+2 
;USB_MSD_Library.mpas,1654 :: 		DescriptorBytesToSend := Len;
	MOVF        R0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_MSD_Library.mpas,1655 :: 		UsbDeviceRequest      := USB_GET_STRING_DESCRIPTOR_ONGOING;
	MOVLW       2
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,1656 :: 		StartStringDescriptor := true;
	MOVLW       255
	MOVWF       _StartStringDescriptor+0 
;USB_MSD_Library.mpas,1657 :: 		end;
L_end_PrepareStringDescriptor:
	RETURN      0
; end of USB_MSD_Library_PrepareStringDescriptor

USB_MSD_Library_GetDescriptor:

;USB_MSD_Library.mpas,1661 :: 		begin
;USB_MSD_Library.mpas,1662 :: 		Index := Lo(SetUpPacket.wValue);
	MOVF        _SetUpPacket+2, 0 
	MOVWF       GetDescriptor_Index+0 
;USB_MSD_Library.mpas,1680 :: 		USB_DEVICE_DESCRIPTOR         : // GetDeviceDescriptor
	MOVF        _SetUpPacket+3, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor229
;USB_MSD_Library.mpas,1682 :: 		UsbDeviceRequest           := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,1683 :: 		DescriptorPointer          := @DeviceDescriptor;
	MOVLW       _DeviceDescriptor+0
	MOVWF       _DescriptorPointer+0 
	MOVLW       hi_addr(_DeviceDescriptor+0)
	MOVWF       _DescriptorPointer+1 
	MOVLW       higher_addr(_DeviceDescriptor+0)
	MOVWF       _DescriptorPointer+2 
;USB_MSD_Library.mpas,1684 :: 		DescriptorBytesToSend      := SizeOf(DeviceDescriptor);
	MOVLW       18
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_MSD_Library.mpas,1685 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_MSD_Library.mpas,1686 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVLW       0
	SUBWF       _SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor547
	MOVLW       18
	SUBWF       _SetUpPacket+6, 0 
L_USB_MSD_Library_GetDescriptor547:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_GetDescriptor231
;USB_MSD_Library.mpas,1687 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        _DescriptorBytesRequested+0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        _DescriptorBytesRequested+1, 0 
	MOVWF       _DescriptorBytesToSend+1 
L_USB_MSD_Library_GetDescriptor231:
;USB_MSD_Library.mpas,1688 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1689 :: 		CopyDescriptorToEP0;
	CALL        USB_MSD_Library_CopyDescriptorToEP0+0, 0
;USB_MSD_Library.mpas,1690 :: 		end;
	GOTO        L_USB_MSD_Library_GetDescriptor226
L_USB_MSD_Library_GetDescriptor229:
;USB_MSD_Library.mpas,1692 :: 		USB_CONFIGURATION_DESCRIPTOR  : // GetConfigDescriptor;
	MOVF        _SetUpPacket+3, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor235
;USB_MSD_Library.mpas,1694 :: 		UsbDeviceRequest           := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,1695 :: 		DescriptorPointer          := @Config1;
	MOVLW       _Config1+0
	MOVWF       _DescriptorPointer+0 
	MOVLW       hi_addr(_Config1+0)
	MOVWF       _DescriptorPointer+1 
	MOVLW       higher_addr(_Config1+0)
	MOVWF       _DescriptorPointer+2 
;USB_MSD_Library.mpas,1696 :: 		DescriptorBytesToSend      := SizeOf(Config1);
	MOVLW       32
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_MSD_Library.mpas,1697 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_MSD_Library.mpas,1698 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVLW       0
	SUBWF       _SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor548
	MOVLW       32
	SUBWF       _SetUpPacket+6, 0 
L_USB_MSD_Library_GetDescriptor548:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_GetDescriptor237
;USB_MSD_Library.mpas,1699 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        _DescriptorBytesRequested+0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        _DescriptorBytesRequested+1, 0 
	MOVWF       _DescriptorBytesToSend+1 
L_USB_MSD_Library_GetDescriptor237:
;USB_MSD_Library.mpas,1700 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1701 :: 		CopyDescriptorToEP0;
	CALL        USB_MSD_Library_CopyDescriptorToEP0+0, 0
;USB_MSD_Library.mpas,1702 :: 		end;
	GOTO        L_USB_MSD_Library_GetDescriptor226
L_USB_MSD_Library_GetDescriptor235:
;USB_MSD_Library.mpas,1704 :: 		USB_STRING_DESCRIPTOR         : // GetStringDescriptor(Index);
	MOVF        _SetUpPacket+3, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor241
;USB_MSD_Library.mpas,1706 :: 		if Index <= 3 then
	MOVF        GetDescriptor_Index+0, 0 
	SUBLW       3
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_GetDescriptor243
;USB_MSD_Library.mpas,1710 :: 		0: //
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor248
;USB_MSD_Library.mpas,1712 :: 		DescriptorPointer     := @LanguageString;
	MOVLW       _LanguageString+0
	MOVWF       _DescriptorPointer+0 
	MOVLW       hi_addr(_LanguageString+0)
	MOVWF       _DescriptorPointer+1 
	MOVLW       higher_addr(_LanguageString+0)
	MOVWF       _DescriptorPointer+2 
;USB_MSD_Library.mpas,1713 :: 		DescriptorBytesToSend := SizeOf(LanguageString);
	MOVLW       4
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_MSD_Library.mpas,1714 :: 		UsbDeviceRequest      := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,1715 :: 		end;
	GOTO        L_USB_MSD_Library_GetDescriptor245
L_USB_MSD_Library_GetDescriptor248:
;USB_MSD_Library.mpas,1716 :: 		1: PrepareStringDescriptor(@UsbManufacturer);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor251
	MOVLW       _UsbManufacturer+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbManufacturer+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbManufacturer+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_MSD_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_MSD_Library_GetDescriptor245
L_USB_MSD_Library_GetDescriptor251:
;USB_MSD_Library.mpas,1717 :: 		2: PrepareStringDescriptor(@UsbProduct);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor254
	MOVLW       _UsbProduct+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbProduct+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbProduct+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_MSD_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_MSD_Library_GetDescriptor245
L_USB_MSD_Library_GetDescriptor254:
;USB_MSD_Library.mpas,1718 :: 		3: PrepareStringDescriptor(@UsbSerialNo);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor257
	MOVLW       _UsbSerialNo+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbSerialNo+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbSerialNo+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_MSD_Library_PrepareStringDescriptor+0, 0
	GOTO        L_USB_MSD_Library_GetDescriptor245
L_USB_MSD_Library_GetDescriptor257:
L_USB_MSD_Library_GetDescriptor245:
;USB_MSD_Library.mpas,1720 :: 		DescriptorBytesRequested   := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_MSD_Library.mpas,1721 :: 		if DescriptorBytesToSend > DescriptorBytesRequested
	MOVF        _DescriptorBytesToSend+1, 0 
	SUBWF       _SetUpPacket+7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor549
	MOVF        _DescriptorBytesToSend+0, 0 
	SUBWF       _SetUpPacket+6, 0 
L_USB_MSD_Library_GetDescriptor549:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_GetDescriptor259
;USB_MSD_Library.mpas,1722 :: 		then DescriptorBytesToSend := DescriptorBytesRequested;
	MOVF        _DescriptorBytesRequested+0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        _DescriptorBytesRequested+1, 0 
	MOVWF       _DescriptorBytesToSend+1 
L_USB_MSD_Library_GetDescriptor259:
;USB_MSD_Library.mpas,1724 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1725 :: 		if Index = 0
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_GetDescriptor262
;USB_MSD_Library.mpas,1726 :: 		then CopyDescriptorToEP0        // string is in constant memory
	CALL        USB_MSD_Library_CopyDescriptorToEP0+0, 0
	GOTO        L_USB_MSD_Library_GetDescriptor263
;USB_MSD_Library.mpas,1727 :: 		else SendStringDescriptorToEP0; // special case
L_USB_MSD_Library_GetDescriptor262:
	CALL        USB_MSD_Library_SendStringDescriptorToEP0+0, 0
L_USB_MSD_Library_GetDescriptor263:
;USB_MSD_Library.mpas,1728 :: 		end
	GOTO        L_USB_MSD_Library_GetDescriptor244
;USB_MSD_Library.mpas,1729 :: 		else StallEP0;
L_USB_MSD_Library_GetDescriptor243:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_GetDescriptor244:
;USB_MSD_Library.mpas,1731 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_GetDescriptor226
L_USB_MSD_Library_GetDescriptor241:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_GetDescriptor226:
;USB_MSD_Library.mpas,1733 :: 		end;
L_end_GetDescriptor:
	RETURN      0
; end of USB_MSD_Library_GetDescriptor

USB_MSD_Library_TokenOutPID:

;USB_MSD_Library.mpas,1737 :: 		begin
;USB_MSD_Library.mpas,1738 :: 		Ep := (USTATCopy shr 3) and $0F; // get endpoint
	MOVF        _USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       TokenOutPID_Ep+0 
;USB_MSD_Library.mpas,1746 :: 		if (Ep = 0) and (BDEP0OUTCnt = 0) then  // ZLP received , reset EP0 out, ready for reception
	MOVF        R0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        1025, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenOutPID266
;USB_MSD_Library.mpas,1748 :: 		EP0OutReset(USB_DAT0);  // reset EP0 to its initial state
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1752 :: 		exit;
	GOTO        L_end_USB_MSD_Library_TokenOutPID
;USB_MSD_Library.mpas,1753 :: 		end;
L_USB_MSD_Library_TokenOutPID266:
;USB_MSD_Library.mpas,1756 :: 		0: // Endpoint 0 out
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenOutPID271
;USB_MSD_Library.mpas,1763 :: 		end;
	GOTO        L_USB_MSD_Library_TokenOutPID268
L_USB_MSD_Library_TokenOutPID271:
;USB_MSD_Library.mpas,1765 :: 		4: //
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenOutPID274
;USB_MSD_Library.mpas,1767 :: 		ClassTokenOutMSD(Ep);
	MOVF        TokenOutPID_Ep+0, 0 
	MOVWF       FARG_ClassTokenOutMSD_Ep+0 
	CALL        USB_MSD_Library_ClassTokenOutMSD+0, 0
;USB_MSD_Library.mpas,1768 :: 		end;
	GOTO        L_USB_MSD_Library_TokenOutPID268
L_USB_MSD_Library_TokenOutPID274:
L_USB_MSD_Library_TokenOutPID268:
;USB_MSD_Library.mpas,1770 :: 		end;
L_end_USB_MSD_Library_TokenOutPID:
L_end_TokenOutPID:
	RETURN      0
; end of USB_MSD_Library_TokenOutPID

USB_MSD_Library_TokenInPID:

;USB_MSD_Library.mpas,1774 :: 		begin
;USB_MSD_Library.mpas,1775 :: 		Ep := (USTATCopy shr 3) and $0F; // get endpoint
	MOVF        _USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       TokenInPID_Ep+0 
;USB_MSD_Library.mpas,1784 :: 		0: // endpoint 0
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenInPID279
;USB_MSD_Library.mpas,1792 :: 		USB_GET_DESCRIPTOR_ONGOING:         CopyDescriptorToEP0;
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenInPID283
	CALL        USB_MSD_Library_CopyDescriptorToEP0+0, 0
	GOTO        L_USB_MSD_Library_TokenInPID280
L_USB_MSD_Library_TokenInPID283:
;USB_MSD_Library.mpas,1794 :: 		USB_GET_STRING_DESCRIPTOR_ONGOING:  SendStringDescriptorToEP0;
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenInPID286
	CALL        USB_MSD_Library_SendStringDescriptorToEP0+0, 0
	GOTO        L_USB_MSD_Library_TokenInPID280
L_USB_MSD_Library_TokenInPID286:
;USB_MSD_Library.mpas,1796 :: 		USB_SET_ADDRESS_ONGOING:      //  FinishSetAddress;
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenInPID289
;USB_MSD_Library.mpas,1798 :: 		UsbDeviceRequest := $FF;    // clear current device request
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,1799 :: 		UsbCurrentConfig := 0;      // clear configuration
	CLRF        _UsbCurrentConfig+0 
;USB_MSD_Library.mpas,1800 :: 		UADDR := UsbAddressPending; // set USB Address
	MOVF        _UsbAddressPending+0, 0 
	MOVWF       UADDR+0 
;USB_MSD_Library.mpas,1801 :: 		if UsbAddressPending > 0
	MOVF        _UsbAddressPending+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_TokenInPID291
;USB_MSD_Library.mpas,1804 :: 		UsbDeviceEnumState := USB_ADDRESS_STATE; // change status
	MOVLW       2
	MOVWF       _UsbDeviceEnumState+0 
;USB_MSD_Library.mpas,1808 :: 		end;
L_USB_MSD_Library_TokenInPID291:
;USB_MSD_Library.mpas,1815 :: 		end;
	GOTO        L_USB_MSD_Library_TokenInPID280
L_USB_MSD_Library_TokenInPID289:
L_USB_MSD_Library_TokenInPID280:
;USB_MSD_Library.mpas,1817 :: 		end;
	GOTO        L_USB_MSD_Library_TokenInPID276
L_USB_MSD_Library_TokenInPID279:
;USB_MSD_Library.mpas,1819 :: 		4: //
	MOVF        TokenInPID_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenInPID295
;USB_MSD_Library.mpas,1821 :: 		ClassTokenInMSD(Ep);
	MOVF        TokenInPID_Ep+0, 0 
	MOVWF       FARG_ClassTokenInMSD_Ep+0 
	CALL        USB_MSD_Library_ClassTokenInMSD+0, 0
;USB_MSD_Library.mpas,1822 :: 		end;
	GOTO        L_USB_MSD_Library_TokenInPID276
L_USB_MSD_Library_TokenInPID295:
L_USB_MSD_Library_TokenInPID276:
;USB_MSD_Library.mpas,1825 :: 		end;
L_end_TokenInPID:
	RETURN      0
; end of USB_MSD_Library_TokenInPID

USB_MSD_Library_ClassSpecificRequest:

;USB_MSD_Library.mpas,1831 :: 		begin
;USB_MSD_Library.mpas,1833 :: 		if (SetUpPacket.wIndex =0) then
	MOVLW       0
	XORWF       _SetUpPacket+5, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassSpecificRequest553
	MOVLW       0
	XORWF       _SetUpPacket+4, 0 
L_USB_MSD_Library_ClassSpecificRequest553:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassSpecificRequest298
;USB_MSD_Library.mpas,1843 :: 		USB_MSD_RESET: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassSpecificRequest303
;USB_MSD_Library.mpas,1848 :: 		MSD_State   := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1849 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1851 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1852 :: 		SendAckToHost;
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,1853 :: 		end;
	GOTO        L_USB_MSD_Library_ClassSpecificRequest300
L_USB_MSD_Library_ClassSpecificRequest303:
;USB_MSD_Library.mpas,1855 :: 		USB_MSD_GET_MAX_LUN: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       254
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_ClassSpecificRequest306
;USB_MSD_Library.mpas,1860 :: 		EP0OutReset(USB_DAT1);          // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1861 :: 		BuffEP0IN[0] := 0;
	CLRF        1344 
;USB_MSD_Library.mpas,1862 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_MSD_Library.mpas,1863 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,1864 :: 		end;
	GOTO        L_USB_MSD_Library_ClassSpecificRequest300
L_USB_MSD_Library_ClassSpecificRequest306:
L_USB_MSD_Library_ClassSpecificRequest300:
;USB_MSD_Library.mpas,1867 :: 		end;
L_USB_MSD_Library_ClassSpecificRequest298:
;USB_MSD_Library.mpas,1868 :: 		end;
L_end_ClassSpecificRequest:
	RETURN      0
; end of USB_MSD_Library_ClassSpecificRequest

USB_MSD_Library_CheckForVendorRequest:

;USB_MSD_Library.mpas,1871 :: 		begin
;USB_MSD_Library.mpas,1875 :: 		end;
L_end_CheckForVendorRequest:
	RETURN      0
; end of USB_MSD_Library_CheckForVendorRequest

USB_MSD_Library_SetUpMSDEndpoints:

;USB_MSD_Library.mpas,1879 :: 		begin
;USB_MSD_Library.mpas,1885 :: 		MSD_State   := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_MSD_State+0 
;USB_MSD_Library.mpas,1886 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_Msd_Command+0 
;USB_MSD_Library.mpas,1888 :: 		SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
	MOVLW       2
	MOVWF       FARG_SPI1_Init_Advanced_master+0 
	CLRF        FARG_SPI1_Init_Advanced_data_sample+0 
	CLRF        FARG_SPI1_Init_Advanced_clock_idle+0 
	MOVLW       1
	MOVWF       FARG_SPI1_Init_Advanced_transmit_edge+0 
	CALL        _SPI1_Init_Advanced+0, 0
;USB_MSD_Library.mpas,1889 :: 		delay_ms(500);
	MOVLW       31
	MOVWF       R11, 0
	MOVLW       113
	MOVWF       R12, 0
	MOVLW       30
	MOVWF       R13, 0
L_USB_MSD_Library_SetUpMSDEndpoints309:
	DECFSZ      R13, 1, 1
	BRA         L_USB_MSD_Library_SetUpMSDEndpoints309
	DECFSZ      R12, 1, 1
	BRA         L_USB_MSD_Library_SetUpMSDEndpoints309
	DECFSZ      R11, 1, 1
	BRA         L_USB_MSD_Library_SetUpMSDEndpoints309
	NOP
;USB_MSD_Library.mpas,1891 :: 		Res := MMC_Init;
	CALL        _Mmc_Init+0, 0
;USB_MSD_Library.mpas,1892 :: 		if Res = 0 then SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_SetUpMSDEndpoints311
	CLRF        FARG_SPI1_Init_Advanced_master+0 
	CLRF        FARG_SPI1_Init_Advanced_data_sample+0 
	CLRF        FARG_SPI1_Init_Advanced_clock_idle+0 
	MOVLW       1
	MOVWF       FARG_SPI1_Init_Advanced_transmit_edge+0 
	CALL        _SPI1_Init_Advanced+0, 0
L_USB_MSD_Library_SetUpMSDEndpoints311:
;USB_MSD_Library.mpas,1894 :: 		Msd_ResetSenseData;
	CALL        USB_MSD_Library_Msd_ResetSenseData+0, 0
;USB_MSD_Library.mpas,1896 :: 		BDEP4OUTAdr  := word(@BuffEP4OUT);
	MOVLW       _BuffEP4OUT+0
	MOVWF       1058 
	MOVLW       hi_addr(_BuffEP4OUT+0)
	MOVWF       1059 
;USB_MSD_Library.mpas,1902 :: 		BDEP4OUTCnt  := (USB_MSD_BULK_OUT_EP_SIZE);
	MOVLW       64
	MOVWF       1057 
;USB_MSD_Library.mpas,1903 :: 		BDEP4OUTStat := (USB_USIE or USB_DAT0 or USB_DTSEN);
	MOVLW       136
	MOVWF       1056 
;USB_MSD_Library.mpas,1905 :: 		BDEP4INAdr   := word(@BuffEP4IN);
	MOVLW       _BuffEP4IN+0
	MOVWF       1062 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       1063 
;USB_MSD_Library.mpas,1906 :: 		BDEP4INStat  := (USB_UCPU or USB_DAT1 or USB_DTSEN); // DAT will be toggled before actual usage
	MOVLW       72
	MOVWF       1060 
;USB_MSD_Library.mpas,1908 :: 		UEP4         := (USB_EP_OUT_IN or USB_HSHK_EN);  // enable data pipes
	MOVLW       30
	MOVWF       UEP4+0 
;USB_MSD_Library.mpas,1914 :: 		end;
L_end_SetUpMSDEndpoints:
	RETURN      0
; end of USB_MSD_Library_SetUpMSDEndpoints

USB_MSD_Library_TokenSetupPID:

;USB_MSD_Library.mpas,1920 :: 		begin
;USB_MSD_Library.mpas,1921 :: 		UsbDeviceRequest := $FF; // clear the device request
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,1924 :: 		Dst := ^byte(@SetupPacket);
	MOVLW       _SetUpPacket+0
	MOVWF       TokenSetupPID_Dst+0 
	MOVLW       hi_addr(_SetUpPacket+0)
	MOVWF       TokenSetupPID_Dst+1 
;USB_MSD_Library.mpas,1925 :: 		Src := ^byte(BufferDescriptor^.Address);
	MOVLW       2
	ADDWF       _BufferDescriptor+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      _BufferDescriptor+1, 0 
	MOVWF       R1 
	MOVFF       R0, FSR0L
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       TokenSetupPID_Src+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       TokenSetupPID_Src+1 
;USB_MSD_Library.mpas,1926 :: 		for I := 0 to (SizeOf(SetupPacket) - 1) do
	CLRF        TokenSetupPID_I+0 
L_USB_MSD_Library_TokenSetupPID315:
;USB_MSD_Library.mpas,1928 :: 		Dst^ := Src^;
	MOVFF       TokenSetupPID_Src+0, FSR0L
	MOVFF       TokenSetupPID_Src+1, FSR0H
	MOVFF       TokenSetupPID_Dst+0, FSR1L
	MOVFF       TokenSetupPID_Dst+1, FSR1H
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;USB_MSD_Library.mpas,1929 :: 		Inc(Src);
	INFSNZ      TokenSetupPID_Src+0, 1 
	INCF        TokenSetupPID_Src+1, 1 
;USB_MSD_Library.mpas,1930 :: 		Inc(Dst);
	INFSNZ      TokenSetupPID_Dst+0, 1 
	INCF        TokenSetupPID_Dst+1, 1 
;USB_MSD_Library.mpas,1931 :: 		end;
	MOVF        TokenSetupPID_I+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID318
	INCF        TokenSetupPID_I+0, 1 
	GOTO        L_USB_MSD_Library_TokenSetupPID315
L_USB_MSD_Library_TokenSetupPID318:
;USB_MSD_Library.mpas,1933 :: 		BDEP0OUTStat := 0;     //
	CLRF        1024 
;USB_MSD_Library.mpas,1934 :: 		BDEP0INStat  := (USB_UCPU or USB_DAT0 or USB_DTSEN); // return the IN buffer to us (dequeue any pending requests)
	MOVLW       8
	MOVWF       1028 
;USB_MSD_Library.mpas,1935 :: 		UCON.PKTDIS := 0; // enable setup packets
	BCF         UCON+0, 4 
;USB_MSD_Library.mpas,1968 :: 		USB_STD_HOST_TO_DEVICE: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID322
;USB_MSD_Library.mpas,1972 :: 		USB_CLEAR_FEATURE:               // ClearDeviceFeature;
	MOVF        _SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID326
;USB_MSD_Library.mpas,1974 :: 		if SetUpPacket.wValue = 1 then // device remote wakeup
	MOVLW       0
	XORWF       _SetUpPacket+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID557
	MOVLW       1
	XORWF       _SetUpPacket+2, 0 
L_USB_MSD_Library_TokenSetupPID557:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID328
;USB_MSD_Library.mpas,1976 :: 		Usb_Status_Device.1 := 0;
	BCF         _Usb_Status_Device+0, 1 
;USB_MSD_Library.mpas,1977 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1978 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,1979 :: 		end else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID329
L_USB_MSD_Library_TokenSetupPID328:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID329:
;USB_MSD_Library.mpas,1980 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID323
L_USB_MSD_Library_TokenSetupPID326:
;USB_MSD_Library.mpas,1982 :: 		USB_SET_FEATURE:                 // SetDeviceFeature
	MOVF        _SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID332
;USB_MSD_Library.mpas,1984 :: 		if SetUpPacket.wValue = 1 then // device remote wakeup
	MOVLW       0
	XORWF       _SetUpPacket+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID558
	MOVLW       1
	XORWF       _SetUpPacket+2, 0 
L_USB_MSD_Library_TokenSetupPID558:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID334
;USB_MSD_Library.mpas,1986 :: 		Usb_Status_Device.1 := 1;
	BSF         _Usb_Status_Device+0, 1 
;USB_MSD_Library.mpas,1987 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1988 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,1989 :: 		end else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID335
L_USB_MSD_Library_TokenSetupPID334:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID335:
;USB_MSD_Library.mpas,1990 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID323
L_USB_MSD_Library_TokenSetupPID332:
;USB_MSD_Library.mpas,1992 :: 		USB_SET_ADDRESS:                           //SetAddress;
	MOVF        _SetUpPacket+1, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID338
;USB_MSD_Library.mpas,1994 :: 		UsbDeviceRequest := USB_SET_ADDRESS_ONGOING;
	MOVLW       3
	MOVWF       _UsbDeviceRequest+0 
;USB_MSD_Library.mpas,1995 :: 		UsbAddressPending := SetUpPacket.wValue; // USB address
	MOVF        _SetUpPacket+2, 0 
	MOVWF       _UsbAddressPending+0 
;USB_MSD_Library.mpas,1996 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,1997 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_MSD_Library.mpas,1998 :: 		BDEP0INStat := (USB_USIE or USB_DAT1 or USB_DTSEN); // echo the buffer
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,1999 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID323
L_USB_MSD_Library_TokenSetupPID338:
;USB_MSD_Library.mpas,2001 :: 		USB_SET_CONFIGURATION:                     // SetConfiguration;
	MOVF        _SetUpPacket+1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID341
;USB_MSD_Library.mpas,2003 :: 		Config := Lo(SetUpPacket.wValue);
	MOVF        _SetUpPacket+2, 0 
	MOVWF       TokenSetupPID_Config+0 
;USB_MSD_Library.mpas,2004 :: 		if Config <= USB_NUM_CONFIGURATIONS then
	MOVF        _SetUpPacket+2, 0 
	SUBLW       1
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_TokenSetupPID343
;USB_MSD_Library.mpas,2006 :: 		UsbCurrentConfig := Config;            // set configuration
	MOVF        TokenSetupPID_Config+0, 0 
	MOVWF       _UsbCurrentConfig+0 
;USB_MSD_Library.mpas,2007 :: 		if Config > 0 then
	MOVF        TokenSetupPID_Config+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_TokenSetupPID346
;USB_MSD_Library.mpas,2009 :: 		UsbDeviceEnumState := USB_CONFIG_STATE;
	MOVLW       3
	MOVWF       _UsbDeviceEnumState+0 
;USB_MSD_Library.mpas,2013 :: 		SetUpMSDEndpoints;
	CALL        USB_MSD_Library_SetUpMSDEndpoints+0, 0
;USB_MSD_Library.mpas,2014 :: 		end
	GOTO        L_USB_MSD_Library_TokenSetupPID347
;USB_MSD_Library.mpas,2015 :: 		else
L_USB_MSD_Library_TokenSetupPID346:
;USB_MSD_Library.mpas,2017 :: 		UsbDeviceEnumState := USB_ADDRESS_STATE; // no configuration selected
	MOVLW       2
	MOVWF       _UsbDeviceEnumState+0 
;USB_MSD_Library.mpas,2021 :: 		end;
L_USB_MSD_Library_TokenSetupPID347:
;USB_MSD_Library.mpas,2022 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2023 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,2030 :: 		end  else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID344
L_USB_MSD_Library_TokenSetupPID343:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID344:
;USB_MSD_Library.mpas,2033 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID323
L_USB_MSD_Library_TokenSetupPID341:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID323:
;USB_MSD_Library.mpas,2036 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID319
L_USB_MSD_Library_TokenSetupPID322:
;USB_MSD_Library.mpas,2038 :: 		USB_STD_HOST_TO_INTERFACE: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID350
;USB_MSD_Library.mpas,2041 :: 		USB_CLEAR_FEATURE:      // ClearInterfaceFeature;
	MOVF        _SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID354
;USB_MSD_Library.mpas,2046 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2047 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,2048 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID351
L_USB_MSD_Library_TokenSetupPID354:
;USB_MSD_Library.mpas,2050 :: 		USB_SET_FEATURE:        // SetInterfaceFeature
	MOVF        _SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID357
;USB_MSD_Library.mpas,2055 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2056 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,2057 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID351
L_USB_MSD_Library_TokenSetupPID357:
;USB_MSD_Library.mpas,2059 :: 		USB_SET_INTERFACE:      // SetInterface;
	MOVF        _SetUpPacket+1, 0 
	XORLW       11
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID360
;USB_MSD_Library.mpas,2061 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE then
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID362
;USB_MSD_Library.mpas,2063 :: 		UsbInterface := SetupPacket.wIndex;
	MOVF        _SetUpPacket+4, 0 
	MOVWF       _UsbInterface+0 
;USB_MSD_Library.mpas,2064 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2065 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,2066 :: 		end else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID363
L_USB_MSD_Library_TokenSetupPID362:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID363:
;USB_MSD_Library.mpas,2069 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID351
L_USB_MSD_Library_TokenSetupPID360:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID351:
;USB_MSD_Library.mpas,2072 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID319
L_USB_MSD_Library_TokenSetupPID350:
;USB_MSD_Library.mpas,2074 :: 		USB_STD_HOST_TO_ENDPOINT: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID366
;USB_MSD_Library.mpas,2076 :: 		Ep := SetUpPacket.wIndex and $8F;  // endpoint number
	MOVLW       143
	ANDWF       _SetUpPacket+4, 0 
	MOVWF       TokenSetupPID_Ep+0 
;USB_MSD_Library.mpas,2080 :: 		USB_CLEAR_FEATURE:      // ClearEndpointFeature;
	MOVF        _SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID370
;USB_MSD_Library.mpas,2083 :: 		USB_EP04_OUT : BDEP4OUTStat := (USB_USIE or USB_DAT0 or USB_DTSEN);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID374
	MOVLW       136
	MOVWF       1056 
	GOTO        L_USB_MSD_Library_TokenSetupPID371
L_USB_MSD_Library_TokenSetupPID374:
;USB_MSD_Library.mpas,2084 :: 		USB_EP04_IN  : BDEP4INStat  := (USB_UCPU or USB_DAT1)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       132
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID377
	MOVLW       64
	MOVWF       1060 
;USB_MSD_Library.mpas,2085 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID371
L_USB_MSD_Library_TokenSetupPID377:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID371:
;USB_MSD_Library.mpas,2087 :: 		if not EP0Stalled then
	CALL        USB_MSD_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID379
;USB_MSD_Library.mpas,2089 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2090 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,2091 :: 		end;
L_USB_MSD_Library_TokenSetupPID379:
;USB_MSD_Library.mpas,2095 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID367
L_USB_MSD_Library_TokenSetupPID370:
;USB_MSD_Library.mpas,2097 :: 		USB_SET_FEATURE:        // SetEndpointFeature
	MOVF        _SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID383
;USB_MSD_Library.mpas,2100 :: 		USB_EP04_OUT : BDEP4OUTStat := (USB_USIE or USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID387
	MOVLW       132
	MOVWF       1056 
	GOTO        L_USB_MSD_Library_TokenSetupPID384
L_USB_MSD_Library_TokenSetupPID387:
;USB_MSD_Library.mpas,2101 :: 		USB_EP04_IN  : BDEP4INStat  := (USB_USIE or USB_BSTALL)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       132
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID390
	MOVLW       132
	MOVWF       1060 
;USB_MSD_Library.mpas,2102 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID384
L_USB_MSD_Library_TokenSetupPID390:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID384:
;USB_MSD_Library.mpas,2104 :: 		if not EP0Stalled then
	CALL        USB_MSD_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID392
;USB_MSD_Library.mpas,2106 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2107 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,2108 :: 		end;
L_USB_MSD_Library_TokenSetupPID392:
;USB_MSD_Library.mpas,2114 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID367
L_USB_MSD_Library_TokenSetupPID383:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID367:
;USB_MSD_Library.mpas,2117 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID319
L_USB_MSD_Library_TokenSetupPID366:
;USB_MSD_Library.mpas,2119 :: 		USB_STD_DEVICE_TO_HOST: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID396
;USB_MSD_Library.mpas,2122 :: 		USB_GET_CONFIGURATION:  //
	MOVF        _SetUpPacket+1, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID400
;USB_MSD_Library.mpas,2124 :: 		BuffEP0IN[0] := 0;
	CLRF        1344 
;USB_MSD_Library.mpas,2125 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID402
;USB_MSD_Library.mpas,2126 :: 		then BuffEP0IN[0] := UsbCurrentConfig;
	MOVF        _UsbCurrentConfig+0, 0 
	MOVWF       1344 
L_USB_MSD_Library_TokenSetupPID402:
;USB_MSD_Library.mpas,2127 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2128 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_MSD_Library.mpas,2129 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,2130 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID397
L_USB_MSD_Library_TokenSetupPID400:
;USB_MSD_Library.mpas,2132 :: 		USB_GET_DESCRIPTOR:     GetDescriptor;
	MOVF        _SetUpPacket+1, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID406
	CALL        USB_MSD_Library_GetDescriptor+0, 0
	GOTO        L_USB_MSD_Library_TokenSetupPID397
L_USB_MSD_Library_TokenSetupPID406:
;USB_MSD_Library.mpas,2134 :: 		USB_GET_STATUS:         //
	MOVF        _SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID409
;USB_MSD_Library.mpas,2136 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2137 :: 		BuffEP0IN[0] := Usb_Status_Device;
	MOVF        _Usb_Status_Device+0, 0 
	MOVWF       1344 
;USB_MSD_Library.mpas,2138 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_MSD_Library.mpas,2139 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_MSD_Library.mpas,2140 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,2143 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID397
L_USB_MSD_Library_TokenSetupPID409:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID397:
;USB_MSD_Library.mpas,2146 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID319
L_USB_MSD_Library_TokenSetupPID396:
;USB_MSD_Library.mpas,2148 :: 		USB_STD_INTERFACE_TO_HOST: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       129
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID412
;USB_MSD_Library.mpas,2151 :: 		USB_GET_INTERFACE:      //
	MOVF        _SetUpPacket+1, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID416
;USB_MSD_Library.mpas,2154 :: 		if UsbDeviceEnumState <> USB_ADDRESS_STATE then
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID418
;USB_MSD_Library.mpas,2156 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2157 :: 		BuffEP0IN[0] := UsbInterface;
	MOVF        _UsbInterface+0, 0 
	MOVWF       1344 
;USB_MSD_Library.mpas,2158 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_MSD_Library.mpas,2159 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,2160 :: 		end else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID419
L_USB_MSD_Library_TokenSetupPID418:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID419:
;USB_MSD_Library.mpas,2161 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID413
L_USB_MSD_Library_TokenSetupPID416:
;USB_MSD_Library.mpas,2163 :: 		USB_GET_STATUS:         //
	MOVF        _SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID422
;USB_MSD_Library.mpas,2165 :: 		if UsbDeviceEnumState <> USB_ADDRESS_STATE then
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID424
;USB_MSD_Library.mpas,2167 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2168 :: 		BuffEP0IN[0] := 0;
	CLRF        1344 
;USB_MSD_Library.mpas,2169 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_MSD_Library.mpas,2170 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_MSD_Library.mpas,2171 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: go
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,2172 :: 		end else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID425
L_USB_MSD_Library_TokenSetupPID424:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID425:
;USB_MSD_Library.mpas,2173 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID413
L_USB_MSD_Library_TokenSetupPID422:
;USB_MSD_Library.mpas,2175 :: 		USB_GET_DESCRIPTOR:     GetDescriptor
	MOVF        _SetUpPacket+1, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID428
	CALL        USB_MSD_Library_GetDescriptor+0, 0
;USB_MSD_Library.mpas,2177 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID413
L_USB_MSD_Library_TokenSetupPID428:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID413:
;USB_MSD_Library.mpas,2180 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID319
L_USB_MSD_Library_TokenSetupPID412:
;USB_MSD_Library.mpas,2182 :: 		USB_STD_ENDPOINT_TO_HOST: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       130
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID431
;USB_MSD_Library.mpas,2184 :: 		Ep := SetUpPacket.wIndex and $8F;  // endpoint number
	MOVLW       143
	ANDWF       _SetUpPacket+4, 0 
	MOVWF       TokenSetupPID_Ep+0 
;USB_MSD_Library.mpas,2188 :: 		USB_GET_STATUS:         //
	MOVF        _SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID435
;USB_MSD_Library.mpas,2192 :: 		USB_EP00_OUT : BuffEP0IN[0] := bit_(BDEP0OUTStat and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID439
	MOVLW       4
	ANDWF       1024, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
	GOTO        L_USB_MSD_Library_TokenSetupPID436
L_USB_MSD_Library_TokenSetupPID439:
;USB_MSD_Library.mpas,2193 :: 		USB_EP00_IN  : BuffEP0IN[0] := bit_(BDEP0INStat  and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID442
	MOVLW       4
	ANDWF       1028, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
	GOTO        L_USB_MSD_Library_TokenSetupPID436
L_USB_MSD_Library_TokenSetupPID442:
;USB_MSD_Library.mpas,2194 :: 		USB_EP04_OUT : BuffEP0IN[0] := bit_(BDEP4OUTStat and USB_BSTALL);
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID445
	MOVLW       4
	ANDWF       1056, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
	GOTO        L_USB_MSD_Library_TokenSetupPID436
L_USB_MSD_Library_TokenSetupPID445:
;USB_MSD_Library.mpas,2195 :: 		USB_EP04_IN  : BuffEP0IN[0] := bit_(BDEP4INStat  and USB_BSTALL)
	MOVF        TokenSetupPID_Ep+0, 0 
	XORLW       132
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID448
	MOVLW       4
	ANDWF       1060, 0 
	MOVWF       FARG_Bit__B+0 
	CALL        _Bit_+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
;USB_MSD_Library.mpas,2196 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID436
L_USB_MSD_Library_TokenSetupPID448:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID436:
;USB_MSD_Library.mpas,2198 :: 		if not EP0Stalled then
	CALL        USB_MSD_Library_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID450
;USB_MSD_Library.mpas,2200 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2201 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_MSD_Library.mpas,2202 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_MSD_Library.mpas,2203 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: go
	MOVLW       200
	MOVWF       1028 
;USB_MSD_Library.mpas,2204 :: 		end;
L_USB_MSD_Library_TokenSetupPID450:
;USB_MSD_Library.mpas,2205 :: 		end;
	GOTO        L_USB_MSD_Library_TokenSetupPID432
L_USB_MSD_Library_TokenSetupPID435:
;USB_MSD_Library.mpas,2207 :: 		USB_SYNCH_FRAME: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID454
;USB_MSD_Library.mpas,2212 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        USB_MSD_Library_EP0OutReset+0, 0
;USB_MSD_Library.mpas,2213 :: 		SendAckToHost; // send acknowledge
	CALL        USB_MSD_Library_SendAckToHost+0, 0
;USB_MSD_Library.mpas,2216 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID432
L_USB_MSD_Library_TokenSetupPID454:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID432:
;USB_MSD_Library.mpas,2221 :: 		else
	GOTO        L_USB_MSD_Library_TokenSetupPID319
L_USB_MSD_Library_TokenSetupPID431:
;USB_MSD_Library.mpas,2223 :: 		case (SetUpPacket.bmRequestType shr 5)and 3 of
	MOVLW       5
	MOVWF       R1 
	MOVF        _SetUpPacket+0, 0 
	MOVWF       R0 
	MOVF        R1, 0 
L_USB_MSD_Library_TokenSetupPID559:
	BZ          L_USB_MSD_Library_TokenSetupPID560
	RRCF        R0, 1 
	BCF         R0, 7 
	ADDLW       255
	GOTO        L_USB_MSD_Library_TokenSetupPID559
L_USB_MSD_Library_TokenSetupPID560:
	MOVLW       3
	ANDWF       R0, 0 
	MOVWF       FLOC_USB_MSD_Library_TokenSetupPID+0 
;USB_MSD_Library.mpas,2229 :: 		USB_CLASS :  ClassSpecificRequest;      // Class specific request (interface)
	MOVF        FLOC_USB_MSD_Library_TokenSetupPID+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID458
	CALL        USB_MSD_Library_ClassSpecificRequest+0, 0
	GOTO        L_USB_MSD_Library_TokenSetupPID455
L_USB_MSD_Library_TokenSetupPID458:
;USB_MSD_Library.mpas,2230 :: 		USB_VENDOR:  CheckforVendorRequest
	MOVF        FLOC_USB_MSD_Library_TokenSetupPID+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_TokenSetupPID461
	CALL        USB_MSD_Library_CheckForVendorRequest+0, 0
;USB_MSD_Library.mpas,2231 :: 		else StallEP0;
	GOTO        L_USB_MSD_Library_TokenSetupPID455
L_USB_MSD_Library_TokenSetupPID461:
	CALL        USB_MSD_Library_StallEP0+0, 0
L_USB_MSD_Library_TokenSetupPID455:
;USB_MSD_Library.mpas,2233 :: 		end;
L_USB_MSD_Library_TokenSetupPID319:
;USB_MSD_Library.mpas,2235 :: 		end;
L_end_TokenSetupPID:
	RETURN      0
; end of USB_MSD_Library_TokenSetupPID

_USB_Interrupt:

;USB_MSD_Library.mpas,2239 :: 		begin
;USB_MSD_Library.mpas,2241 :: 		if PIR2.USBIF = 1 then // usb interrupt occurred
	BTFSS       PIR2+0, 5 
	GOTO        L__USB_Interrupt464
;USB_MSD_Library.mpas,2243 :: 		PIR2.USBIF := 0;
	BCF         PIR2+0, 5 
;USB_MSD_Library.mpas,2245 :: 		Tmp := UIR and UIE; // get the enabled interrupts
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_MSD_Library.mpas,2247 :: 		while Tmp > 0 do    // some interrupts have occured
L__USB_Interrupt467:
	MOVF        USB_Interrupt_Tmp+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_Interrupt468
;USB_MSD_Library.mpas,2249 :: 		while Tmp.TRNIF = 1 do
L__USB_Interrupt472:
	BTFSS       USB_Interrupt_Tmp+0, 3 
	GOTO        L__USB_Interrupt473
;USB_MSD_Library.mpas,2252 :: 		USTATCopy := USTAT; // get copy of the status register
	MOVF        USTAT+0, 0 
	MOVWF       _USTATCopy+0 
;USB_MSD_Library.mpas,2254 :: 		BufferDescriptor := ^TBufferDescriptor(@BDEP0OUTStat) + ((USTATCopy shr 2) and $1F); // create pointer to BufferDescriptor of EPx
	MOVF        _USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       31
	ANDWF       R0, 0 
	MOVWF       R3 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _BDEP0OUTStat+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_BDEP0OUTStat+0)
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _BufferDescriptor+0 
	MOVF        R1, 0 
	MOVWF       _BufferDescriptor+1 
;USB_MSD_Library.mpas,2256 :: 		UIR.TRNIF := 0;     // clear the interrupt flag (advances fifo: enable further activity)
	BCF         UIR+0, 3 
;USB_MSD_Library.mpas,2258 :: 		if BufferDescriptor^.Status.UOWN = 0 then
	MOVF        R0, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0L
	MOVFF       R3, FSR0H
	BTFSC       POSTINC0+0, 7 
	GOTO        L__USB_Interrupt477
;USB_MSD_Library.mpas,2260 :: 		Pid := (BufferDescriptor^.Status shr 2) and $0F; // get the PID out of the endpoint buffer status
	MOVFF       _BufferDescriptor+0, FSR0L
	MOVFF       _BufferDescriptor+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       USB_Interrupt_Pid+0 
;USB_MSD_Library.mpas,2262 :: 		USB_TOKEN_IN:     TokenInPid;
	MOVF        R1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt482
	CALL        USB_MSD_Library_TokenInPID+0, 0
	GOTO        L__USB_Interrupt479
L__USB_Interrupt482:
;USB_MSD_Library.mpas,2263 :: 		USB_TOKEN_OUT:    TokenOutPid;
	MOVF        USB_Interrupt_Pid+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt485
	CALL        USB_MSD_Library_TokenOutPID+0, 0
	GOTO        L__USB_Interrupt479
L__USB_Interrupt485:
;USB_MSD_Library.mpas,2264 :: 		USB_TOKEN_SETUP:  TokenSetupPID
	MOVF        USB_Interrupt_Pid+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt488
	CALL        USB_MSD_Library_TokenSetupPID+0, 0
;USB_MSD_Library.mpas,2265 :: 		else StallEP0;
	GOTO        L__USB_Interrupt479
L__USB_Interrupt488:
	CALL        USB_MSD_Library_StallEP0+0, 0
L__USB_Interrupt479:
;USB_MSD_Library.mpas,2267 :: 		end;
L__USB_Interrupt477:
;USB_MSD_Library.mpas,2268 :: 		Tmp := UIR and UIE;
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_MSD_Library.mpas,2269 :: 		end;
	GOTO        L__USB_Interrupt472
L__USB_Interrupt473:
;USB_MSD_Library.mpas,2271 :: 		if Tmp.URSTIF  = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 0 
	GOTO        L__USB_Interrupt490
;USB_MSD_Library.mpas,2276 :: 		UsbReset;
	CALL        USB_MSD_Library_UsbReset+0, 0
;USB_MSD_Library.mpas,2277 :: 		end;
L__USB_Interrupt490:
;USB_MSD_Library.mpas,2279 :: 		if Tmp.STALLIF = 1 then UIR.STALLIF := 0; // clear interrupt flag
	BTFSS       USB_Interrupt_Tmp+0, 5 
	GOTO        L__USB_Interrupt493
	BCF         UIR+0, 5 
L__USB_Interrupt493:
;USB_MSD_Library.mpas,2281 :: 		if Tmp.IDLEIF  = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 4 
	GOTO        L__USB_Interrupt496
;USB_MSD_Library.mpas,2283 :: 		IsIdle := true;
	MOVLW       255
	MOVWF       _IsIdle+0 
;USB_MSD_Library.mpas,2284 :: 		UIE.IDLEIE := 0; // disable the idle interrupt
	BCF         UIE+0, 4 
;USB_MSD_Library.mpas,2285 :: 		UIR.SOFIF  := 0;
	BCF         UIR+0, 6 
;USB_MSD_Library.mpas,2286 :: 		UIE.SOFIE :=  1; // enable the SOF interrupt
	BSF         UIE+0, 6 
;USB_MSD_Library.mpas,2287 :: 		UIR.IDLEIF := 0; // clear interrupt flag
	BCF         UIR+0, 4 
;USB_MSD_Library.mpas,2288 :: 		end;
L__USB_Interrupt496:
;USB_MSD_Library.mpas,2290 :: 		if Tmp.SOFIF = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 6 
	GOTO        L__USB_Interrupt499
;USB_MSD_Library.mpas,2292 :: 		IsIdle     := false; // clear the "is Idle" bit 0
	CLRF        _IsIdle+0 
;USB_MSD_Library.mpas,2293 :: 		UIE.SOFIE  := 0;     // disable the SOF interrupt
	BCF         UIE+0, 6 
;USB_MSD_Library.mpas,2294 :: 		UIR.IDLEIF := 0;
	BCF         UIR+0, 4 
;USB_MSD_Library.mpas,2295 :: 		UIE.IDLEIE := 1;     // enable the idle interrupt
	BSF         UIE+0, 4 
;USB_MSD_Library.mpas,2296 :: 		UIR.SOFIF  := 0;     // clear interrupt flag
	BCF         UIR+0, 6 
;USB_MSD_Library.mpas,2297 :: 		end;
L__USB_Interrupt499:
;USB_MSD_Library.mpas,2299 :: 		Tmp := UIR and UIE; // get the enabled interrupts
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_MSD_Library.mpas,2300 :: 		end;
	GOTO        L__USB_Interrupt467
L__USB_Interrupt468:
;USB_MSD_Library.mpas,2302 :: 		end;
L__USB_Interrupt464:
;USB_MSD_Library.mpas,2304 :: 		end;
L_end_USB_Interrupt:
	RETURN      0
; end of _USB_Interrupt
